2023-07-29  Eli Zaretskii  <eliz@maintain0p.gnu.org>

	* Version 29.1 released.

2023-07-23  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump Emacs version to 29.1.

2023-07-23  Eli Zaretskii  <eliz@gnu.org>

	Update AUTHORS and ChangeLog.4

	* ChangeLog.4:
	* etc/AUTHORS: Update for Emacs 29.1 release.

2023-07-22  Vincenzo Pupillo  <v.pupillo@gmail.com>

	Update JSX support due to upstream changes (bug#64647)

	A recent change in tree-sitter-javascript grammar support for
	JSX (commit bb1f97b), changed two things:
	1. renamed nested_identifier to member_expression
	2. removed jsx_fragment, jsx_text is used instead

	* lisp/progmodes/js.el (js-jsx--treesit-indent-compatibility-bb1f97b):
	Indent helper function to handle different tree-sitter-javascript
	version.
	* lisp/progmodes/js.el (js--treesit-indent-rules): Use the new
	function to handle both jsx_fragment and jsx_text.
	* lisp/progmodes/js.el (js-jsx--treesit-font-lock-compatibility-bb1f97b):
	Font lock helper function for handle different tree-sitter-javascript
	version.
	* lisp/progmodes/js.el (js--treesit-font-lock-settings): Use the new
	function to handle both nested_identifier and member_expression.

2023-07-22  Vincenzo Pupillo  <v.pupillo@gmail.com>

	Update TSX support due to upstream changes (bug#64647)

	A recent change in tree-sitter-typescript grammar support for
	TSX (commit b893426), changed two things:
	1. renamed nested_identifier to member_expression
	2. removed jsx_fragment, jsx_text is used instead

	* lisp/progmodes/typescript-ts-mode.el
	(tsx-ts-mode--indent-compatibility-b893426): Indent helper function
	to handle different tree-sitter-typescript version.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): use the new function to handle
	both jsx_fragment and jsx_text.
	* lisp/progmodes/typescript-ts-mode.el
	(tsx-ts-mode--font-lock-compatibility-bb1f97b): Font lock helper
	function for handle different tree-sitter-typescript version.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Use the new function to
	handle both nested_identifier and member_expression.

2023-07-21  Philipp Stephani  <phst@google.com>

	Unbreak build with CHECK_STRUCTS.

	The hash for the Lisp_Overlay structure has changed due to the (comment-only)
	commit 7ac947f34c745c61f8acc1fe2452a2c720d57a0d.

	* src/pdumper.c (dump_overlay): Update struct hash.

2023-07-21  Mattias Engdegård  <mattiase@acm.org>

	Revert "Improve commentary in nsfns.m"

	This reverts commit 3af27a4b815906c2ee38cbaf3a765289b3df061a,
	because it missed the point completely.
	Please talk to the original author next time.

2023-07-20  Eli Zaretskii  <eliz@gnu.org>

	Fix NetBSD build --with-sound

	* src/sound.c (alsa_write): Use ESTRPIPE only if defined.
	(Bug#64698)

2023-07-20  Mauro Aranda  <maurooaranda@gmail.com>

	Fix typo in pre-filter for underline property

	* lisp/cus-face.el (custom-face-attributes): Fix typo (Bug#64347)

2023-07-20  Po Lu  <luangruo@yahoo.com>

	Improve commentary in nsfns.m

	* src/nsfns.m (lispString): Avoid C++ comment and make the
	commentary actually relevant to the reason `make_string' is
	used.

2023-07-20  Po Lu  <luangruo@yahoo.com>

	Fix typos and ommissions in cus-edit.el

	* lisp/cus-edit.el (custom-display): Add missing display types.

2023-07-18  Mattias Engdegård  <mattiase@acm.org>

	Convert NUL-containing NSString objects to Lisp strings correctly

	This cures the inability to paste text containing NUL from other
	applications on macOS, introduced by mistake in 7e3c2b553f
	(bug#64697).

	* src/nsfns.m ([NSString lispString]): Use make_string instead of
	build_string which relies on NUL-termination.

2023-07-15  Spencer Baugh  <sbaugh@catern.com>

	Ignore quit while getting interprogram paste in kill-new

	On X, if the current selection owner is not responding to selection
	requests, the user may want to take ownership of the selection.  The
	obvious way to do this is to kill some text (which a user might also
	be doing just as part of normal editing at the time the selection
	owner becomes nonresponsive).  However, if
	save-interprogram-paste-before-kill is non-nil, then killing text will
	hang until the user quits, and this quit will abort the entire
	kill-new, preventing the user from taking ownership of the selection.

	Now instead if the user quits while we are attempting to retrieve the
	selection from hanging owner, we will proceed to take ownership of the
	selection as normal, resolving the problem.

	(One example of a selction owner that might not be responding to
	selection requests is another instance of Emacs itself; while Emacs is
	blocked in call-process or Lisp execution, it currently does not
	respond to selection requests.)

	* lisp/simple.el (kill-new): Ignore quit while getting interprogram
	paste (bug#64423)

2023-07-15  Wang Diancheng  <dianchengwang@gmail.com>  (tiny change)

	* lisp/progmodes/gdb-mi.el: Fix interactive invocation of 'gud-go'.

	Bug#64590.

2023-07-15  Valtteri Vuorikoski  <vuori@notcom.org>  (tiny change)

	Fix NetBSD build with and without ncurses

	* configure.ac (netbsd): Don't set TERMINFO=no unless the termcap
	library is either -ltermcap or -lcurses.  This prevents aborts
	because on recent versions of NetBSD libtermcap is actually a
	symlink to libterminfo. (Bug#64577)

2023-07-14  YugaEgo  <yet@ego.team>

	Improve documentation of 'enable-local-variables' in Emacs manual

	* doc/emacs/custom.texi (Safe File Variables): Document ':all'.
	(Bug#64621)

2023-07-13  Jim Porter  <jporterbugs@gmail.com>

	Add documentation about remote access in Eshell

	Do not merge to master.  This is a backport of 438921161ac.

	* doc/misc/eshell.texi
	(Invocation): Mention the '*' prefix.
	(Remote Access): New section...
	(Commands): ... link to it.

2023-07-13  Jim Porter  <jporterbugs@gmail.com>

	Document some missing Eshell commands

	Do not merge to master.  This is a backport of f7a899d7ca0.

	* doc/misc/eshell.texi (Built-ins): Document 'eshell-debug'.
	(Extra built-in commands): Document 'count', 'ff', and 'gf'.

2023-07-13  Jim Porter  <jporterbugs@gmail.com>

	Document optional Eshell modules

	Do not merge to master.  This is a backport of 77f13edab0f.

	* doc/misc/eshell.texi (Built-ins): Move disabled-by-default commands
	to...
	(Tramp extensions, Extra built-in commands): ...here
	(Optional modules, Key rebinding, Smart scrolling): Add documentation.
	(Bug and ideas): Documentation is no longer incomplete!

2023-07-13  Jim Porter  <jporterbugs@gmail.com>

	Correct the Eshell documentation about how to write new modules

	* doc/misc/eshell.texi (Writing a module): Fix the documentation.
	'eshell-defgroup' doesn't exist anymore.

	Do not merge to master.  This is a backport of 77f13edab0f.

2023-07-13  Jim Porter  <jporterbugs@gmail.com>

	Restructure Eshell extension modules documentation

	This adds a section for documenting all the optional modules.

	Do not merge to master.  This is a backport of f2981a1681d.

	* doc/misc/eshell.texi (Extension modules): Move explanation about
	writing modules to...
	(Writing a module): ... here.
	(Module testing): Remove.  Testing an Eshell module doesn't require
	any special documentation.
	(Key binding, Smart scrolling, Electric forward slash): Move under...
	(Optional modules): ... here.
	(Directory handling, Terminal emulation): Remove.  These modules are
	enabled by default, and so are documented above.
	(Tramp extensions, Extra built-in commands): New sections.

2023-07-13  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Replace duplicate text from epa.texi by a reference

	* doc/misc/auth.texi (GnuPG and EasyPG Assistant Configuration):
	Replace duplicate text from epa.texi by a reference to
	that. (Bug#64154)

2023-07-13  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Add basic usage information and fix references

	* doc/misc/epa.texi (Top): Add menu entry for new node GnuPG Pinentry.
	(Quick Start): Add information on and reference to basic GnuPG
	configuration.
	(Encrypting/decrypting gpg files): Add usage information.
	(GnuPG version compatibility): Update version information.
	(GnuPG Pinentry): Add new node.
	(Caching Passphrases): Describe mandatory gpg-agent usage for GnuPG
	2.0 and later.
	(Overview, Encrypting/decrypting gpg files, GnuPG version compatibility)
	(Caching Passphrases, Bug Reports): Fix references, terminology,
	mark-up, and index entries.  (Bug#64154)

2023-07-13  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Add concept index, title-case structure titles

	* doc/misc/epa.texi (Top, Overview, Commands, Key management)
	(Cryptographic operations on regions, Cryptographic operations on files)
	(Dired integration, Mail-mode integration)
	(Encrypting/decrypting gpg files, Querying a key server)
	(GnuPG version compatibility, Caching Passphrases)
	(GNU Free Documentation License): Add concept index, title-case
	structure titles.  (Bug#64154)

2023-07-10  Eli Zaretskii  <eliz@gnu.org>

	Fix show-paren-mode when the parentheses is partially visible

	* lisp/paren.el (show-paren-function): Support the case where the
	open paren is partially visible, but enough so to not consider it
	"off-screen".  (Bug#64547)

2023-07-08  Gregory Heytings  <gregory@heytings.org>

	Merge branch 'scratch/bug64391' into emacs-29

2023-07-08  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-get-buffer-string): Stabilize.

2023-07-08  Michael Albinus  <michael.albinus@gmx.de>

	Fix stale cache in Tramp (don't merge)

	* lisp/net/tramp-sh.el (tramp-do-copy-or-rename-file-directly):
	Flush cache in time.

2023-07-07  Mattias Engdegård  <mattiase@acm.org>

	Mark failing icalendar test as unstable (bug#56241)

	* test/lisp/calendar/icalendar-tests.el
	(icalendar-export-bug-56241-dotted-pair):
	This test started failing early July 2023 in multiple branches at
	once without any change to the code and is likely sensitive to the
	current date.  Tag it to keep it quiet for now.

2023-07-06  Gregory Heytings  <gregory@heytings.org>

	Simplify after adding internal function to enter a labeled restriction

	* src/editfns.c: (Finternal__labeled_narrow_to_region): Merge the
	code of Finternal__label_restriction into this function.
	(Finternal__label_restriction): Remove this function.
	(syms_of_editfns): Remove the 'outermost-restriction' buffer local
	variable, which is not used anymore, and the symbol of
	'internal--label-restriction'.
	(Fwiden): Remove the call to reset the 'outermost-restriction'
	buffer local variable.

2023-07-06  Gregory Heytings  <gregory@heytings.org>

	Add internal function to enter a labeled restriction

	* src/editfns.c (Finternal__labeled_narrow_to_region): New
	function.  A specific function is necessary to avoid unnecessary
	slowdowns when 'narrow-to-region'/'widen' are called in a loop.
	(Fnarrow_to_region): Remove the call to Fset, which has been moved
	into Finternal__labeled_narrow_to_region.
	(labeled_narrow_to_region): Use the new function.
	(syms_of_editfns): Add the symbol of the new function.

	* lisp/subr.el (internal--with-restriction): Use the new function.

2023-07-04  Robert Pluim  <rpluim@gmail.com>

	Improve natnump shortdoc

	* lisp/emacs-lisp/shortdoc.el (number): Make it clear that zero
	satisfies 'natnump'.  Move 'natnump' next to 'cl-plusp' to highlight
	the difference between them.

2023-07-04  Robert Pluim  <rpluim@gmail.com>

	correct info documentation of benchmark-call

	* doc/lispref/debugging.texi (Profiling): 'benchmark-call' is a defun,
	not a macro.

2023-07-03  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/grep.el (rgrep): Fix docstring.

	Instead of the incorrect key `M-c' produce the right key
	with \\<read-regexp-map>\\[read-regexp-toggle-case-fold].

2023-07-03  Spencer Baugh  <sbaugh@catern.com>

	Include a help-echo for flymake's modeline counters

	This helps clarify what each of these numbers mean.  This is inspired
	by 'compilation-mode-line-errors' which does the same.
	* lisp/progmodes/flymake.el (flymake--mode-line-counter): Add
	help-echo to mode line properties.  (Bug#64424)

2023-07-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in completion due to 'completion-regexp-list'

	* doc/lispref/minibuf.texi (Basic Completion):
	* src/minibuf.c (syms_of_minibuf) <completion-regexp-list>:
	Document that global non-nil settings of 'completion-regexp-list'
	are not safe.

	* lisp/minibuffer.el (completion-pcm--merge-completions): Avoid
	errors in 'try-completion' when PREFIX is nil.  (Bug#64351)

2023-07-01  Alan Mackenzie  <acm@muc.de>

	C Mode: Don't fontify foo globally as type due to "struct foo"

	This fixes bug#64322.

	* lisp/progmodes/cc-langs.el (c-typeless-decl-kwds): Make the
	entry for c-mode nil.

2023-07-01  Mattias Engdegård  <mattiase@acm.org>

	* lisp/rect.el (rectangle--duplicate-right): Fix rectangle dup bug.

	This is a necessary adjustment to changes to rect.el in Emacs 29.

2023-07-01  Spencer Baugh  <sbaugh@janestreet.com>

	Add project command entries to the menu-bar

	This will make it easier for new users to learn these increasingly
	important and useful commands.  (Bug#63469)

	* lisp/menu-bar.el (menu-bar-file-menu): Add project-dired and
	project-find-file entries.
	(menu-bar-search-menu): Add project-find-regexp entry.
	(menu-bar-replace-menu): Add project-query-replace regexp entry.
	(menu-bar-shell-commands-menu): Add project-shell entry.
	(menu-bar-buffers-menu-command-entries): Add project-switch-to-buffer
	and project-list-buffer entries.
	(menu-bar-project-menu): Add.
	(menu-bar-tools-menu): Add "Project" submenu, and also project-compile
	entry and change text for compile entry.

2023-06-30  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of registers

	* doc/lispref/text.texi (Registers): Document buffers in
	registers.  Mention "frameset" as another name for "frame
	configuration".
	* doc/emacs/regs.texi (Registers, Configuration Registers)
	(File and Buffer Registers): Clarify and improve wording.  Add
	cross-references and indexing.
	(Configuration Registers): Rename the section to a more accurate
	name.  (Bug#64354)

	* lisp/register.el (jump-to-register, point-to-register)
	(register-alist, frame-configuration-to-register): Doc fixes.
	(Bug#64353)

2023-06-29  Andrew G Cohen  <cohen@andy.bu.edu>

	Use a temporary buffer in nnagent-request-set-mark (bug#64117)

	Commit cb12a84f2c519a48dd87453c925e3bc36d9944db inadvertently removed
	the use of a temporary buffer in nnagent-request-set-mark.  Bug and
	fix reported by Jens Schmidt <jschmidt4gnu@vodafonemail.de>

	* lisp/gnus/nnagent.el (nnagent-request-set-mark): Restore the use of
	a temporary buffer that was inadvertently removed.

	(cherry picked from commit 5075d752773c31d959272a7e2b73b1dc38ba184c)

2023-06-29  john muhl  <jm@pub.pink>  (tiny change)

	Support cons cell as value of ':line-width' box attribute

	* lisp/calculator.el (calculator-need-3-lines): Support
	values of a face's ':line-width' box attribute that are
	cons cells.  (Bug#64344)

2023-06-29  Yuan Fu  <casouri@gmail.com>

	Add missing calls to treesit_record_change in editfns.c

	These should be all that are missing.  See the next commit for detail.

	* src/editfns.c (Ftranslate_region_internal):
	(Ftranspose_regions): Call treesit_record_change.

2023-06-29  Yuan Fu  <casouri@gmail.com>

	Call treesit_record_change in subst-char-in-region (bug#64329)

	* src/editfns.c (Fsubst_char_in_region): Call treesit_record_change in
	the else branch.

2023-06-29  Juri Linkov  <juri@linkov.net>

	* lisp/misc.el (duplicate-line-final-position): New defcustom (bug#64185).

	* lisp/misc.el (duplicate-line): Use it.

	* test/lisp/misc-tests.el (misc--duplicate-line): Add tests for
	duplicate-line-final-position.

	Don't merge to master.

2023-06-29  Daniel Martín  <mardani29@yahoo.es>

	Make js-beginning-of-defun return non-nil on success

	The docstring of 'beginning-of-defun-function' says that the
	function shall return non-nil when it found the beginning
	of a defun.  This is specially important because the calling
	code decides when to move point depending on the return value.
	* lisp/progmodes/js.el (js-beginning-of-defun)
	(js--beginning-of-defun-flat): Return non-nil when the beginning
	of a defun is found.  (Bug#64283)

	* test/lisp/progmodes/js-tests.el (js-mode-end-of-defun): Add a unit
	test.

2023-06-27  Yuan Fu  <casouri@gmail.com>

	Tree-sitter use with-silent-modifications like jit-lock (bug#64321)

	* lisp/treesit.el (treesit--font-lock-notifier): Use
	with-silent-modifications when marking modified text to be fontified
	by jit-lock.  This is what jit-lock itself does.

2023-06-27  Stephen Berman  <stephen.berman@gmx.net>

	Fix todo-mode.el Commentary and a doc string (bug#64298)

	* lisp/calendar/todo-mode.el: Explicitly note in the Commentary
	that the Todo mode user manual is a separate Info manual in the
	Emacs installation.
	(todo-always-add-time-string): Replace doc string, which was
	mistakenly retained in the initial merge of this version of
	todo-mode.el, by a correct description of this user option.

2023-06-27  Stephen Berman  <stephen.berman@gmx.net>

	Prevent truncation of todo-mode categories sexp

	* lisp/calendar/todo-mode.el (todo-delete-file)
	(todo-move-category, todo-convert-legacy-files)
	(todo-update-categories-sexp, todo-check-format):
	Bind print-length and print-level to nil before using prin1
	and related functions, to avoid truncating the todo categories
	sexp and possibly corrupting the file format.

2023-06-27  Stephen Berman  <stephen.berman@gmx.net>

	Avoid making todo-mode buffers manually editable

	* lisp/calendar/todo-mode.el (todo-add-category)
	(todo-move-category, todo-edit-item--header)
	(todo-set-item-priority, todo-move-item, todo-item-undone)
	(todo-archive-done-item, todo-set-category-number): Restrict the
	scope of nil buffer-read-only to the function calls that change
	buffer text, thereby preventing todo mode buffers from becoming
	manually editable and hence possibly corrupted when the minibuffer
	is in use.

2023-06-26  Michael Albinus  <michael.albinus@gmx.de>

	Fix Tramp mount-spec (don't merge)

	* lisp/net/tramp-fuse.el (tramp-fuse-mounted-p): The mount-spec
	could contain an optional trailing slash.  (Bug#64278)

2023-06-25  Daniel Semyonov  <daniel@dsemy.com>

	Fix VC package build when doc file isn't in a subdir

	* lisp/emacs-lisp/package-vc.el (package-vc--build-documentation):
	Expand 'file' before attempting to get its directory.  (Bug#64242)

2023-06-25  Michael Albinus  <michael.albinus@gmx.de>

	Fix type check in tramp-get-buffer-string

	* lisp/net/tramp.el (tramp-get-buffer-string): Check, that BUFFER
	is really a bufferp.

2023-06-25  Richard M. Stallman  <rms@gnu.org>

	Clarify list terminology

	* doc/lispintro/emacs-lisp-intro.texi (Lists diagrammed):
	Mention "cons cell".  Add index entries.
	(car & cdr): Simplify etymology of `car' and `cdr'.
	Explain why for some purposes they are better than `first' and `rest'.
	Mention cons cells.

	(cherry picked from commit 188c90c7c111dbbdc3edd29c23b59ade26f97bfd)

2023-06-24  Mattias Engdegård  <mattiase@acm.org>

	* lisp/emacs-lisp/shortdoc.el: More and better `substring` examples.

	Suggested by Juri Linkov.

2023-06-24  Eli Zaretskii  <eliz@gnu.org>

	Fix "C-x RET r" when the new encoding is UTF

	* src/fileio.c (Finsert_file_contents): Update point of
	'conversion_buffer' before decoding the last block.  (Bug#64253)

2023-06-23  Dmitry Gutov  <dmitry@gutov.dev>

	Fix "vc-print-log does not erase buffer" and associated problems

	* lisp/vc/vc.el (vc-deduce-fileset): Make sure to retain the
	buffer switch (if it did), bug#63949.

2023-06-23  Theodor Thornhill  <theo@thornhill.no>

	Add selector_expression indentation rule

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--indent-rules): New rule.

2023-06-22  Eli Zaretskii  <eliz@gnu.org>

	Add "nixd" LSP server to Eglot

	* lisp/progmodes/eglot.el (eglot-server-programs): Add "nixd".
	Patch by Brian Leung <leungbk@posteo.net>.  (Bug#64214)

2023-06-22  Eli Zaretskii  <eliz@gnu.org>

	Fix building --with-native-compilation=aot from release tarball

	* lisp/Makefile.in (%.eln): Pattern rule for AOT native
	compilation.
	(compile-eln-targets, compile-eln-aot): New targets for AOT native
	compilation.

	* src/Makefile.in (../native-lisp): If NATIVE_COMPILATION_AOT is
	set, also native-compile all the other Lisp files.
	(Bug#64167)

2023-06-21  Alan Mackenzie  <acm@muc.de>

	Fix bug#64152 (Minibuffer sometimes goes "modal")

	In particular, when a frame has no minibuffer and is using that
	of a different "normal" frame, C-x 5 o, etc., and GUI
	operations fail.

	Fix by partially reverting the commit from 2022-07-07 15:38:09
	+0000 "Remove obscure, obsolete code from do_switch_frame".  As
	a consequent change, also revert the commit from 2022-07-08
	20:19:03 +0000 "Remove now unused parameter TRACK from
	do_switch_frame".

	* src/frame.c (do_switch_frame): Restore the TRACK parameter.
	Restore the code which redirects the frame focus when a new
	frame gets selected.

	* src/frame.c (Fselect_frame, Fhandle_switch_frame)
	(delete_frame)
	* src/keyboard.c (quit_throw_to_read_char)
	* src/lisp.h (do_switch_frame prototype)
	* src/minibuf.c (read_minibuf_unwind)
	* src/window.c (Fset_window_configuration): Restore the TRACK
	argument to do_switch_frame.

	* src/xterm.c (x_try_restore_frame): Add a zero TRACK argument
	to do_switch_frame.

2023-06-21  Eli Zaretskii  <eliz@gnu.org>

	Disable target-async by default in gdb-mi.el

	* lisp/progmodes/gdb-mi.el (gdb-non-stop-setting): Disable until
	bug#63084 is fixed.  (Bug#64186)

2023-06-20  Filipp Gunbin  <fgunbin@fastmail.fm>

	Revert "Fix parsing of dn line if WITHDN is non-nil"

	This reverts commits 71b27779a9a and d2246b26275, because they change
	the return value of "ldap-search" in an incompatible way.  The fix
	(a different one) will be done on master instead (bug#64089).

2023-06-20  Eli Zaretskii  <eliz@gnu.org>

	Don't truncate filenames with "emacs.el" in them

	* lisp/emacs-lisp/find-func.el (find-function-search-for-symbol):
	Avoid false positives when looking for "emacs.el" matches the
	likes of "emacs.elpa".  (Bug#64143)

2023-06-20  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'minibuffer-message'

	* doc/lispref/minibuf.texi (Minibuffer Misc): Clarify that
	'minibuffer-message' behaves like 'message' if called from a
	buffer that is not a minibuffer.

	* lisp/minibuffer.el (minibuffer-message)
	(set-minibuffer-message, clear-minibuffer-message): Doc fixes.
	(Bug#64165)

2023-06-19  João Távora  <joaotavora@gmail.com>

	Eglot: again fix positions of coinciding inlay hint overlays (bug#64101)

	This bug originated from the previous fix, and is reproducible on non
	Mac OS platforms, as long as the very latest version (at time of
	writing) of the rust-analyzer server is used.

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Reverse
	priorities when pegging overlays after (i.e. when before-string is
	used).

2023-06-18  Eli Zaretskii  <eliz@gnu.org>

	* lisp/ldefs-boot.el: Regenerate.

2023-06-18  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version to 29.0.92

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump version to 29.0.92.

2023-06-18  Mattias Engdegård  <mattiase@acm.org>

	Describe primarily the Emacs s-exp dialect for treesit queries

	* doc/lispref/parsing.texi (Pattern Matching, Multiple Languages):
	Writing tree-sitter queries as Emacs s-expressions is much more
	convenient than using the native query notation inside a string,
	so it makes sense to base the documentation on the former dialect
	(bug#64017).

2023-06-18  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of :predicate in 'define-globalized-minor-mode'

	* doc/lispref/modes.texi (Defining Minor Modes):
	* lisp/emacs-lisp/easy-mmode.el (define-globalized-minor-mode):
	Document that :predicate creates a customizable user option.
	(Bug#64048)

2023-06-17  Basil L. Contovounesios  <contovob@tcd.ie>

	Revert "Fix some tree-sitter :match regexps"

	This reverts commit 95091b77f0bbb2ae1aa94ef4a413626e7d434d58
	of 2023-06-17, mistakenly pushed to emacs-29.

	The patch will be installed on master instead, and backported later,
	after Emacs 29.1 is released (bug#64019).

	Do not merge to master.

2023-06-17  Michael Albinus  <michael.albinus@gmx.de>

	Require ls-lisp in Tramp only when needed

	* lisp/net/tramp-compat.el (ls-lisp): Require only on MS Windows.
	(Bug#64124)

	* lisp/net/tramp-sh.el (ls-lisp-use-insert-directory-program): Declare.
	(tramp-sh-handle-insert-directory): Simplify.

	* lisp/net/tramp.el (ls-lisp-use-insert-directory-program): Declare.
	(tramp-handle-insert-directory): Require ls-lisp.  Simplify.

2023-06-17  Alan Mackenzie  <acm@muc.de>

	After minibuffer action, don't make the minibuffer current

	This fixes bug#63967.

	* src/minibuf.c (minibuffer_unwind): After restoring the next
	minibuffer outwards to the mini window (when
	enable-recursive-minibuffers is non-nil), don't call
	Fset_frame_selected_window, which used to set the current
	window to be the mini window.

2023-06-17  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix some tree-sitter :match regexps

	The shy groups were caught by modified versions of the GNU ELPA
	packages xr and relint:
	- https://github.com/mattiase/xr/pull/6
	- https://github.com/mattiase/relint/pull/14

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query): Quote special
	character in regexp.
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--font-lock-settings):
	* lisp/progmodes/js.el (js--plain-method-re):
	(js--treesit-font-lock-settings):
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Replace character
	alternative [\\d], which matches '\' or 'd', with the most likely
	intention [0-9].  Fix shy groups mistyped as optional colons.
	Remove unneeded numbered :match group in rust-ts-mode (bug#64019).

2023-06-17  João Távora  <joaotavora@gmail.com>

	Eglot: fix relative position of coinciding inlay hint overlays (bug#64101)

	Only seems to happen on certain platforms, like Mac OS.  Reason
	unknown reason so far, but this defensive fix seems safe.

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Explicitly put
	priority in inlay hint overalys.

2023-06-17  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of comment-dwim (bug#64104)

	* lisp/newcomment.el (comment-dwim): Doc fix.

	* doc/emacs/programs.texi (Comment Commands): More accurate
	description of what 'M-;' does when there's no active region.

2023-06-17  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Fix parsing of dn line if WITHDN is non-nil

	Function `ldap-search' errors out with `wrong-type-argument listp'
	when called with WITHDN non-nil.
	* lisp/net/ldap.el (ldap-search-internal): Parse the dn line
	correctly so that `ldap-search' can grok it.  (Bug#64089)

2023-06-15  Andreas Schwab  <schwab@suse.de>

	* doc/misc/calc.texi (Advanced Math Functions): Correct calc
	algebraic syntax.

2023-06-15  Eli Zaretskii  <eliz@gnu.org>

	Consider 'dired-kill-when-opening-new-dired-buffer' in mouse clicks

	* lisp/dired.el (dired-mouse-find-file): Honor the value of
	'dired-kill-when-opening-new-dired-buffer'.  (Bug#64079)

2023-06-15  Eli Zaretskii  <eliz@gnu.org>

	Fix Gamma function definition in calc.texi

	* doc/misc/calc.texi (Advanced Math Functions): Fix definition
	of Gamma function.  Use @sup in @infoline lines.  (Bug#64077)

2023-06-15  Eli Zaretskii  <eliz@gnu.org>

	Fix subscripts in the Calc manual

	* doc/misc/calc.texi (Musical Notes): Use @sub instead of TeX-only
	'_' notation.  For the details, see the discussion in
	https://lists.gnu.org/archive/html/emacs-devel/2023-06/msg00096.html.

2023-06-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'declare' forms

	* lisp/simple.el (read-extended-command-predicate): Mention the
	'(declare completion ...' form in the doc string.

	* doc/lispref/functions.texi (Declare Form): Clarify
	'completion-predicate' and 'modes'; add cross-references.
	(Bug#64045)

2023-06-13  Basil L. Contovounesios  <contovob@tcd.ie>

	Improve tree-sitter docs

	* doc/lispref/positions.texi (List Motion): Incorporate more
	accurate description of treesit-defun-type-regexp from
	'(elisp) Tree-sitter Major Modes', replacing that duplicate
	entry (bug#64018).

	* doc/lispref/parsing.texi (Parsing Program Source)
	(Language Grammar, Using Parser, Retrieving Nodes)
	(Accessing Node Information, Pattern Matching, Multiple Languages):
	(Tree-sitter Major Modes):
	* doc/lispref/modes.texi (Parser-based Font Lock): Improve wording,
	grammar, punctuation, and markup.  Fix typos.
	(Parser-based Indentation): Ditto.  Document indent rule presets
	field-is, catch-all, nth-sibling, grand-parent, and
	great-grand-parent.

	* lisp/treesit.el (treesit-simple-indent-presets): Mention field-is,
	catch-all, nth-sibling, grand-parent, great-grand-parent in
	docstring.
	(treesit-major-mode-setup, treesit-explore-mode): Improve
	docstring/commentary grammar.

2023-06-13  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix some Texinfo markup in manuals

	* doc/emacs/macos.texi (Mac / GNUstep Customization):
	* doc/lispintro/emacs-lisp-intro.texi (condition-case):
	* doc/lispref/control.texi (pcase Macro):
	* doc/lispref/debugging.texi (Internals of Debugger):
	* doc/lispref/internals.texi (Building Emacs):
	* doc/lispref/modes.texi (Imenu):
	(Parser-based Font Lock, Parser-based Indentation):
	* doc/lispref/parsing.texi (Retrieving Nodes, Tree-sitter C API):
	* doc/lispref/processes.texi (Network, Bindat Types):
	* doc/lispref/searching.texi (Rx Functions):
	* doc/lispref/text.texi (Replacing):
	* doc/lispref/windows.texi (Textual Scrolling):
	* doc/misc/calc.texi (Killing From Stack, Customizing Calc):
	* doc/misc/cc-mode.texi (Misc Font Locking, List Line-Up):
	* doc/misc/ede.texi (ede-cpp-root-project)
	(ede-proj-target-makefile, ede-sourcecode):
	* doc/misc/ert.texi (Running Tests in Batch Mode):
	* doc/misc/eudc.texi (Emacs-only Configuration, The Server Hotlist):
	* doc/misc/eww.texi (Advanced):
	* doc/misc/flymake.texi (Starting Flymake)
	(Proc customization variables):
	* doc/misc/tramp.texi (File name completion):
	* doc/misc/gnus.texi (Summary Buffer Lines, Gnus Registry Setup)
	(Fancy splitting to parent, Customizing the IMAP Connection)
	(Mail Source Specifiers, Agent as Cache): Consistently mark up nil
	and t as @code.  Also fix the markup and wording of some surrounding
	text (bug#64016).

	* doc/lispref/display.texi (SVG Images, Icons):
	* doc/lispref/modes.texi (Customizing Keywords): Prefer ASCII
	apostrophe over Unicode right single quotation mark.

2023-06-13  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix bol/bos anchors in tree-sitter :match regexps

	Further regexp fixes to follow separately (bug#64019#29).

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	* lisp/progmodes/cmake-ts-mode.el
	(cmake-ts-mode--font-lock-settings):
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--font-lock-settings):
	* lisp/progmodes/js.el (js--treesit-font-lock-settings):
	* lisp/progmodes/python.el (python--treesit-settings):
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	* lisp/progmodes/sh-script.el (sh-mode--treesit-settings):
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings):
	* test/src/treesit-tests.el (treesit-query-api): Anchor :match
	regexps at beginning/end of string, not line.

2023-06-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/subr.el (with-restriction): Tweak indent rule

2023-06-12  Eli Zaretskii  <eliz@gnu.org>

	Fix setting region in the minibuffer

	* lisp/minibuffer.el (minibuffer-beginning-of-buffer): Fix setting
	region.  (Bug#64022)

2023-06-12  Michael Albinus  <michael.albinus@gmx.de>

	Fix setting $DBUS_SESSION_BUS_ADDRESS after Emacs has started

	* doc/misc/dbus.texi (Alternative Buses): Explain using
	$DBUS_SESSION_BUS_ADDRESS after Emacs has started.

	* src/dbusbind.c (XD_DBUS_VALIDATE_BUS_ADDRESS): Use egetenv.

2023-06-11  Eli Zaretskii  <eliz@gnu.org>

	Fix tex-mode display-buffer issues

	* lisp/window.el (display-tex-shell-buffer-action): New defcustom.
	* lisp/textmodes/tex-mode.el (tex-display-shell)
	(tex-cmd-doc-view, tex-recenter-output-buffer): Use it.
	(Bug#63956)

2023-06-10  Morgan Smith  <Morgan.J.Smith@outlook.com>

	Add test for when 'completion-auto-help' is 'visible'

	* test/lisp/minibuffer-tests.el (completion-auto-help-test): Add
	test for when 'completion-auto-help' is 'visible'.  Also test
	for successful completion message.  (Bug#63913)

2023-06-10  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in 'apropos-documentation' after 'eval-buffer'

	* lisp/apropos.el (apropos--map-preloaded-atoms): Support the case
	where an element of 'load-history' has nil as its car.  (Bug#63881)

2023-06-10  Daniel Martín  <mardani29@yahoo.es>

	Mention indent-rigidly in the Emacs manual

	* doc/emacs/indent.texi (Indentation Commands): Rewrite the first
	sentence of 'C-x TAB' to mention the command that it executes, and
	without using passive voice.  (Bug#63997)

2023-06-10  Morgan Smith  <Morgan.J.Smith@outlook.com>

	Don't ding when completion succeeded

	* lisp/minibuffer.el (minibuffer-completion-help): Ensure 'ding'
	is not called on a successful completion.  Ensure 'ding' is not
	called on a failure if 'completion-fail-discreetly' is set.
	Also change "No completions" to "No match" as that is what is
	used elsewhere.  (Bug#63913)

2023-06-09  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of color-related functions

	* doc/lispref/frames.texi (Color Names): Document
	'color-name-to-rgb' and 'color-dark-p'.

2023-06-08  Eli Zaretskii  <eliz@gnu.org>

	Revert "* package.el (package--get-activatable-pkg): Prefer source packages"

	This reverts commit fb87d5008e21d1bc03547c1edf2280fb4cb8311e.
	It caused problems when new versions of packages are installed
	without deleting old versions.  (Bug#63757)

2023-06-08  Michael Albinus  <michael.albinus@gmx.de>

	Fix connection-local user options handling (bug#63300)

	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables): Avoid saving the changed
	user option to file unless triggered explicitly by user.  (Bug#63300)

2023-06-08  Eli Zaretskii  <eliz@gnu.org>

	Document 'startup-redirect-eln-cache'

	* doc/lispref/compile.texi (Native Compilation)
	(Native-Compilation Functions): Document
	'startup-redirect-eln-cache'.

	* etc/PROBLEMS: Fix last change.
	* etc/NEWS: Mark 'startup-redirect-eln-cache' as documented.

2023-06-06  Andrea Corallo  <akrl@sdf.org>

	Fix `emacs-lisp-native-compile-and-load' for C-h f (bug#58314)

	* lisp/emacs-lisp/comp.el (comp-write-bytecode-file): New function
	spilling code from `batch-byte+native-compile'.
	(batch-byte+native-compile): Make use of.
	* lisp/progmodes/elisp-mode.el
	(emacs-lisp-native-compile-and-load): Produce the elc file and ask
	to have it loaded.

2023-06-06  Theodor Thornhill  <theo@thornhill.no>

	Add 'infer' as a keyword to typescript-ts-mode (bug#63880)

	* lisp/progmodes/typescript-ts-mode.el (typescript-ts-mode--keywords):
	New keyword.

2023-06-04  Philip Kaludercic  <philipk@posteo.net>

	Revert changes to the order in which package descs are loaded

	* lisp/emacs-lisp/package.el (package-load-all-descriptors):  Remove
	NOSORT argument to 'directory-files', reverting back to the behaviour
	as of Emacs 28.  (Bug#63757)

2023-06-04  Spencer Baugh  <sbaugh@janestreet.com>

	Handle point in last file-name component in minibuffer completion

	This is a followup to commit e338a8ac41d4a9fd798dda90275abe75ac071335
	(Handle point not at EOB in minibuffer-choose-completion).
	That commit added a heuristic, but the heuristic was insufficient:
	It still had the original wrong behavior when completing the last
	file-name component (i.e., the completion category is 'file' and
	there's no slash after point).  This patch makes the heuristic
	cover that case as well.
	* lisp/minibuffer.el (minibuffer-next-completion)
	(minibuffer-choose-completion): If in file completion and there's no
	slash after point, clear what's after point when we complete.
	(Bug#62700)

2023-06-03  Eli Zaretskii  <eliz@gnu.org>

	Avoid asking redundant question in emacsbug.el

	* lisp/mail/emacsbug.el (report-emacs-bug-hook): Don't ask the
	question about saving email setup if we cannot save it anyway.
	(Bug#63816)

2023-06-03  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-base): Don't install gawk.

2023-06-03  Dmitry Gutov  <dmitry@gutov.dev>

	typescript-ts-mode: Add a rule for function_signature

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings):
	Add a rule for function_signature (bug#63867)

2023-06-03  Mattias Engdegård  <mattiase@acm.org>

	* admin/unidata/emoji-zwj.awk: Avoid sprint buffer overflow

	Some AWK implementations have a fixed buffer for sprintf; for mawk the
	default size is 8192 bytes.  Hoist a string concatenation from
	a sprintf call to avoid running into that limit.  See discussion at
	https://lists.gnu.org/archive/html/emacs-devel/2023-06/msg00090.html .

	(cherry picked from commit b5f17fe07c6624380ba8d0c7a400a6b89f225209)

2023-06-03  Йордан Миладинов  <yordanm@pm.me>  (tiny change)

	Fix apostrophe handling in rust-ts-mode and go-ts-mode (Bug#63708)

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--syntax-propertize):
	Treat apostrophes as strings if used to define character literals.
	Treat LT and GT as pairs if used to define type parameters (formerly
	they were treated as pairs only for type arguments).
	* lisp/progmodes/go-ts-mode.el (go-ts-mode--syntax-table): Treat
	apostrophes as strings if used to define rune literals.

2023-06-03  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-base): Install also gawk.

2023-06-03  Eli Zaretskii  <eliz@gnu.org>

	Fix 'python-util-clone-local-variables'

	* lisp/progmodes/python.el (python-util-clone-local-variables):
	Avoid signaling an error when a local variable is unbound.
	Patch by Ernesto Alfonso <erjoalgo@gmail.com>.  (Bug#63818)

2023-06-03  kobarity  <kobarity@gmail.com>

	Revert "Enhance Python font-lock to support multilines"

	This reverts commit 4915ca5dd4245a909c046e6691e8d4a1919890c8.

	We have found that there are performance issues when editing a large
	file.  The issue can be reproduced as follows:

	1. emacs -Q
	2. Open large Python file (e.g. turtle.py in Python)
	3. Near the top of the buffer, enter open paren and some characters.

	The above commit extends the region to be font-locked using
	`python-nav-end-of-statement'.  However, if there are unbalanced
	parens, it may move point to the end of the buffer.  This causes
	almost the entire buffer to be font-locked, which is not acceptable
	for large files.

2023-06-03  Eli Zaretskii  <eliz@gnu.org>

	Fix typo in calc.texi

	* doc/misc/calc.texi (Programming Tutorial): Fix a typo.
	Suggested by Vladimir Nikishkin <lockywolf@gmail.com>.

2023-06-02  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.4.1

2023-06-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in 'delete-forward-char' deleting static compositions

	* lisp/simple.el (delete-forward-char): Fix recognition of static
	compositions.  (Bug#63837)

2023-06-02  Robert Pluim  <rpluim@gmail.com>

	Make VS-15 and VS-16 compositions work correctly

	There is a conflict between forward matching and backward matching
	composition rules involving the same codepoint, which can cause the
	backward matching ones not to be invoked.  Ensure that VS-15 (U+FE0E)
	and VS-16 (U+FE0F) are composed by forward matching rules instead in
	order to avoid this issue.

	* admin/unidata/emoji-zwj.awk: Add rules for CHAR+VS-15 and CHAR+VS-16.
	* lisp/composite.el: remove backward matching rule for VS-15.  (Bug#63731)

2023-06-01  Dmitry Gutov  <dmitry@gutov.dev>

	Fix project-name for vc-aware backend in non-file buffers

	* lisp/progmodes/project.el (project-name): Make sure
	project-vc-name is picked up from dir-locals in all
	non-file-visiting buffers too (mentioned in bug#63469).

2023-05-31  Theodor Thornhill  <theo@thornhill.no>

	Add type_predicate 'is' as keyword in typescript-ts-mode (bug#63810)

	* lisp/progmodes/typescript-ts-mode.el (typescript-ts-mode--keywords):
	New keyword 'is'.

2023-05-31  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in info-look.el

	* lisp/info-look.el (info-lookup-guess-gdb-script-symbol): Fix
	infloop when there are no completions.  (Bug#63808)

2023-05-31  Stephen Berman  <stephen.berman@gmx.net>

	Fix several todo-mode.el item editing bugs (bug#63811)

	* lisp/calendar/todo-mode.el (todo-insert-item--basic): With
	insertion type 'here', ensure item is inserted on the todo-mode
	line where the command was invoked.
	(todo-edit-item--cat, todo-edit-item--pos): New variables.
	(todo-edit-item--text): Restrict the scope of nil-valued
	buffer-read-only to the functions that change buffer text.  If
	user moved point while editing a single-line todo item or a done
	item comment, or while inserting a done item comment, restore
	point, and for comments, make sure the done items section is
	displayed.  For multiline items, set the new variables so
	todo-edit-quit can use them.
	(todo-edit-quit): Use the values of the new variables to restore
	point in the todo-mode buffer if it had been moved while editing.
	(todo-edit-item--header): Avoid clobbering match data when editing
	a todo item header.

2023-05-31  Randy Taylor  <dev@rjt.dev>

	dockerfile-ts-mode: Prevent empty categories in imenu (Bug#63759)

	* lisp/progmodes/dockerfile-ts-mode.el (dockerfile-ts-mode--imenu):
	Don't include empty categories.

2023-05-31  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Brush up doc strings and terminology in plstore.el

	* lisp/plstore.el (plstore-encoded, plstore-passphrase-callback-function)
	(plstore--init-from-buffer, plstore-revert, plstore-close)
	(plstore--merge-secret, plstore--decrypt, plstore--match, plstore-find)
	(plstore-get, plstore-put, plstore-delete, plstore--insert-buffer)
	(plstore-save, plstore--encode, plstore--decode)
	(plstore--write-contents-functions, plstore-mode-decoded)
	(plstore-mode): Brush up doc strings and documentation in general.
	Fix terminology, in particular spurious occurences of all uppercase
	"PLSTORE".  (Bug#63627)

2023-05-31  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Add internal documentation on plstore.el

	* lisp/plstore.el: Add internal documentation and some words of
	warning in the user documentation.  (Bug#63627)

2023-05-30  Theodor Thornhill  <theo@thornhill.no>

	Add compact_constructor_declaration font-locking to java-ts-mode

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--font-lock-settings):
	New pattern.

2023-05-29  Juri Linkov  <juri@linkov.net>

	* lisp/tmm.el (tmm-completion-delete-prompt): Add more checks (bug#63754).

	In case when 'completions-header-format' is nil, the first 'mouse-face'
	property is at the beginning of the buffer.  So first use 'get-text-property'
	at point-min.

2023-05-29  Eli Zaretskii  <eliz@gnu.org>

	Allow to disable the DWIMish behavior of 'x' in package menu

	* lisp/emacs-lisp/package.el
	(package-menu-use-current-if-no-marks): New defcustom.
	(package-menu-execute): Use it.  (Bug#62563)

	* etc/NEWS: Announce the new option.

2023-05-29  Robert Pluim  <rpluim@gmail.com>

	Allow dired to invoke secondary browser

	'browse-url-of-dired-file' always invokes the primary browser, but
	sometimes it's handy to call a different browser, which is why
	'browse-url-secondary-browser-function' exists.

	* lisp/net/browse-url.el (browse-url-of-dired-file): Call
	'browse-url-secondary-browser-function' when invoked with a prefix
	argument.
	* etc/NEWS: Announce the change.

2023-05-29  Robert Pluim  <rpluim@gmail.com>

	Add a binding for enriched-toggle-markup

	* lisp/textmodes/enriched.el (enriched-mode-map): Bind
	'enriched-toggle-markup' to 'M-o m'.
	* etc/NEWS: Announce the change.

2023-05-29  Eli Zaretskii  <eliz@gnu.org>

	Fix order of tmm-menubar when 'tmm-mid-prompt' is nil

	* lisp/tmm.el (tmm-prompt): Reverse 'tmm-km-list' when
	'tmm-mid-prompt' is nil, to present the menu in the correct order.
	Suggested by Thiago Melo <tmdmelo@gmail.com>.

2023-05-29  Michael Albinus  <michael.albinus@gmx.de>

	Fix regression when saving tramp-default-proxies-alist (Do not merge)

	* lisp/net/tramp.el (tramp-add-hops): Suppress `signal-hook-function'.
	Save `tramp-default-proxies-alist' only when changed.

2023-05-28  Yuan Fu  <casouri@gmail.com>

	Save the tree-sitter grammar recipe when installing a grammar

	Raised in bug#63750, but not the main subject of it.

	* lisp/treesit.el (treesit-install-language-grammar): Save the recipe
	to treesit-language-source-alist when installation is successful.

2023-05-28  Robert Pluim  <rpluim@gmail.com>

	Add instructions and test file for VS-15/VS-16

	* admin/notes/unicode: Add instructions for emoji-variation-sequences.txt
	* admin/unidata/emoji-variation-sequences.txt: New file, imported from
	Unicode 15.

2023-05-28  Michael Heerdegen  <michael_heerdegen@web.de>

	A better fix for "Fix cancellation of Wdired"

	* lisp/wdired.el (wdired-abort-changes): Call
	`dired-build-subdir-alist' instead of `dired-revert'.
	(Bug#63676)

2023-05-27  Eli Zaretskii  <eliz@gnu.org>

	Fix tmm-menubar when 'tmm-completion-prompt' is nil

	* lisp/tmm.el (tmm-prompt): Handle nil value of 'tmm-mid-prompt'.
	(tmm-completion-delete-prompt): Don't rely on the exact text of
	the completion heading line, as it is now a customizable format
	string, and can be nil, meaning no heading line is inserted at
	all.  Instead, search for the first character of the menu based on
	text properties used for it.  (Bug#63754)

2023-05-26  kobarity  <kobarity@gmail.com>

	Use 'font-lock-extend-region-functions' in python-mode

	* lisp/progmodes/python.el (python-font-lock-extend-region): Change
	arguments and return value for 'font-lock-extend-region-functions'.
	(python-mode): Change from
	'font-lock-extend-after-change-region-function' to
	'font-lock-extend-region-functions'.  (Bug#63622)

2023-05-26  kobarity  <kobarity@gmail.com>

	Fix python-info-docstring-p

	* lisp/progmodes/python.el (python-info-docstring-p): Stop using
	python-rx string-delimiter.

	* test/lisp/progmodes/python-tests.el
	(python-font-lock-escape-sequence-bytes-newline)
	(python-font-lock-escape-sequence-hex-octal)
	(python-font-lock-escape-sequence-unicode)
	(python-font-lock-raw-escape-sequence): Mark as expected failures
	until another bug in 'python-info-docstring-p' is corrected.
	(python-info-docstring-p-7): New test.  (Bug#63622)

2023-05-26  Eli Zaretskii  <eliz@gnu.org>

	Fix cancellation of Wdired

	* lisp/wdired.el (wdired-abort-changes): Call 'dired-revert'.
	Patch by Stephen Berman <stephen.berman@gmx.net>.  (Bug#63676)

2023-05-26  Mattias Engdegård  <mattiase@acm.org>

	Handle #@00 in new reader in a compatible way (bug#63722)

	This was a regression from Emacs 28.

	* src/lread.c (skip_lazy_string, read0): Make #@00 read as nil, which
	is a quirk from the old reader that we preserve for compatibility.
	* test/src/lread-tests.el (lread-skip-to-eof): Verify it.

	Reported by Richard Newton.

2023-05-25  Po Lu  <luangruo@yahoo.com>

	Don't mark selection request events

	* src/pgtkterm.c (mark_pgtkterm): Prevent crash by not marking
	selection request events, which don't have Lisp_Object members.

2023-05-25  Po Lu  <luangruo@yahoo.com>

	Disable cairo-xcb support by default

	* INSTALL (--with-cairo-xcb): Document new option.
	* configure.ac (USE_CAIRO_XCB): Implement new option.

2023-05-25  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/project.el: Move :safe from defcustom to autoload (bug#63469)

	(project-vc-ignores, project-vc-merge-submodules)
	(project-vc-include-untracked, project-vc-name)
	(project-vc-extra-root-markers, project-kill-buffers-display-buffer-list):
	Autoload the line that puts 'safe-local-variable' property on defcustom symbol
	instead of using the :safe keyword.

2023-05-25  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc-annotate.el (vc-annotate-mode-menu): Quote vc-annotate-backend.

	When unquoted it might get the nil value when vc-annotate.el is loaded
	in non-vc-controlled buffer (bug#63689).

2023-05-25  Juri Linkov  <juri@linkov.net>

	Add vc-create/switch/print-branch to menu and update documentation (bug#63690)

	* doc/emacs/maintaining.texi (VC Change Log):
	Add 'C-x v b l' (vc-print-branch-log).
	(Creating Branches): Add @kindex and @findex for vc-create-branch.
	(Switching Branches): Add @kindex and @findex for vc-switch-branch.

	* lisp/vc/vc-hooks.el (vc-menu-map): Add menu items for new
	commands vc-create-branch and vc-switch-branch, and also
	vc-print-branch-log.

	* lisp/vc/vc.el (vc-print-branch-log): Improve docstring.

2023-05-25  Eli Zaretskii  <eliz@gnu.org>

	Fix rare crashes in 'try_window_reusing_current_matrix'

	* src/xdisp.c (try_window_reusing_current_matrix): Make sure we
	never use a mode-line glyph row to start displaying scrolled-in
	rows.  (Bug#63711)

2023-05-25  Michael Albinus  <michael.albinus@gmx.de>

	Make last Tramp change less invasive

	* lisp/net/tramp.el (tramp-dissect-file-name): Revert last change.
	(tramp-handle-file-name-as-directory)
	(tramp-handle-file-name-directory): Let-bind `tramp-default-proxies-alist'.

2023-05-23  Eli Zaretskii  <eliz@gnu.org>

	Fix 'use-dialog-box-p' and friends

	* lisp/subr.el (use-dialog-box-p): Use dialog boxes also when
	invoked from some window-system gesture.  (Bug#63655)
	(y-or-n-p): Fix the description in the doc string of conditions
	under which a dialog box will be used.

	* src/fns.c (Fyes_or_no_p): Use the same condition for dialog
	boxes as in 'use-dialog-box-p'.  Fix the description in the doc
	string of conditions under which a dialog box will be used.

	* doc/lispref/minibuf.texi (Multiple Queries, Yes-or-No Queries):
	Fix the description of conditions under which a dialog box will be
	used.

2023-05-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Avoid duplicates when adding package dirs to load-path

	Do not merge to master, we're going to delete this code there.

	* lisp/emacs-lisp/package.el (package-activate-1): Check if the path
	we're about to add is already in 'load-path', since package autoload
	files have been updating 'load-path' for a decade.

2023-05-23  Robert Pluim  <rpluim@gmail.com>

	Avoid duplicate load-path entry when generating package autoloads

	'file-name-directory' produces a path ending in '/', so that needs to be
	run through 'directory-file-name' to avoid duplicate entries in
	'load-path'.  (Bug#63625)

	* lisp/emacs-lisp/package.el (package-generate-autoloads): Call
	'directory-file-name' on the directory of 'load-file-name'.

2023-05-23  Eli Zaretskii  <eliz@gnu.org>

	Disable loading SQLite3 extensions when SQLite3 version is too old

	* src/sqlite.c (HAVE_LOAD_EXTENSION): Define to 1 only if
	enabling/disabling extension loading is supported as well.
	(load_dll_functions, Fsqlite_load_extension): Condition on
	HAVE_LOAD_EXTENSION, not on HAVE_SQLITE3_LOAD_EXTENSION.
	(Bug#63653)

2023-05-22  Eli Zaretskii  <eliz@gnu.org>

	Fix visiting HTML files encoded in iso-2022 variants

	* lisp/international/mule.el (sgml-xml-auto-coding-function)
	(sgml-html-meta-auto-coding-function): Handle coding-systems whose
	coding-system-type is iso-2022.  (Bug#63644)

2023-05-22  Eli Zaretskii  <eliz@gnu.org>

	Support 'isearch-allow-scroll' in 'pixel-scroll-precision-mode'

	* lisp/pixel-scroll.el (pixel-scroll-precision)
	(pixel-scroll-down, pixel-scroll-up): Put the 'scroll-command'
	property on these commands.  (Bug#63640)

2023-05-22  Andreas Schwab  <schwab@suse.de>

	shr: allow moving between adjacent anchors

	* lisp/net/shr.el (shr-urlify): Put shr-tab-stop only over first
	position.

2023-05-22  Michael Albinus  <michael.albinus@gmx.de>

	Fix multihop file name expansion in Tramp

	* lisp/net/tramp.el (tramp-dissect-file-name): Set hop to nil if
	NODEFAULT.  (Bug#63578)

2023-05-21  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Remove obsolete information from Gnus manual

	The Gnus manual was still referencing long-removed external
	marks in section "Archiving Mails".  Without external marks,
	that section is almost pointless, so remove it completely.
	* doc/misc/gnus.texi (Archiving Mail): Remove section.
	(Top, Browsing the Web): Remove references to "Archiving
	Mail".  (Bug#63497)

2023-05-21  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Preserve mark in comint-history-isearch

	This preserves mark in `comint-history-isearch-backward' and
	friends, which tend to set the mark on completion of the isearch
	to unexpected positions.
	* lisp/comint.el (comint-history-isearch-end): Set `isearch-opoint'
	to point.  (Bug#63616)

2023-05-20  Liu Hui  <liuhui1610@gmail.com>

	Fix systemd unit completion for old versions of systemd

	* lisp/pcmpl-linux.el (pcmpl-linux--systemd-units): Use '--no-legend'
	for compatibility with older versions of systemctl.  (Bug#63411)

2023-05-20  Eli Zaretskii  <eliz@gnu.org>

	Fix Skeletons menu-bar menu in Python modes

	* lisp/progmodes/python.el (python-mode, python-ts-mode): Call
	'python-skeleton-add-menu-items' here, not in 'python-base-mode',
	since the "Python" menu is not yet set up in the latter.
	(Bug#63598)

2023-05-20  Eli Zaretskii  <eliz@gnu.org>

	Fix loading SQLite extensions

	* src/sqlite.c (sqlite3_db_config) [WINDOWSNT]: Load from the DLL.
	(Fsqlite_load_extension): Use 'sqlite3_db_config' to enable and
	disable loading of extensions.  Add a few free extensions to the
	allow-list.  Fix testing for the ".dll" extension.  (Bug#63590)

	* test/src/sqlite-tests.el (sqlite-load-extension): Fix the test
	to require successful load if the extension does exist.

2023-05-20  Mattias Engdegård  <mattiase@acm.org>

	* etc/NEWS: Note dotimes loop variable scoping change (bug#63586)

2023-05-20  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode--top-level-declarator

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--top-level-declarator): Don't use treesit-node-match-p.

2023-05-19  Yuan Fu  <casouri@gmail.com>

	Improve c-ts-mode font-lock for function names (bug#63390)

	When a function definition has preproc directives in its body, it
	can't correctly parse into a function_definition.  This fix tries to
	recognize this case and highlight the function_declarator correctly.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--font-lock-settings): New rule.
	(c-ts-mode--top-level-declarator): New function.

2023-05-19  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el: Don't use 'minibuffer-selected-window' (bug#62427).

	(tab-bar-select-tab, tab-bar-new-tab-to):
	Use 'window-minibuffer-p' instead of 'minibuffer-selected-window'.
	And switch to 'get-mru-window' instead of 'minibuffer-selected-window'.

2023-05-19  Juri Linkov  <juri@linkov.net>

	Split windows horizontally in places that use split to create a new window.

	* lisp/tab-bar.el (tab-bar-new-tab-to):
	* lisp/window.el (window-state-put):
	To create a new window, split horizontally instead of vertically.
	Use 'window-safe-min-width' for the SIZE arg of 'split-window'.
	(bug#62592)

2023-05-18  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter test (bug#63481)

	* test/src/treesit-tests.el (treesit-basic-parsing): Latest json
	parser doesn't return an error on empty buffer or multiple objects
	anymore [1].

	https://github.com/tree-sitter/tree-sitter-json/commit/40a81c01a40ac48744e0c8ccabbaba1920441199

2023-05-18  Aaron Jensen  <aaronjensen@gmail.com>

	Attempt to fix redisplay problems on macOS

	* src/nsterm.m (ns_scroll_run): Attempt to fix redisplay
	artifacts.  (Bug#63187)

2023-05-18  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>  (tiny change)

	Clarify misleading comment in isearch.el

	Clarify a misleading comment in isearch.el as to whether frame events
	should exit an isearch or not (Bug#62032, Bug#41338 for background
	information).
	* lisp/isearch.el (isearch-mode-map): Replace the misleading comment.
	(Bug#62032)

2023-05-18  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of package-menu commands

	* doc/emacs/package.texi (Package Menu): Document that some
	package-menu filters accept lists of values interactively.

	* lisp/emacs-lisp/package.el (package-menu-execute)
	(package-menu-hide-package, package-menu-describe-package)
	(package-menu-mark-delete, package-menu-mark-install)
	(package-menu-mark-unmark, package-menu-backup-unmark)
	(package-menu-quick-help, package-menu-get-status)
	(package-menu--find-upgrades, package-menu-mark-upgrades)
	(package-menu-filter-by-archive)
	(package-menu-filter-by-description)
	(package-menu-filter-by-keyword)
	(package-menu-filter-by-name-or-description)
	(package-menu-filter-by-name, package-menu-filter-by-status)
	(package-menu-filter-by-version, package-menu-filter-marked)
	(package-menu-describe-package): Doc fixes.

2023-05-17  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix M-x completion-predicate under python-ts-mode

	* lisp/progmodes/python.el (python--completion-predicate)
	(python-shell--completion-predicate): Filter M-x completion based on
	python-base-mode instead of python-mode.  This allows for
	python-ts-mode as well (bug#63552).

2023-05-17  Andrea Corallo  <akrl@sdf.org>

	* Account for `byte-compile-warnings' during native compilation (bug#63302).

	* lisp/emacs-lisp/comp.el (comp-final, comp-run-async-workers):
	Forward `byte-compile-warnings' to child processes.

2023-05-16  Philip Kaludercic  <philipk@posteo.net>

	Avoid duplicate VC packages in 'package-selected-packages'

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack-1): Check if
	'package-selected-packages' already contains the package name.
	(bug#63338)

2023-05-15  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-new-tab-to): Set 'window-side' to nil (bug#62427).

	This is still needed for the case when tab-bar-new-tab-choice is 'window'.

2023-05-14  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.6

2023-05-14  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version for next pretest

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump Emacs version to 29.0.91.

2023-05-14  Gabriel do Nascimento Ribeiro  <gabriel376@hotmail.com>

	Ignore current-prefix-arg in async-shell-command

	* lisp/simple.el (async-shell-command): Ignore current-prefix-arg and
	always pass nil to second argument of `shell-command'.  (Bug#63432)

2023-05-13  Joseph Turner  <joseph@breatheoutbreathe.in>

	Fix building of VC package manuals with relative includes

	* lisp/emacs-lisp/package-vc.el (package-vc--build-documentation):
	Invoke makeinfo with -I to ensure the package directory is always
	consulted for @include statements.  (Bug#63337)

2023-05-13  Cyril Arnould  <cyril.arnould@outlook.com>  (tiny change)

	Another fix for VHDL mode highlighting

	* lisp/progmodes/vhdl-mode.el (vhdl-version): Bump to 3.38.5.
	(vhdl-compiler-alist): Fix the regexps and the doc string.

2023-05-13  Eli Zaretskii  <eliz@gnu.org>

	Fix auto-filling in Texinfo mode

	This fixes auto-filling in Texinfo buffers.  It was broken by the
	fix to bug#49558, which made M-q fill over-long @noindent lines by
	refraining from customizing 'paragraph-separate' in Texinfo mode.
	The underlying problem here is that 'auto-fill-mode' doesn't call
	mode-specific filling functions, but does its job by itself, and
	depends on 'forward-paragraph' to find the beginning of the
	paragraph as appropriate for calculation of 'fill-prefix', and a
	different value of 'paragraph-separate' broke that.  As a side
	effect, the change below also changes paragraph-movement commands
	in Texinfo back to how they behaved prior to that bugfix, but I
	don't see why the paragraph-movement behavior introduced by that
	fix made more sense.  Try to move through a series of
	@-directives, like a paragraph preceded by several @cindex
	entries, and you will see the inconsistencies.  In any case, the
	adverse effects of that fix on auto-filling is unacceptable.

	* lisp/textmodes/texinfo.el (fill-paragraph-separate): New
	variable.
	(texinfo-mode): Set 'fill-paragraph-separate' to the default value
	of 'paragraph-separate'.  Customize 'paragraph-separate' to the
	Texinfo-specific value, as it was before commit dde591571abf.
	(texinfo--fill-paragraph): Bind 'paragraph-separate' to the value
	of 'fill-paragraph-separate', to keep 'M-q' happy.

2023-05-12  Gregory Heytings  <gregory@heytings.org>

	Merge branch 'scratch/long-lines-cleanup' into 'emacs-29'

2023-05-12  Gregory Heytings  <gregory@heytings.org>

	Add an assertion in, and a commentary for, 'get_nearby_bol_pos'

	* src/xdisp.c:
	(get_nearby_bol_pos): Document the function, and add an assertion
	on its return value.

2023-05-12  Gregory Heytings  <gregory@heytings.org>

	Fix the return type of 'labeled_restrictions_get_bound'

	* src/editfns.c:
	(labeled_restrictions_get_bound): Return a Lisp_Object instead of
	a pointer to a struct Lisp_Marker.
	(unwind_reset_outermost_restriction, reset_outermost_restrictions)
	(Fwiden, Fnarrow_to_region): Adapt to the new return type.

2023-05-12  Eli Zaretskii  <eliz@gnu.org>

	Fix mouse highlight with some fonts in Cairo builds

	* src/ftcrfont.c (ftcrfont_draw): Don't set the
	'background_filled_p' flag of the glyph string.  (Bug#63271)

2023-05-12  Philip Kaludercic  <philipk@posteo.net>

	Ensure that package menu respects 'package-install-upgrade-built-in'

	* lisp/emacs-lisp/package.el (package-menu--find-upgrades): Check if
	built-in packages can be upgraded if
	'package-install-upgrade-built-in' is non-nil.

2023-05-12  Philip Kaludercic  <philipk@posteo.net>

	Ensure that EXTRA-DATA are always written when generating autoloads

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate): Handle
	edge-case where no autoloads are found.  (Bug#63260)

2023-05-11  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.4.0

	Or strictly speaking v0.4.0-1-g428576a4.)

2023-05-11  Eli Zaretskii  <eliz@gnu.org>

	Revert "Don't have nntp-report signal an error"

	This reverts commit 032969e8c65ba1ccda8466f6c61f20e0c7293ebf.
	The commit is being reverted because it caused bug#62845.

2023-05-10  Alan Mackenzie  <acm@muc.de>

	Make c-emacs-features use the proper binding of parse-sexp-lookup-properties

	This is relevant for bug #58558, although it does not fix it.  Due to a wrong
	ordering of with-current-buffer and a let form, the function overwrote the
	global value of parse-sexp-lookup-properties and two other variables.

	* lisp/progmodes/cc-defs.el (c-emacs-features): Change the nesting of
	with-current-buffer and let so that the let bindings get used.

2023-05-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	with-display-message: Workaround for bug#63253

	Running arbitrary ELisp code from an atimer is still dangerous,
	at least because the regexp engine is not-reentrant, so let's patch up
	the case we bumped into.  There are probably many other such holes :-(

	* src/alloc.c (garbage_collection_inhibited): Make it non-static.

	* src/xdisp.c (garbage_collection_inhibited): Declare it.
	(set_message, clear_message): Use it as a proxy for "we're in
	a dangerous context like within `probably_quit`".

2023-05-09  João Távora  <joaotavora@gmail.com>

	Fido-mode: never shadow 'external' completion style

	As explained in the manual (20.7.2 Fast minibuffer selection)
	'fido-mode' and 'fido-vertical-mode' give priority the "flex"
	completion style.

	In fact, bug#62015 was recently fixed in commit because that priority
	was not taking place correctly and some completions were missed.

	However, an exception must be made for the 'external' completion
	style.

	That style, made available by the lisp/external-completion.el library,
	is specifically designed to work with backends that provide only a
	partial view of all completions.  If we allow 'flex' to step in front
	of 'external' it could mean that 'flex' matches something and
	'external' isn't triggered as it probably should.

	To reproduce have the rust-mode ELPA package and the rust-analyzer LSP
	server handy.  Then:

	  emacs -Q -f package-initialize main.rs

	Where main.rs is this content:

	  fn foo1()    {} fn foo2()    {} fn foo3() {}
	  fn foobar1() {} fn foobar2() {} fn foobar3() {}

	The rust-analyzer server can be quickly configured to return only 3
	workspace symbols max, so evaluate:

	  (setq-default eglot-workspace-configuration
	                '(:rust-analyzer
	                    (:workspace (:symbol (:search (:limit 3))))))

	Now start M-x eglot and M-x fido-vertical-mode and type C-u M-. to
	find an arbitrary symbol in this one-file project.

	Type 'f'.  You will see the three foo's are listed, correctly.

	Now type '3'.   You will only see "foo3".

	But that's wrong because "foobar3" was available, if only the server
	had been asked for it.  This commit fixes the situation and no
	completions are lost.

	As an unfortunate side-effect of this commit, the fontification of
	completions-common-part on the matches is lost, but that is not worse
	than missing out on completions and there are better ways to recover
	the fontification anyway (in external-completion.el).

	See also:
	https://github.com/joaotavora/eglot/discussions/1219#discussioncomment-5818336

	* lisp/icomplete.el (icomplete--fido-ccd): Do not touch entries
	with 'external in them.

	Do not merge to master.
	Backport:

	(cherry picked from commit 0e8d8a72284f6b3aaa1bbce73d41c7d84bbc4d3c)

2023-05-09  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in --without-all build trying to scale non-ASCII char

	* src/fontset.c (face_for_char): Display a non-ASCII character as
	glyphless if the ASCII face has no fontset.  (Bug#63283)

2023-05-09  Eli Zaretskii  <eliz@gnu.org>

	Improve instructions for dealing with Emacs crashes

	* doc/emacs/trouble.texi (Crashing): Show the variant of the
	'addr2line' command for MS-Windows.

2023-05-08  Mohsen Banan  <form@mohsen.banan.1.byname.net>

	Improved transliterations + improved bidi insertion support for Farsi

	* lisp/leim/quail/persian.el ("farsi-transliterate-banan"):
	Improve and add transliterations.  (Bug#63361)

2023-05-08  Alan Third  <alan@idiocy.org>

	Fix crash when creating a child frame in NS (bug#63107)

	* src/nsterm.m ([EmacsView initFrameFromEmacs:]): Have a second go at
	creating the toolbar.
	([EmacsWindow createToolbar:]): If there is already a toolbar or the
	EmacsView's layer is not an EmacsLayer, then do nothing.

	(cherry picked from commit 3adc1e7f37901235bda83ea65a90644b7b0a8dbf)

2023-05-07  Andrew G Cohen  <cohen@andy.bu.edu>

	Fix outgoing mime type regression (Bug#62815)

	* lisp/net/mailcap.el (mailcap-mime-extensions,
	mailcap-parse-mimetype-file, mailcap-mime-types): Don't regexp-quote
	mimetypes in a context where they should be strings.
	(mailcap--regexp-quote-type): Remove.

	(cherry picked from commit 605414d018da47f99dec5019142f584b6eb174c8)

2023-05-07  Nicholas Vollmer  <iarchivedmywholelife@gmail.com>

	define-minor-mode: sanitize mode function messages

	* lisp/emacs-lisp/easy-mmode.el (define-minor-mode): Ensure mode's
	pretty name is not interprted as a message formatting string,
	e.g., if the mode name contains a '%'.  (Bug#63343)

2023-05-07  Eli Zaretskii  <eliz@gnu.org>

	Fix beginning/end-of-defun with tree-sitter

	* lisp/treesit.el (treesit-beginning-of-defun)
	(treesit-end-of-defun): Push mark, as other beginning/end-of-defun
	functions do.

2023-05-06  Theodor Thornhill  <theo@thornhill.no>

	Fix indent for enums in csharp-mode

	* lisp/progmodes/csharp-mode.el (csharp-guess-basic-syntax): Check for
	keywords containing 'enum' on the line before an opening bracket, and
	make it behave like a class-open token.

2023-05-06  Eli Zaretskii  <eliz@gnu.org>

	Teach c-ts-mode about the 'restrict' keyword

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--keywords): Add
	"restrict" and "_Atomic" type qualifiers.  (Bug#63323)

2023-05-06  Eli Zaretskii  <eliz@gnu.org>

	* lisp/x-dnd.el (x-dnd-after-move-frame): Skip dead frames.  (Bug#63312)

2023-05-06  Eli Zaretskii  <eliz@gnu.org>

	Fix doc strings of 'mark-sexp' and 'mark-word'

	* lisp/emacs-lisp/lisp.el (mark-sexp):
	* lisp/simple.el (mark-word): Clarify the doc strings in various
	usage cases.  (Bug#62892)

2023-05-05  Dmitry Gutov  <dmitry@gutov.dev>

	(package-upgrade): Don't remove the package from 'package-selected-packages'

	* lisp/emacs-lisp/package.el (package-upgrade):
	Don't remove the package from 'package-selected-packages', fixing
	the problem described in https://debbugs.gnu.org/62720#718.

2023-05-05  João Távora  <joaotavora@gmail.com>

	Eglot: re-rename eglot-upgrade to eglot-upgrade-eglot

	* doc/misc/eglot.texi (Getting the latest version): Mention
	eglot-upgrade-eglot.

	* etc/EGLOT-NEWS: Mention eglot-upgrade-eglot.

	* lisp/progmodes/eglot.el (eglot-upgrade-eglot): Rename from
	eglot-update.
	(eglot-update): New compatibility alias.

2023-05-05  Eli Zaretskii  <eliz@gnu.org>

	Fix arguments of xml.c functions as displayed in Help buffers

	* lisp/subr.el (libxml-parse-xml-region)
	(libxml-parse-html-region): Adjust advertised-calling-convention
	to the changes in commit cc33c6cf3a.  (Bug#63291)

2023-05-05  Po Lu  <luangruo@yahoo.com>

	More fixes for NetBSD/vax

	* src/sysdep.c (init_signals) [__vax__]: Treat SIGILL
	as a floating point error on VAXen.
	Otherwise, (log 0.0) crashes Emacs.

2023-05-05  Cyril Arnould  <cyril.arnould@outlook.com>  (tiny change)

	Improve VHDL mode highlighting

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Differentiate
	between ModelSim errors, warnings, and notes when highlighting
	them.  Add a new entry for Xilinx Vivado.  (Bug#63251)

2023-05-04  Po Lu  <luangruo@yahoo.com>

	Clarify documentation wrt floating point division by zero and NaN

	* doc/lispref/numbers.texi (Float Basics)
	(Arithmetic Operations): Document what happens on a VAX.
	Tested on NetBSD 9.3.

2023-05-04  Robert Pluim  <rpluim@gmail.com>

	Make loaddefs-generate slightly more tolerant

	There are packages in the wild, such as vlf-20191126.2250, which have
	entries that are not terminated by three ';', but by two.  Tolerate
	such entries.

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate): Search for two
	';' as a delimiter, not three.  (Bug#63236)

2023-05-04  Philip Kaludercic  <philipk@posteo.net>

	Fix order of rcirc-connect arguments

	* lisp/net/rcirc.el (rcirc): Pass SERVER-ALIAS before CLIENT-CERT.
	(rcirc-connect): Take SERVER-ALIAS before CLIENT-CERT.

	This is necessary for the 'rcirc-reconnect' trick to work that applies
	the contents of 'rcirc-connection-info' to 'rcirc-connect', otherwise
	the server alias gets lost as certfp information.

	This addresses a change made in b79cb838a477ee5a5c3660e81264991ff833a82f.

2023-05-04  Thuna  <thuna.cing@gmail.com>  (tiny change)

	Fix rcirc messages printing in the wrong place

	* lisp/net/rcirc.el (rcirc-send-message): Print the message before
	sending it to the server.
	(rcirc-print): Get the time with subsecond precision.
	* lisp/calendar/parse-time.el (parse-time-string
	parse-iso8601-time-string): Accept optional second FORM arguments,
	with the same meaning as in `decode-time'.  Mention as such in the
	docstring.  (Bug#59501)

2023-05-04  Philip Kaludercic  <philipk@posteo.net>

	Prevent unnecessary modifications of 'package-vc-selected-packages'

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Handle the
	structure of correctly, not as an alist but a list of alists.
	(package-vc--archive-spec-alist, package-vc--archive-spec-alists,
	package-vc--desc->spec, package-vc--read-archive-data,
	package-vc--download-and-read-archives, package-vc--unpack): Rename
	'package-vc--archive-spec-alist' to 'package-vc--archive-spec-alists'.

2023-05-03  Dmitry Gutov  <dmitry@gutov.dev>

	Rename eglot-update to eglot-upgrade

	* doc/misc/eglot.texi (Getting the latest version):
	Update the reference.

	* lisp/progmodes/eglot.el (eglot-upgrade): Rename from
	'eglot-update', as discussed on emacs-devel, in line with
	'package-upgrade'.

2023-05-03  Randy Taylor  <dev@rjt.dev>

	go-ts-mode: Use iota query only if supported (Bug#63086)

	iota query support was added on January 5, 2022.  To support older
	versions of the tree-sitter-go grammar (like the latest tagged version,
	v0.19.1, which was released on March 3, 2021), check if the query is
	supported before trying to use it.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--iota-query-supported-p): New
	function.
	(go-ts-mode--font-lock-settings): Use it.

2023-05-03  Dmitry Gutov  <dmitry@gutov.dev>

	(rng-complete-tag): Add the (ignored) argument to the :company-kind function

	* lisp/nxml/rng-nxml.el (rng-complete-tag): Add the (ignored)
	argument to the :company-kind function.  Fixes the "Wrong number
	of arguments" error reported at
	https://github.com/company-mode/company-mode/issues/1386.

2023-05-03  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-219-g3ded15b

2023-05-03  Po Lu  <luangruo@yahoo.com>

	Fix inserting selection data into Mozilla programs

	* lisp/select.el (xselect-convert-to-text-uri-list): Don't
	return any value when converting non-DND selections to this
	drag-and-drop target.

	Reported by Tobias Bading <tbading@web.de>.

2023-05-03  Thuna  <thuna.cing@gmail.com>  (tiny change)

	Recognize defstruct slot names in various eieio functions

	* lisp/emacs-lisp/cl-preloaded.el (cl-struct-define): Set
	each slot's name's 'slot-name' property so that
	'eieio--known-slot-name-p' can recognize them.  (Bug#62959)

2023-05-02  Thuna  <thuna.cing@gmail.com>  (tiny change)

	Use 'calendar-buffer' instead of fixed string

	* test/lisp/calendar/cal-julian-tests.el (with-cal-julian-test):
	Use 'calendar-buffer' instead of a literal fixed name.
	(Bug#61546)

2023-05-02  Spencer Baugh  <sbaugh@catern.com>

	Handle point not at EOB in minibuffer-choose-completion

	Without this change, only the minibuffer contents before point
	are cleared when a completion is chosen, which results in stray
	text when point is in the middle of the minibuffer.

	After this change, we heuristically decide either to clear the
	whole buffer or only part of it, taking into account the
	location of point.

	This is a backport for the Emacs 29 release branch of a simpler
	fix in minibuffer-completion-help.

	* lisp/minibuffer.el (minibuffer-next-completion):
	(minibuffer-choose-completion):
	Recalculate completion-base-affixes with point.  (Bug#62700)

2023-05-02  Spencer Baugh  <sbaugh@catern.com>

	Note that Emacs pauses when handling sentinel errors

	Noting this behavior and variable here makes it easier to
	understand the behavior of Emacs when a sentinel has an error.

	* doc/lispref/processes.texi (Filter Functions): Note that Emacs
	pauses when handling sentinel errors.
	(Sentinels): Note that Emacs pauses when handling sentinel errors.
	(Bug#63096)

2023-05-01  Eli Zaretskii  <eliz@gnu.org>

	Fix vertical-motion when tab-line is displayed in a window

	* src/xdisp.c (try_window, try_window_id): Account for tab-line,
	if present, when converting scroll-margin at the top of the window
	to vertical pixel coordinate.  (Bug#63201)

2023-04-30  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.5-3-g2993f4

2023-04-30  Philip Kaludercic  <philipk@posteo.net>

	Prevent generating empty autoload files

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate): Remove
	optimisation that would mistakenly discard old loaddefs in case a file
	was not modified by EXTRA-DATA is non-nil.  (Bug#62734)

2023-04-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/org/org-macs.el (org--inhibit-version-check): Fix docstring

	Also, add an explanation to the docstring for what the version
	check is about.

2023-04-30  Eli Zaretskii  <eliz@gnu.org>

	Fix redisplay of mode line after its format changes from nil

	* src/dispnew.c (update_window): Make sure a mode-line's row of
	the current glyph matrix is disabled when the mode line is not
	being displayed.  (Bug#63186)

2023-04-30  Michael Albinus  <michael.albinus@gmx.de>

	Fix c-ts-mode--emacs-c-range-query

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--emacs-c-range-query):
	Check for (treesit-available-p).

2023-04-30  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of warnings

	* doc/lispref/control.texi (Errors):
	* doc/lispref/os.texi (Startup Summary):
	* doc/lispref/display.texi (Warning Basics, Warning Variables)
	(Warning Options, Delayed Warnings): Improve documentation of
	warnings.  Document the automatic delaying of warnings during
	startup.  (Bug#63181)

2023-04-29  Yuan Fu  <casouri@gmail.com>

	Fix FOR_EACH_TAIL fontification (bug#62951)

	Fix the fontification inconsistency between different FOR_EACH_TAIL's.
	See the comment for more explanation.  Also enable the emacs-devel
	feature automatically when c-ts-mode-emacs-sources-support is on.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--for-each-tail-regexp): Move up.
	(c-ts-mode--font-lock-settings): New font-lock rule for FOR_EACH_TAIL.
	(c-ts-mode--fontify-for-each-tail): New function.
	(c-ts-mode): Automatically enable emacs-devel feature.

2023-04-29  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of libxml-parse-* functions

	* doc/lispref/text.texi (Parsing HTML/XML):
	* src/xml.c (Flibxml_parse_html_region, Flibxml_parse_xml_region):
	Update the documentation regarding the use of BASE-URL argument.
	(Bug#63125)

2023-04-28  Theodor Thornhill  <theo@thornhill.no>

	Skip over whitespace in annotation-top-cont check (bug#63141)

	* lisp/progmodes/csharp-mode.el (csharp-guess-basic-syntax): Make sure
	we skip over whitespace when looking for the next '['.

2023-04-28  Ruijie Yu  <ruijie@netyu.xyz>

	Update zh-CN tutorial translation

	* etc/tutorials/TUTORIAL.cn (INTRO): Additions from English
	version; say "interrupt" not "quit" a partially-entered command;
	fixed minor inconsistency (English says partially-entered command,
	Chinese used to say partially-executed command -- they are
	different); converted half-width square brackets containing
	translators' notes into full-width ones for consistency.
	(BASIC CURSOR CONTROL): mention that a word boundary for Chinese
	can also be space; fixed incorrect terminology (keyboard vs
	terminal); retain English term "terminal"; retain English term
	"prefix argument"; "most commands _interpret_ prefix args as
	repeat-count", not "explain"; ensure space is added on both ends
	of an English word.
	(WINDOWS): Clarify it is the digit 1 in C-x 1.
	(INSERTING AND DELETING): Mention the term "continuation line" and
	retain its English term, because this term is mentioned again
	later in the tutorial; avoid saying the name of "\\"; add
	description for "electric" and a rough translation; sync English
	for prefix argument for DEL and C-d; ensure that translators'
	notes are marked explicitly so; add indentation to the instruction
	about continuation lines; additional translations such as
	mentioning C--, etc.
	(FILES): Re-pluralize the heading; space around English words;
	describe what C-g cancels (the command) when entering file name;
	replace "search for" with "find"; minor rephrasing; explicit
	translator notes; fixed the write-file message to no longer
	contain ellipses (see src/fileio.c:5541).
	(BUFFERS): Re-pluralize the heading; mention that C-x C-b also
	shows buffer name; C-x s only looks for file-visiting buffers.
	(EXTENDING THE COMMAND SET): Include C-x s and C-x b in list of
	learned commands.
	(MODE LINE): Remove the dashes in description on the point
	location.
	(MULTIPLE WINDOWS): Mention the difference between frame
	and window; also add translator notes pointing to end of
	tutorial which contains a terminology list.
	(MULTIPLE FRAMES): Change the M-x commands to keybinds C-x 5 2 and
	C-x 5 0 to sync with English.
	(GETTING MORE HELP): Change C-h f to C-h x, to sync with English.
	(INSTALLING PACKAGES): Rephrase "available packages", used to say
	lit., "existing", now says lit., "installable"; consistently
	translate the term "package", and retain its English name.
	(TRANSLATION): Add my name as co-maintainer of this file.

	* etc/tutorials/TUTORIAL.translators (TUTORIAL.cn): Add my name
	as co-maintainer for TUTORIAL.cn.

2023-04-28  Eli Zaretskii  <eliz@gnu.org>

	Fix eglot.texi

	* doc/misc/eglot.texi (Troubleshooting Eglot): Add missing @menu.
	(Performance, Getting the latest version): Improve wording and
	indexing, add cross-references.

2023-04-27  Po Lu  <luangruo@yahoo.com>

	Fix two crashes upon startup

	* src/image.c (image_create_bitmap_from_data)
	(image_create_bitmap_from_file): Specify a Window or a Pixmap
	describing the screen, not a back buffer drawable which may not exist.
	Otherwise, Emacs crashes on startup when a bitmap icon is in use.

2023-04-27  João Távora  <joaotavora@gmail.com>

	Eglot: explain how to update Eglot in manual (bug#62720)

	* lisp/progmodes/eglot.el (eglot-update): New command.

	* doc/misc/eglot.texi (Troubleshooting): Rework.

2023-04-27  João Távora  <joaotavora@gmail.com>

	Eglot: fix edge case when deleting inlay hint overlays

	When asked to update hints in a region (FROM TO),
	eglot--update-hints-1 first deletes the existing hints.  It must
	however take care to delete all overlays that logically belong to the
	region, even if they don't physically belong to it, e.g. inlay
	overlays spanning (FROM-1 FROM) and having a 'after-string' property.

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Fix edge case.

2023-04-27  Dmitry Gutov  <dmitry@gutov.dev>

	package-upgrade[-all]: Expand docstrings to note the current limitation

	* lisp/emacs-lisp/package.el (package-upgrade, package-upgrade-all):
	Expand docstrings to note the current limitation (bug#62720).

2023-04-27  Dmitry Gutov  <dmitry@gutov.dev>

	Rename all functions called package-*-update-* to package-*-upgrade-*

	* lisp/emacs-lisp/package-vc.el (package-vc-upgrade-all):
	Rename from 'package-vc-update-all'.
	(package-vc-upgrade): Rename from 'package-vc-update'.

	* lisp/emacs-lisp/package.el (package-upgrade):
	Rename from 'package-update' (bug#62750).
	(package--upgradeable-packages):
	Rename from 'package--updateable-packages'.
	(package-upgrade-all): Rename from 'package-update-all'.

2023-04-27  Yuan Fu  <casouri@gmail.com>

	Fix FOR_EACH_TAIL in c-ts-mode (bug#62951)

	* lisp/progmodes/c-ts-mode.el
	(c-ts-mode--indent-styles): New indent rule.

	(c-ts-mode--for-each-tail-regexp)
	(c-ts-mode--for-each-tail-body-matcher)
	(c-ts-mode--emacs-c-range-query)
	(c-ts-mode--for-each-tail-ranges)
	(c-ts-mode--reverse-ranges)
	(c-ts-mode--emacs-set-ranges): New functions and variables.

	(c-ts-mode): Create a emacs-c parser.  More setup for Emacs source
	support.

	* lisp/treesit.el (treesit-query-range): Ignore underscore-prefixed
	capture names.

2023-04-27  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (distclean): Remove the 'native-lisp' directory.

2023-04-27  Eli Zaretskii  <eliz@gnu.org>

	Improve greek-ibycus4 input method

	* lisp/leim/quail/greek.el ("greek-ibycus4"): Add another sequence
	for CAPITAL LETTER RHO WITH DASIA.  (Bug#63104)

2023-04-26  F. Jason Park  <jp@neverwas.me>

	Explain ERC 5.5 regressions in new version 5.5.0.29.1

	* doc/misc/erc.texi: Bump version to 5.5.0.29.1.
	* etc/ERC-NEWS: Don't hype bugged option `erc-reconnect-display'.
	* lisp/erc/erc-dcc.el (erc-dcc-do-GET-command): Add comment explaining
	parsing bug in ERC 5.5 (bug#62444).
	* lisp/erc/erc-networks.el (erc-networks-on-MOTD-end): Mention known
	/MOTD bug in error notice so people don't waste energy reporting
	it (bug#62151).
	* lisp/erc/erc.el: Change Version header to 5.5.0.29.1.  Don't bother
	updating the `customize-package-emacs-version-alist' entry
	because no option defaults are affected.
	(erc-version): Change version to 5.5.0.29.1.
	(erc-reconnect-display, erc-query-on-unjoined-chan-privmsg): Add
	warning to doc strings and `custom-set' functions.  It's believed that
	these bugs degrade the user experience significantly enough to warrant
	such mentions (bug#62833).
	(erc-query): Fix erroneous redirect string in deprecation spec.
	Do not merge to master.

2023-04-26  F. Jason Park  <jp@neverwas.me>

	* doc/misc/erc.texi: Elaborate on upgrading via ELPA.

2023-04-26  Robert Pluim  <rpluim@gmail.com>

	Improve outline-default-state docstring

	* lisp/outline.el (outline-default-state): Explain which functions are
	available to affect heading visibility.

2023-04-26  Eli Zaretskii  <eliz@gnu.org>

	Document problems with /bin/sh on Solaris 10

	* etc/PROBLEMS (Solaris): Document problems with '/bin/sh'.
	Suggested by Paul Eggert <eggert@cs.ucla.edu>.  (Bug#63067)

2023-04-25  Eli Zaretskii  <eliz@gnu.org>

	Followup to addition of TUTORIAL.fa

	* etc/NEWS: Announce addition of TUTORIAL.fa.

	* etc/tutorials/TUTORIAL.translators (TUTORIAL.fa): New entry.

	* lisp/language/misc-lang.el ("Persian"): Add tutorial property.

2023-04-25  Mohsen Banan  <form@mohsen.banan.1.byname.net>

	Add Farsi/Persian translation of the tutorial

	* etc/tutorials/TUTORIAL.fa: New file.

	* lisp/language/misc-lang.el (arabic-shaper-ZWNJ-handling): Fix
	typo in doc string.

2023-04-25  Eli Zaretskii  <eliz@gnu.org>

	Add Mongolian language environments

	* lisp/language/misc-lang.el ("Mongolian-traditional"):
	* lisp/language/cyrillic.el ("Mongolian-cyrillic"): New
	language environments.

	* etc/HELLO: Add Mongolian Traditional.
	* etc/NEWS: Announce the new language environments.

	(Bug#63028)

2023-04-25  Eli Zaretskii  <eliz@gnu.org>

	Document the 'end-session' event on MS-Windows

	* doc/lispref/commands.texi (Misc Events): Document the
	'end-session' event.  (Bug#63058)

2023-04-24  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.4-9-g8eb209

2023-04-24  Eli Zaretskii  <eliz@gnu.org>

	Don't support versioned grammar libraries on MS-Windows

	* src/treesit.c (treesit_load_language_push_for_each_suffix):
	Don't append ".0.0" on WINDOWSNT.

2023-04-24  Yuan Fu  <casouri@gmail.com>

	Accept versioned tree-sitter language grammar files

	By discussion on emacs-devel, titled "Versioned Tree-sitter parser
	libraries".

	* src/treesit.c (Vtreesit_str_dot_0): New variable.
	(treesit_load_language_push_for_each_suffix): Additionally look for
	lib_base_name.0 and lib_base_name.0.0.
	(syms_of_treesit): Initialize Vtreesit_str_dot_0.

2023-04-24  Benson Chu  <bensonchu457@gmail.com>  (tiny change)

	tab-bar-new-tab: inhibit side-window checks

	Previously, calling 'tab-bar-new-tab-to' only removed the
	'window-side' property on the currently selected window,
	and then a call to 'delete-other-windows' was made to
	ensure that the selected window was the only window.
	We can skip this check by shadowing 'window--sides-inhibit-check'
	to t.
	* lisp/tab-bar.el (tab-bar-new-tab-to): Inhibit side-window checks.
	(Bug#62427)

2023-04-24  Michael Albinus  <michael.albinus@gmx.de>

	* etc/NEWS: Fix outline level.  (Bug#63042)

	Fix typos.

2023-04-23  Eli Zaretskii  <eliz@gnu.org>

	Fix rendering of Traditional Mongolian script

	* lisp/international/characters.el: Set punctuation syntax for Po
	characters from the Mongolian block
	* lisp/international/fontset.el (setup-default-fontset): Add
	fontset setting for Traditional Mongolic.
	* lisp/language/misc-lang.el (composition-function-table): Add
	rules for Traditional Mongolic.  (Bug#63028)

2023-04-22  Eli Zaretskii  <eliz@gnu.org>

	Fix line-number-at-pos when POSITION is out of narrowing

	* src/fns.c (Fline_number_at_pos): Don't signal an error when
	ABSOLUTE is nil and POSITION is outside of the narrowing, like the
	original Lisp implementation did.  Minor speedup by using the byte
	position where it is available from the get-go.  (Bug#62857)

2023-04-22  Eli Zaretskii  <eliz@gnu.org>

	Fix exiting Emacs after saving a tutorial

	* lisp/tutorial.el (tutorial--starting-point): Make it
	permanent-local, so that saving the tutorial to some file doesn't
	kill this buffer-local variable.  Otherwise, trying to exit Emacs
	after saving the tutorial will signal an error, because
	'tutorial--starting-point' is void.  (Bug#37326)

2023-04-22  Eli Zaretskii  <eliz@gnu.org>

	Add indentation style setting for c-ts-mode in .dir-locals.el

	* lisp/progmodes/c-ts-mode.el (c-ts-indent-style-safep): New
	predicate.
	(c-ts-mode-indent-style): Use it to test the value for being safe.

	* .dir-locals.el (c-ts-mode): Set 'c-ts-mode-indent-style' to 'gnu'.

2023-04-20  Nicolas Martyanoff  <nicolas@n16f.net>

	sql: add missing postgresql types

	* lisp/progmodes/sql.el: Add multiple missing PostgreSQL types: bigserial,
	smallserial, macaddr8, jsonb, jsonpath, built-in range types, object
	identifier types (oid & co).

2023-04-19  Eli Zaretskii  <eliz@gnu.org>

	Fix display of menu-bar bindings of commands in *Help* buffers

	* lisp/help-fns.el (help-fns--insert-menu-bindings): Propertize
	with 'help-key-binding' face only the menu items, not the arrows
	between successive items.  This is because 'char-displayable-p' is
	unreliable when we propertize the character with an arbitrary
	face: that face could specify a font which doesn't support the
	character after all, while 'char-displayable-p' assumes there are
	no restrictions on fonts that can be used for displaying the
	character.  Also, make the code more efficient by avoiding the
	call to 'char-displayable-p' inside the loop.

2023-04-19  Spencer Baugh  <sbaugh@janestreet.com>

	Improve Completion Example section in the Emacs manual

	This can be a useful substitute for full-on fuzzy completion, as
	provided by other completion styles and completion packages.
	* doc/emacs/mini.texi (Completion Example): Give an example of
	completion with point not at end of minibuffer.  Also, use
	@kbd{@key{TAB}} when telling the user to hit TAB.  (Bug#62836)

2023-04-19  Robert Pluim  <rpluim@gmail.com>

	Improve 'message-server-alist' docstring

	* lisp/gnus/message.el (message-server-alist): Fix typo and clarify
	what happens if there is already an X-Message-SMTP-Method header.

2023-04-19  Robert Pluim  <rpluim@gmail.com>

	Add index entry for fallback modes

	* doc/emacs/custom.texi (Specifying File Variables): Add index for
	'fallback modes'.

2023-04-18  Dmitry Gutov  <dmitry@gutov.dev>

	xref-search-program-alist: Fix searching larger file lists on MS Windows

	* lisp/progmodes/xref.el (xref-search-program-alist):
	Add '-s 10000' to xargs' options when on Windows or DOS.
	Apparently the xargs port doesn't currently know how to obey the
	system-wide limits (https://debbugs.gnu.org/bug=61667#521).

2023-04-18  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Fix typo and inaccuracy in the ELisp Reference manual

	* doc/lispref/loading.texi (Dynamic Modules): Fix a typo.
	* doc/lispref/customize.texi (Group Definitions): Faces are also
	in the 'custom-group' property of a customization group.
	(Bug#62887)

2023-04-18  Eli Zaretskii  <eliz@gnu.org>

	Fix description of lexical environment's internals

	* doc/lispref/variables.texi (Lexical Binding): Update the
	description of how the lexical environment is represented
	internally.  (Bug#62840)

2023-04-16  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.4-2-g0f6ae7

2023-04-16  Eli Zaretskii  <eliz@gnu.org>

	Documentation copyedits for 'package-install-upgrade-built-in' etc

	* etc/NEWS: More details about the new option
	'package-install-upgrade-built-in'.

	* lisp/emacs-lisp/package.el (package-install-upgrade-built-in)
	(package--active-built-in-p, package-install): Doc fixes.
	(Bug#62720)

2023-04-16  Philip Kaludercic  <philipk@posteo.net>

	Allow upgrading built-in packages with 'package-install'

	* etc/NEWS: Mention the change
	* lisp/emacs-lisp/package.el (package--upgradable-built-in-p): Add new
	predicate.
	(package-install-upgrade-built-in): Add new user option to enable
	feature.
	(package-install): Respect new user option.

2023-04-16  Eli Zaretskii  <eliz@gnu.org>

	Minor changes in c-ts-mode.el's support of DEFUNs

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--fontify-DEFUN): Renamed
	from 'c-ts-mode--fontify-defun'; all callers changed.
	(c-ts-mode-emacs-sources-support): Renamed from
	'c-ts-mode-emacs-devel' and made into a defcustom; all users
	changed.
	(c-ts-mode--emacs-defun-p, c-ts-mode--emacs-defun-at-point)
	(c-ts-mode--emacs-current-defun-name): Doc fixes.  (Bug#62825)

2023-04-16  Eli Zaretskii  <eliz@gnu.org>

	Fix strike-through attribute support on TTY frames

	* src/term.c (init_tty): Fix setting the strike-through capability
	with "smxx".  (Bug#62265)

2023-04-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in 'describe-keymap' due to shadowing

	* src/keymap.c (describe_vector): Handle shadowing by something
	other than a symbol.  (Bug#62867)

2023-04-15  Andreas Schwab  <schwab@linux-m68k.org>

	Make image-map bindings available on image links

	* lisp/net/shr.el (shr-map): Move shr-browse-image to "M-i".
	* lisp/net/eww.el (eww-image-link-keymap): Use shr-image-map.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	* CONTRIBUTE: Fix a typo

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Add to Eglot support for additional language-servers.

	* lisp/progmodes/eglot.el (eglot-server-programs): Add
	'vscode-markdown-language-server' for Markdown and
	'dot-language-server' for GraphViz.  (Bug#62844)

2023-04-14  Yuan Fu  <casouri@gmail.com>

	Partial support for DEFUN in c-ts-mode (bug#62825)

	The DEFUN is hard to incorporate because it's made of two nodes rather
	than one, and most tree-sitter functionalities assume a defun is one
	node.  I fixed the indent-defun and add-log functionality, but
	beginning/end-of-defun and imenu still don't recognize DEFUN.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-emacs-devel): New variable.
	(c-ts-mode--defun-name): Support DEFUN.
	(c-ts-mode--defun-valid-p): Support DEFUN.
	(c-ts-mode--emacs-defun-p)
	(c-ts-mode--emacs-defun-at-point): New functions.
	(c-ts-mode-indent-defun): Use c-ts-mode--emacs-defun-at-point.
	(c-ts-mode--emacs-current-defun-name): New function.
	(c-ts-mode, c++-ts-mode): Optionally setup custom defun-name function.

2023-04-14  Eli Zaretskii  <eliz@gnu.org>

	Fix style and unwinding code in treesit.c

	This was supposed to be a cherry-pick from master, but
	isn't, due to the unnecessary rush to fix master without
	cleaning up the mess first and without separating changes
	that can and cannot be backported.
	* src/treesit.c (treesit_traverse_cleanup_cursor): Fix indentation
	style.
	(Ftreesit_search_subtree, Ftreesit_search_forward)
	(Ftreesit_induce_sparse_tree): Fix specpdl unwinding.  (Bug#62823)
	Do not merge to master.

2023-04-14  Yuan Fu  <casouri@gmail.com>

	Catch signals produced by PRED in tree-sitter search functions

	Earlier we switched to using cursors rather than nodes to traverse the
	parse tree.  Because cursors need cleanup, we have to catch signals
	thrown by the predicate functions and free the cursor. Failing to do
	this will result in leaking the cursor whenever the predicate function
	signals in a search function.  This change fixes the leak.
	* src/treesit.c (treesit_traverse_cleanup_cursor): New function.
	(Ftreesit_search_subtree)
	(Ftreesit_search_forward)
	(Ftreesit_induce_sparse_tree): Catch signals.  (Bug#62823)

	(cherry picked from commit a5eb9f6ad4e6f5a2819b540a477f1e889f6ef355)

2023-04-13  Eli Zaretskii  <eliz@gnu.org>

	Fix compilation of w32.c with old MinGW system headers

	* src/w32.c (CONSOLE_FONT_INFO): Make sure the definition is not
	visible for MinGW versions whose w32api's version is before 5.2.0.
	(Bug#52792)

2023-04-12  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-add-log-current-method: Reduce the use of 'nreverse'

	* lisp/progmodes/ruby-mode.el (ruby-add-log-current-method):
	Reduce the use of 'nreverse' (bug#62761).

	* test/lisp/progmodes/ruby-mode-tests.el
	(ruby-add-log-current-method-singleton-referencing-outer):
	New test.

2023-04-12  Visuwesh  <visuweshm@gmail.com>

	Fix detection of WebP images by their signature

	* lisp/image.el (image-type-header-regexps): The 4 characters
	between "RIFF" and "WEBP" in WebP images can also be newlines.
	(Bug#62790)

2023-04-12  Earl Hyatt  <okamsn@protonmail.com>

	Add more documentation for the keys of `package-vc-selected-packages`.

	* doc/emacs/package.texi (Specifying Package Sources): List the
	accepted keys in a new subsection of Fetching Package Sources.

	* lisp/emacs-lisp/package-vc.el (package-vc-selected-packages):
	Mention the `:doc` key.  Add the `:doc` key to the Customize form,
	mention the new Info node, correct "TexInfo" to "Texinfo", avoid
	Git-specific terms for the description of `:branch`, mention guessing
	`:vc-backend` based on the URL.

2023-04-11  Dmitry Gutov  <dgutov@yandex.ru>

	vc-checkout: Try to use the vc-dir's backend first

	* lisp/vc/vc.el (vc-checkout): Try to use the vc-dir's backend
	before looking for the file's one.  The latter doesn't work when
	the file doesn't exist on disk yet (bug#62674).

2023-04-11  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation related to 'ispell-complete-word'

	* lisp/textmodes/ispell.el (ispell-alternate-dictionary)
	(ispell-complete-word-dict, ispell-complete-word): Doc fixes.
	(Bug#62775)

2023-04-11  Po Lu  <luangruo@yahoo.com>

	* configure.ac: Add -lbsd on Haiku.

2023-04-11  Eli Zaretskii  <eliz@gnu.org>

	Add menu to 'c-ts-mode' and 'c++-ts-mode'

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-menu): New menu.

2023-04-11  Mattias Engdegård  <mattiase@acm.org>

	Update manual about `sort`

	* doc/lispref/sequences.texi (Sequence Functions):
	Remove inaccurate and over-specific claims about how `sort` works for
	lists: there is no guarantee that it doesn't modify the `car` fields
	of the input list (which is precisely what it does at this time).

	(cherry picked from commit c753a9592345e2084d69e9e2cc458c16db2e4141)

2023-04-11  Eli Zaretskii  <eliz@gnu.org>

	Fix wallpaper-tests on MS-Windows

	* test/lisp/image/wallpaper-tests.el (wallpaper--find-setter)
	(wallpaper--find-setter/call-predicate)
	(wallpaper--find-setter/set-current-setter)
	(wallpaper-set/calls-init-action)
	(wallpaper-set/calls-wallpaper-set-function)
	(wallpaper-set/runs-command, wallpaper-set/runs-command/detach):
	Skip these tests if native functions are used for changing
	wallpaper.  These tests are irrelevant in that case.

2023-04-11  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix a couple of eglot-tests

	* test/lisp/progmodes/eglot-tests.el
	(eglot-test-rust-analyzer-watches-files): Bump timeout.
	(eglot-test-json-basic): Check for yas-minor-mode before using it,
	like other tests do (bug#61637).

2023-04-10  Eli Zaretskii  <eliz@gnu.org>

	Fix visiting RPM files

	We cannot call 'sh-set-shell' inside 'sh-base-mode', since various
	settings of 'sh-mode', in particular the syntax table, is not yet
	set.  Likewise with various hooks: since 'sh-base-mode' is not a
	mode any file should be visited with, it makes no sense to set up
	stuff like 'hack-local-variables-hook' in 'sh-base-mode'; it
	should be set in the descendant modes instead.
	* lisp/progmodes/sh-script.el (sh-base-mode): Move the call to
	'sh-set-shell' from here...
	(sh-mode): ...to here...
	(bash-ts-mode): ...with a copy here.  (Bug#62748)

2023-04-10  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix ff-quiet-mode doc

	* lisp/find-file.el (ff-quiet-mode, ff-find-other-file): Say that
	ff-quiet-mode disables tracing, not the inverse.

2023-04-01  Gregory Heytings  <gregory@heytings.org>

	Another final fix to last changes

	* src/xdisp.c (get_small_narrowing_begv): Refine the value of 'bol_pos'.

2023-04-01  Gregory Heytings  <gregory@heytings.org>

	Three final fixes to last changes

	* src/xdisp.c (get_nearby_bol_pos): Initialize 'bol' to BEGV - 1
	instead of 0 (which fixes cursor motion commands in the presence
	of a narrowing), adapt the return condition accordingly, and do
	not restart the loop when BEGV has been reached.
	(get_small_narrowing_begv): Use correct type.

2023-04-01  Gregory Heytings  <gregory@heytings.org>

	Two further fixes to last changes

	* src/xdisp.c (get_narrowed_width): Use FRAME_WINDOW_P instead of
	Fterminal_live_p.  Also take WINDOW_LEFT_FRINGE_WIDTH into
	account.

2023-04-01  Gregory Heytings  <gregory@heytings.org>

	Improve and fix last changes

	* src/xdisp.c (get_narrowed_width): Use WINDOW_RIGHT_FRINGE_WIDTH,
	which works both for character-only terminals and for GUI frames
	without fringes.
	(get_nearby_bol_pos): Instead of searching for BOL in
	[pos-500000..pos], gradually extend the region, starting with
	[pos-500..pos].  This is much faster in buffers with some long
	lines in the middle of lots of short lines.

2023-03-29  Gregory Heytings  <gregory@heytings.org>

	Fix cursor motion in character-only terminals

	* src/xdisp.c (get_narrowed_width): Subtract 1 from
	window_body_width to account for the '\' line wrapping indication.

2023-03-28  Gregory Heytings  <gregory@heytings.org>

	Make get_medium_narrowing_begv/zv static

	* src/xdisp.c (get_medium_narrowing_begv):
	(get_medium_narrowing_zv): Make these two functions static, they
	are only used in xdisp.c.

	* src/dispextern.h: Remove the prototypes.

2023-03-28  Gregory Heytings  <gregory@heytings.org>

	Improve accuracy of cursor motion commands in long lines

	* src/xdisp.c (get_nearby_bol_pos): New function.
	(get_small_narrowing_begv): Use it.  This makes cursor motion
	commands much more accurate in the first 500K characters of each
	long line.

2023-03-28  Gregory Heytings  <gregory@heytings.org>

	Remove labeled restrictions before calling Fwiden

	* src/editfns.c (labeled_restrictions_remove_in_current_buffer):
	New function.

	* src/lisp.h: Make it externally visible.

	* src/xdisp.c (display_count_lines_logically):
	* src/lread.c (readevalloop):
	* src/indent.c (line_number_display_width):
	* src/fileio.c (write_region):
	* src/callproc.c (Fcall_process_region):
	* src/buffer.c (Ferase_buffer): Use it.

2023-03-28  Gregory Heytings  <gregory@heytings.org>

	Code cleanup for long line optimizations

	This commit does not change any code, it merely renames functions
	and clarifies the documentation, to make the code hopefully easier
	to grasp.

	* src/dispextern.h (struct it): Rename the 'narrowed_begv',
	'narrowed_zv', 'locked_narrowing_begv', 'locked_narrowing_zv' to
	'medium_narrowing_begv', 'medium_narrowing_zv',
	'large_narrowing_begv', 'large_narrowing_zv'.  Clarify the
	comments.
	Update the prototypes of the functions renamed in xdisp.c.

	* src/lisp.h: Update the prototypes of the functions renamed in
	editfns.c.  Remove the prototype of
	'safe_run_hooks_maybe_narrowed', which is used only in keyboard.c.

	* src/xdisp.c
	(get_small_narrowing_begv): Renamed from
	'get_closer_narrowed_begv'.
	(get_medium_narrowing_begv): Renamed from 'get_narrowed_begv'.
	(get_medium_narrowing_zv): Renamed from 'get_narrowed_zv'.
	(get_large_narrowing_begv): Renamed from 'get_locked_narrowing_begv'.
	(get_large_narrowing_zv): Renamed from 'get_locked_narrowing_zv'.
	(SET_WITH_NARROWED_BEGV): Use the new field names.
	(handle_fontified_prop): Use the new function and new field names.
	(back_to_previous_line_start): Use the new field name.
	(back_to_previous_visible_line_start): Use the new field name.
	(reseat): Use the new function and new field names.
	(get_visually_first_element): Use the new field name.
	(move_it_vertically_backward): Use the new function name.
	(redisplay_internal): Use the new function name.
	Also add a large comment to explain how Emacs deals with long lines.

	* src/keyboard.c:
	(safe_run_hooks_maybe_narrowed): Use the new function names from
	xdisp.c and editfns.c.  Make the function static, and add a
	prototype.

	* src/editfns.c:
	(labeled_restrictions): Renamed from 'narrowing_locks'.
	(labeled_restrictions_add): Renamed from 'narrowing_locks_add'.
	(labeled_restrictions_remove): Renamed from
	'narrowing_locks_remove'.
	(labeled_restrictions_get_bound): Renamed from
	'narrowing_lock_get_bound'.
	(labeled_restrictions_peek_label): Renamed from
	'narrowing_lock_peek_tag'.
	(labeled_restrictions_push): Renamed from 'narrowing_lock_push'.
	(labeled_restrictions_pop): Renamed from 'narrowing_lock_pop'.
	(unwind_reset_outermost_restriction): Renamed from
	'unwind_reset_outermost_narrowing'.
	(reset_outermost_restrictions): Renamed from
	'reset_outermost_narrowings'.
	(labeled_restrictions_save): Renamed from 'narrowing_locks_save'.
	(labeled_restrictions_restore): Renamed from
	'narrowing_locks_restore'.
	(unwind_labeled_narrow_to_region): Renamed from
	'unwind_narrow_to_region_locked'.
	(labeled_narrow_to_region): Renamed from
	'narrow_to_region_locked'.
	(Finternal__label_restriction): Renamed from
	'Finternal__lock_narrowing'.
	(Finternal__unlabel_restriction): Renamed from
	'Finternal__unlock_narrowing'.
	(Fwiden): Use the new function names.
	(Fnarrow_to_region): Use the new function names.
	(save_restriction_save): Use the new function names.
	(syms_of_editfns): Use the new function names.
	<outermost-restriction>: Renamed from 'outermost-narrowing'.

	* lisp/subr.el (internal--with-restriction): Use the new internal
	function name.
	(internal--without-restriction): Use the new internal function
	name.

	* src/composite.c (composition_compute_stop_pos):
	(find_automatic_composition): Use the new function name.

	* doc/lispref/positions.texi (Narrowing): Add index entry.

2023-04-10  Eli Zaretskii  <eliz@gnu.org>

	* lisp/ldefs-boot.el: Regenerate.

2023-04-10  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version to 29.0.90

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump version to 29.0.90.

2023-04-09  Dmitry Gutov  <dgutov@yandex.ru>

	Fix some cases of incomplete code's indentation [c/c++-ts-mode]

	* lisp/progmodes/c-ts-mode.el (c-ts-base--before-indent): Try to
	guess when the parse tree is incomplete, and provide a better node
	to indent against (bug#62717).
	(c-ts-base-mode): Set up advice for local treesit-indent-function.

2023-04-09  Dmitry Gutov  <dgutov@yandex.ru>

	project-search: Pipe the list of files through 'file-regular-p'

	* lisp/progmodes/project.el (project-search): Pipe the list of
	files through 'file-regular-p' to skip directories (bug#62735).

2023-04-09  Eli Zaretskii  <eliz@gnu.org>

	Update ChangeLog and AUTHORS for Emacs 29

	* admin/authors.el: Update for Emacs 29.

	* etc/AUTHORS: Re-generate for Emacs 29.

	* ChangeLog.4: New generated file.
	* Makefile.in (PREFERRED_BRANCH): Update to emacs-29.
	(CHANGELOG_HISTORY_INDEX_MAX): Bump to 4.

2023-04-09  João Távora  <joaotavora@gmail.com>

	Backport: Eglot: no more tests based on Pylsp (bug#62694)

	The functionality under test in eglot.el is exactly the same, but use
	the clangd server only, as that is used in more tests, and it is much
	easier to check if it misbehaves or not.

	Tests pass with clangd version 15.

	* test/lisp/progmodes/eglot-tests.el (python): Don't require it.
	(eglot--call-with-fixture): Simplify.
	(eglot--wait-for-clangd): New helper.
	(eglot-test-basic-completions)
	(eglot-test-non-unique-completions, eglot-test-basic-xref)
	(eglot-test-snippet-completions)
	(eglot-test-snippet-completions-with-company)
	(eglot-test-eldoc-after-completions, eglot-test-multiline-eldoc):
	Use clangd, not pylsp.
	(eglot-test-formatting): Renamed from
	eglot-test-python-autopep-formatting.
	(eglot-test-python-yapf-formatting): Remove.

	(cherry picked from commit fc8230f3362b12955152f48565a6c670b4c4cc88)

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Fix 'C-h k' for "Paste from Kill Menu" in context menus

	* lisp/mouse.el (context-menu-region): Make the entries be
	symbols, not just integers, to prevent "C-h c" from interpreting
	them as character keys.  (Bug#62626)

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Improve the documentation of the XDS support

	* doc/lispref/frames.texi (Drag and Drop): Rephrase and rearrange
	the documentation of XDS support.  Add indexing.  Document
	'x-dnd-save-direct' and 'x-dnd-save-direct-immediately'.  Original
	patch from Po Lu <luangruo@yahoo.com>.

	* lisp/x-dnd.el (x-dnd-types-alist, x-dnd-test-function)
	(x-dnd-default-test-function, x-dnd-direct-save-function): Doc
	fixes.
	(x-dnd-save-direct, x-dnd-save-direct-immediately): Rename the
	second argument to FILENAME.  Doc fix.

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Allow reindentation of images inserted by 'mm-inline-image'

	* lisp/gnus/mm-view.el (mm-inline-image): Use "x" as text on which
	to put the image 'display' property, so that indentation commands
	don't destroy the image inadvertently.  (Bug#62637)

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Fix "C-h k" and "C-h c" with Paste from Kill Menu

	* lisp/subr.el (event-basic-type, event-modifiers): Return nil if
	EVENT is a string.  (Bug#62626)

2023-04-08  Daniel Martín  <mardani29@yahoo.es>

	Change cursor color on NS port when it matches the face background

	* src/macfont.m (CG_SET_FILL_COLOR_WITH_FRAME_CURSOR): New macro.
	(CG_SET_FILL_COLOR_WITH_FRAME_BACKGROUND): New macro.
	(macfont_draw): When the cursor's color matches the face background,
	set the fill color of the cursor to the face foreground.
	* src/nsterm.m (ns_maybe_dumpglyphs_background): When dumping the
	background of a glyph string, apply the logic mentioned
	above.  (Bug#62573)

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of image-related commands

	* lisp/image.el (image-map): Make it inherit from
	'image-slice-map' instead of repeating the bindings.

	* doc/emacs/files.texi (Image Mode): Document the key bindings set
	by 'insert-image'.  Add indexing.

	* doc/lispref/display.texi (Showing Images): Make the description
	of user commands more concise.  Add index entries and
	cross-reference to the Emacs manual.

	* etc/NEWS: Rearrange entries relevant to image commands.

2023-04-08  Eli Zaretskii  <eliz@gnu.org>

	Fix handling of sliced images

	* lisp/image.el (image-slice-map): New keymap, without some
	bindings that make no sense with sliced images.
	(insert-image, insert-sliced-image): Use it.
	(insert-sliced-image): Make the 'keymap' property rear-nonsticky,
	to prevent calling image commands when point is to the right of
	the slice.  (Bug#62679)

	* lisp/image/image-crop.el (image-cut, image-crop): Doc fixes.
	(image-crop): Don't try using stock MS-Widows convert.exe
	program.  Use 'image--get-image' to support sliced images.

2023-04-08  garid3000  <garidzorigoo@gmail.com>

	Add cyrillic-mongolian input method

	* lisp/leim/quail/cyrillic.el (cyrillic-mongolian): New input
	method.  (Bug#56617)

2023-04-07  João Távora  <joaotavora@gmail.com>

	Jsonrpc: don't bind inhibit-read-only to t so early

	Related to https://github.com/joaotavora/eglot/discussions/1202, where
	because of this very wide binding to inhibit-read-only to t, Eglot was
	managing to write into read-only buffers from the response handlers
	that ran from within the stack of the jsonrpc.el process filter.

	This is of course illegal and dangerous, but Eglot wasn't made aware
	because of the binding.

	* lisp/jsonrpc.el (jsonrpc--process-filter): Don't bind
	inhibit-read-only so early.

2023-04-07  Eli Zaretskii  <eliz@gnu.org>

	Allow active region when IM is used

	* lisp/international/quail.el (quail-minibuffer-message): Bind
	deactivate-mark to allow setting active region in the minibuffer
	when an input method is used.  (Bug#62709)

2023-04-06  Robert Pluim  <rpluim@gmail.com>

	Add emoji-zoom-reset

	* lisp/international/emoji.el (emoji-zoom-map): Add emoji-zoom-reset.
	(emoji-zoom-reset): New function, it resets the zoom level.
	* lisp/international/mule-cmds.el (ctl-x-map): Add emoji-zoom-reset.
	* etc/NEWS: Announce new command.

2023-04-06  Robert Pluim  <rpluim@gmail.com>

	Make emoji-zoom-{increase,decrease} set text properties correctly

	* lisp/international/emoji.el (emoji-zoom-increase): Ensure that we're
	increasing the :height of the anonymous face at point, rather than
	having two :height properties, which appeared to work by
	accident, and don't error at eob.  (Bug#62675)

2023-04-06  Eli Zaretskii  <eliz@gnu.org>

	Fix transforming sliced images

	* lisp/image.el (image--get-image): Support sliced images
	(bug#62679).  Doc fix.
	(image-mouse-decrease-size, image-mouse-increase-size)
	(image-decrease-size, image-increase-size): Doc fixes.

2023-04-04  Michael Albinus  <michael.albinus@gmx.de>

	Adapt EMBA scripts.

	* test/infra/Dockerfile.emba (emacs-gnustep): Add zlib1g-dev.
	Remove make instrumentation.

	* test/infra/gitlab-ci.yml (build-image-gnustep, test-gnustep): Uncomment.

2023-04-04  Eli Zaretskii  <eliz@gnu.org>

	Another terminology fix in ELisp reference manual

	* doc/lispref/frames.texi (Mouse Tracking):
	* doc/lispref/commands.texi (Motion Events, Event Examples):
	'track-mouse' is a macro, not a special form.

2023-04-04  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Correct terminology in Elisp Reference Manual

	* doc/lispref/functions.texi (Function Names): 'defun' is a macro, not
	a special form.  (Bug#62661)

2023-04-04  Michael Albinus  <michael.albinus@gmx.de>

	Comment out GNUSTEP jobs on EMBA (again)

	* test/infra/gitlab-ci.yml (build-image-gnustep, test-gnustep):
	Comment out jobs due to bug#62210.

2023-04-03  Mattias Engdegård  <mattiase@acm.org>

	Fix regexp string escaping mistake in vhdl-mode.el (bug#62508)

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Quote brackets
	correctly.

2023-04-02  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.3-2-gf2949d

2023-04-02  João Távora  <joaotavora@gmail.com>

	Eglot: don't watch directories that don't exist

	project-files isn't guaranteed to return existing files, so better
	check if they exist because placing a watcher on them.

	Originally reported at:
	https://github.com/joaotavora/eglot/issues/1198

	* lisp/progmodes/eglot.el (eglot-register-capability
	workspace/didChangeWatchedFiles): Check if directories exist.

2023-04-02  Eshel Yaron  <me@eshelyaron.com>

	Preserve peer information for web page in eww-readable

	The :peer property in eww-data affects the face of the page title
	in 'header-line-format' as set by 'eww-update-header-line-format'.
	Preserving this property in eww-readable avoids having the header
	line's appearance change when this command is called.
	* lisp/net/eww.el (eww-readable): Preserve eww-data's :peer
	property.  (Bug#62574)

2023-04-02  Eli Zaretskii  <eliz@gnu.org>

	* lisp/subr.el (use-dialog-box-p): Fix conditions for GUI dialogs.

2023-04-01  Eli Zaretskii  <eliz@gnu.org>

	Fix ModelSim error regexp in vhdl-mode

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Fix ModelSim
	error regexp.  Suggested by Reto Zimmermann <reto@gnu.org>.
	(Bug#62508)

2023-04-01  Eli Zaretskii  <eliz@gnu.org>

	Document enhancements in handling of echo-area messages

	* etc/NEWS:
	* doc/lispref/display.texi (Displaying Messages):
	* lisp/minibuffer.el (inhibit-message-regexps)
	(set-message-functions, inhibit-message, set-multi-message):
	Improve the documentation of functions dealing with display of
	echo-area messages.

2023-04-01  Eli Zaretskii  <eliz@gnu.org>

	Fix new Eshell tests on MS-Windows

	* test/lisp/eshell/eshell-tests.el (eshell-test/eshell-command/background)
	(eshell-test/eshell-command/background-pipeline): Allow for ".exe"
	in the program's name.  This fixes these tests on MS-Windows.

2023-03-31  Jim Porter  <jporterbugs@gmail.com>

	Fix using background commands in 'eshell-command'

	Do not merge to master.

	This regressed due to the patch for bug#53715, which changed how
	Eshell pipelines return the processes in the pipeline (bug#62556).

	* lisp/eshell/esh-cmd.el (eshell-eval-command): Allow process-pairs.

	* test/lisp/eshell/eshell-tests.el (eshell-test/eshell-command/simple)
	(eshell-test/eshell-command/pipeline)
	(eshell-test/eshell-command/background)
	(eshell-test/eshell-command/background-pipeline): New tests.

2023-03-31  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Fix typo in section 14.1 of Emacs Manual

	* doc/emacs/display.texi (Scrolling): Fix typo.  (Bug#62569)

2023-03-30  João Távora  <joaotavora@gmail.com>

	Eglot: unbreak eglot-extend-to-xref on w32

	Because of a drive-letter casing mismatch between 'buffer-file-name'
	and the return value of 'url-generic-parse-url', the hash-table test
	'equal' in 'eglot-current-server' failed.

	This failed to recognize that the file xref landed us on really is
	managed by the language server that facilitated that jump.

	The function w32-long-file-name seems to convert "C:/Users/" to
	"c:/Users" consistently and so is a good addition to
	eglot--uri-to-path.

	* lisp/progmodes/eglot.el (eglot--uri-to-path): Use
	w32-long-file-name.

2023-03-30  João Távora  <joaotavora@gmail.com>

	Eglot: ensure server shutdown turns off eglot-inlay-hints-mode

	* lisp/progmodes/eglot.el (eglot--managed-mode-off): Turn off
	eglot-inlay-hints-mode.

2023-03-30  Yuan Fu  <casouri@gmail.com>

	Add two typescript-ts-mode faces (bug#62429)

	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode-jsx-tag-face)
	(typescript-ts-mode-jsx-attribute-face): New faces.
	(typescript-ts-mode--font-lock-settings): Use new faces.
	(tsx-ts-mode): Mention the new faces in the docstring.

2023-03-30  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Fix scrolling window when point moves up

	This fixes the case when both 'scroll-conservatively' and
	'scroll-step' are customized to non-default values.
	* src/xdisp.c (try_scrolling): Fix precedence between
	'scroll-step' and 'scroll-conservatively' when scrolling with
	'previous-line'.  (Bug#62530)

2023-03-30  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'defcustom's :set keyword

	* lisp/custom.el (defcustom):
	* doc/lispref/customize.texi (Variable Definitions): Improve the
	documentation of the :set keyword in 'defcustom'.

2023-03-29  Andrea Corallo  <akrl@sdf.org>

	Comp fix calls to redefined primtives with op-bytecode (bug#61917)

		* test/src/comp-tests.el (61917-1): New test.
		* src/comp.c (syms_of_comp): New variable.
		* lisp/loadup.el: Store primitive arities before dumping.
		* lisp/emacs-lisp/comp.el (comp--func-arity): New function.
		(comp-emit-set-call-subr): Make use of `comp--func-arity'.

2023-03-29  Eli Zaretskii  <eliz@gnu.org>

	Fix duplicate defcustom in eww.el

	* lisp/net/eww.el (eww-default-download-directory): Renamed back
	from 'eww-download-directory'; all users changed.  Doc fix.
	(Bug#62531)

2023-03-29  Eli Zaretskii  <eliz@gnu.org>

	Fix indentation regression in 'C-h l'

	* lisp/help.el (view-lossage): Fix indentation of commands
	when the key sequence includes a semicolon.  (Bug#62453)

2023-03-29  Michael Albinus  <michael.albinus@gmx.de>

	* doc/misc/tramp.texi (Remote shell setup): Clarify use of ssh RemoteCommand.

2023-03-28  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'read-choice' and related symbols

	* doc/lispref/commands.texi (Reading One Event):
	* lisp/subr.el (read-char-choice-use-read-key, read-char-choice)
	(read-char-choice-with-read-key, y-or-n-p-use-read-key): Improve
	documentation of these functions and variables.

2023-03-28  Andrea Corallo  <akrl@sdf.org>

	Revert "Comp fix calls to redefined primtives with op-bytecode (bug#61917)"

	This reverts commit 263d6c38539691c954f4c3057cbe8d5468499b91.

	These patch series caused a number of regression and more analysis is
	required.

2023-03-28  Andrea Corallo  <akrl@sdf.org>

	Revert "* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Improve..."

	This reverts commit 4a7a0c9a9f521b04b23580901e9c0a662b504e32.

	These patch series caused a number of regression and more analysis is
	required.

2023-03-28  Michael Albinus  <michael.albinus@gmx.de>

	Skip ruby-ts-imenu-index test if needed

	* test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-imenu-index):
	Add check for treesitter.

2023-03-28  Michael Albinus  <michael.albinus@gmx.de>

	Fix Eglot Tramp tests on EMBA

	* test/lisp/progmodes/eglot-tests.el (eglot--call-with-tramp-test):
	Bind `tramp-allow-unsafe-temporary-files' with t.  (Bug#62289)

2023-03-28  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-gnustep): Instrument "make V=1 ...".

2023-03-27  João Távora  <joaotavora@gmail.com>

	Fix accidental backward-incompatible change (bug#62417)

	This code used to work, but with the change of 59ecf25fc860 it stopped
	working:

	   (defun foop (buffer-name _alist) (string-match "foop" buffer-name))
	   (add-to-list 'display-buffer-alist '(foop . display-buffer-other-frame))

	This change makes it work again, restoring compatibility.

	* lisp/subr.el (buffer-match-p): Fix and adjust docstring.
	* lisp/window.el (display-buffer-alist): Adjust docstring.
	(display-buffer-assq-regexp): Make good on promise of display-buffer-alist.

2023-03-26  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix/simplify Imenu index generation

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--full-name): Drop '#'
	from the end of resulting string when the node is not a method.
	Support 'singleton_method' nodes.
	(ruby-ts--imenu-helper): Simplify, to create a "flat" list of
	entries, rather than a nested one.  The previous implementation
	had problems (like producing a nested structure of full-qualified
	names, thus creating a lot of textual repetition), seems easier to
	just follow ruby-mode's example here, at least for Emacs 29's
	release.

	* test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-imenu-index):
	New test.

2023-03-26  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--align-chain): Use 'equal' to check for an exact match

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--align-chain): Use
	'equal' to check for an exact match rather than substring.

2023-03-26  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-218-g3dbb22a

2023-03-26  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.2

2023-03-26  Ken Brown  <kbrown@cornell.edu>

	Skip failing tests on Cygwin with native compilation (bug#62450)

	* test/Makefile.in (TEST_NATIVE_COMP): New variable, used to
	determine whether to run tests tagged with :nativecomp.  Set it to
	"no" on Cygwin and to $(HAVE_NATIVE_COMP) otherwise.

	* test/lisp/emacs-lisp/benchmark-tests.el (benchmark-tests): Skip
	on Cygwin with native-compilation.

2023-03-26  Michael Albinus  <michael.albinus@gmx.de>

	Fix GNUSTEP tests on EMBA

	* configure.ac (LIBS_GNUSTEP): Adapt CPPFLAGS and CFLAGS.  (Bug#62210)
	Proposed by Po Lu <luangruo@yahoo.com>.

	* test/infra/gitlab-ci.yml (build-image-gnustep)
	(test-gnustep): Uncomment jobs.

2023-03-26  Phil Sainty  <psainty@orcon.net.nz>

	Fix primary selection modification during `term-mouse-paste' (bug#58608)

	* lisp/term.el (term-mouse-paste): Prevent the primary selection from
	being changed in the process of sending it to the inferior process.

2023-03-26  Xi Lu  <lx@shellcodes.org>

	Add 'eww-default-download-directory'.

	* lisp/net/eww.el (eww-default-download-directory): New defcustom.
	(eww--download-directory): Use it.  (Bug#62435)

2023-03-26  Phil Sainty  <psainty@orcon.net.nz>

	* doc/lispref/modes.texi: Improve docs for obsolete '%m' construct

	Bug #57080.

2023-03-26  Phil Sainty  <psainty@orcon.net.nz>

	Improve docs for global-mode-string / %M construct

	* src/xdisp.c (global-mode-string): Update docstring.
	* doc/lispref/modes.texi: Update manual.

2023-03-26  Phil Sainty  <psainty@orcon.net.nz>

	* src/buffer.c (mode-line-format): Document %o and %q constructs

	Missed from commit b0b02ca7f3e06d0f092df6f81babd1277bf93b0f.

2023-03-26  Phil Sainty  <psainty@orcon.net.nz>

	* src/buffer.c (mode-line-format): Remove docs for obsolete %t construct

	This documentation had been previously removed in 1999 in [1]
	but was subsequently restored again in a different form in 2006
	in [2] as the construct was still supported on some systems.
	However it looks like it hasn't done what that documentation
	indicated since [3] in 2011, and the final remnant of this
	functionality was removed in [4] in 2013; so it seems clear that
	it's no longer supported and shouldn't be documented now.

	[1] commit 08de62001945d4dd32a3d6af44da05804cb296d5
	[2] commit dafbe726b89a36010f3f24bb1efe4ace0a5f7f0f
	[3] commit 05c652517317d10690aaf0a6aa0bc876382b9d82
	[4] commit 8549f9e89bd9288c4c709d183a5bf8f07dbeed3d

2023-03-25  kobarity  <kobarity@gmail.com>

	Improve indenting "case" in Python

	* lisp/progmodes/python.el (python-info-dedenter-statement-p): Do not
	consider the first "case" in the block as dedenter.
	* test/lisp/progmodes/python-tests.el
	(python-info-dedenter-opening-block-positions-7)
	(python-info-dedenter-statement-p-6): New tests. (Bug#62092)

2023-03-25  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-native-comp): Add zlib1g-dev.

2023-03-25  Ken Brown  <kbrown@cornell.edu>

	Fix failure of fns-tests-collate-strings on Cygwin

	* test/src/fns-tests.el (fns-tests-collate-strings): Use
	en_XY.UTF-8 instead of en_DE.UTF-8 as an example of an invalid
	locale; en_DE.UTF-8 is actually a valid locale on Cygwin.
	Note: The test will still fail on Cygwin releases < 3.5
	because of a Cygwin bug.  (Bug#62420)

2023-03-25  Aaron L. Zeng  <azeng@janestreet.com>  (tiny change)

	* lisp/savehist.el (savehist-save): Preserve shared structure

	This avoids ballooning the size of variables that contain
	large text properties, such as the 'yank-handler' installed
	by 'evil-yank-rectangle', which contains a list of lines in
	the string.
	* lisp/savehist.el (savehist-save): Enable 'print-circle'.
	(Bug#62364)

2023-03-24  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp manual

	* doc/misc/tramp.texi (Default Method): OpenSSH for MS Windows can
	be used.
	(Ssh setup): Extend for MS Windows and ssh.

2023-03-24  Eli Zaretskii  <eliz@gnu.org>

	Fix system time sampling on MS-Windows

	* src/timefns.c (emacs_localtime_rz) [WINDOWSNT]: Unconditionally
	call tzset to make sure we pick up all the changes of time zone,
	working around the MS CRT caching.

2023-03-24  Yuan Fu  <casouri@gmail.com>

	Fix treesit_ensure_parsed (bug#62333)

	* src/treesit.c (treesit_ensure_parsed): Check for need_reparse after
	treesit_sync_visible_region runs, because as the comment says,
	treesit_sync_visible_region might modify need_reparse.

2023-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/help-fns.el (find-lisp-object-file-name): Fix bug#62376 part2

	Nowadays `loaddefs.el` are byte-compiled, so adjust pattern accordingly

2023-03-23  Eli Zaretskii  <eliz@gnu.org>

	Improve "Bugs" in the Emacs manual

	* doc/emacs/trouble.texi (Bugs, Known Problems)
	(Understanding Bug Reporting, Checklist, Sending Patches)
	(Contributing, Coding Standards): Improve wording, structure,
	markup, and indexing.  (Bug#62320)

2023-03-23  João Távora  <joaotavora@gmail.com>

	Fix Eglot progress reporting

	When the server sends an "end" message, Emacs's progress reporters
	should also be updated.

	* lisp/progmodes/eglot.el (eglot-handle-notification $/progress): Rework.

2023-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix :predicate handling in globalized minor modes

	* lisp/emacs-lisp/easy-mmode.el (define-globalized-minor-mode):
	Fix a thinko.  (Bug#62376)

2023-03-23  Eli Zaretskii  <eliz@gnu.org>

	Allow showing prefix commands in Help buffers

	* lisp/help.el (describe-bindings-show-prefix-commands): New user
	option.
	(describe-map): Use it to decide whether to output prefix
	commands.  Patch by Bob Rogers <rogers@rgrjr.com>.  (Bug#62279)

	* etc/NEWS: Document 'describe-bindings-show-prefix-commands'.

2023-03-23  Daniel Martín  <mardani29@yahoo.es>

	Fix toolbar item validation in the NS port

	* src/nsterm.m ([EmacsView validateToolbarItem:]): Implement this
	NSToolbarItemValidation method, which is called by AppKit when it
	needs to validate an image item in a toolbar.  This solves, in
	particular, the problem with having the "Save" icon on the tool
	bar enabled at Emacs startup.  (Bug#62234)

2023-03-22  Michael Albinus  <michael.albinus@gmx.de>

	Use libgccjit-10-dev on EMBA

	* test/infra/Dockerfile.emba (emacs-native-comp): Use
	libgccjit-10-dev.  (Bug#62211)

	* test/infra/gitlab-ci.yml (build-native-comp-speed2)
	(test-native-comp-speed2): Uncomment jobs.

2023-03-22  Juri Linkov  <juri@linkov.net>

	* lisp/outline.el (outline--fix-buttons-after-change): Add save-match-data.

	It's important for a hook in after-change-functions not to change match-data.
	Otherwise it breaks functions that make changes in the buffer, such as
	for example, successive calls to delete-region in smerge-keep-n, etc.

2023-03-22  Yuan Fu  <casouri@gmail.com>

	Align concatenated strings to the first sibling in c-ts-mode

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Change rule.

2023-03-22  Yuan Fu  <casouri@gmail.com>

	Only fill the current paragraph in c-ts-common--fill-block-comment

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common--fill-block-comment): Shrink the filled region to the
	paragraph at point.

2023-03-21  Yuan Fu  <casouri@gmail.com>

	Add missing indent rule for c-ts-mode

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule for case.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-03-21  Yuan Fu  <casouri@gmail.com>

	Improve docstring of treesit-parent-while (bug#62301)

	* doc/lispref/parsing.texi (Retrieving Nodes): Improve and fix
	docstring for treesit-parent-until and treesit-parent-while.
	* lisp/treesit.el (treesit-parent-while): Improve docstring.

2023-03-21  João Távora  <joaotavora@gmail.com>

	Eglot: report window/workDoneProgress capability to language server

	In bug#59149, LSP progress reporting was implemented, but Eglot's
	'capabilities' statement to the server wasn't changed to include
	window/workDoneProgress.

	* lisp/progmodes/eglot.el (eglot-client-capabilities): Actually
	report workDoneProgress.

2023-03-21  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Improve 263d6c38539

2023-03-21  Robert Pluim  <rpluim@gmail.com>

	Expand defvar-keymap documentation

	* doc/lispref/keymaps.texi (Creating Keymaps): Describe the :repeat keyword.

2023-03-20  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/treesit.el (treesit-end-of-defun): Guard arg against nil (bug#62158).

2023-03-20  Andrea Corallo  <akrl@sdf.org>

	Comp fix calls to redefined primtives with op-bytecode (bug#61917)

	* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Fix compilation
	of calls to redefined primtives with dedicated op-bytecode.
	* test/src/comp-tests.el (61917-1): New test.

2023-03-20  Robert Pluim  <rpluim@gmail.com>

	Warn package authors away from keymap-unset with REMOVE

	* doc/lispref/keymaps.texi (Changing Key Bindings): Ask package
	authors to not use the REMOVE argument to `keymap-unset'.

2023-03-20  Michael Albinus  <michael.albinus@gmx.de>

	Comment out jobs on EMBA

	* test/infra/gitlab-ci.yml: Comment out jobs due to bug#62210 and
	bug#62211.

2023-03-20  Robert Pluim  <rpluim@gmail.com>

	Improve defvar-keymap docstring.

	* lisp/keymap.el (defvar-keymap): Improve description of ':enter' and
	':exit' usage for ':repeat' keyword.

2023-03-19  Gregory Heytings  <gregory@heytings.org>

	Improve warning about changing the string returned by symbol-name

	* src/data.c (Fsymbol_name): Add warning.  See bug#62009.

	* doc/lispref/symbols.texi (Creating Symbols): Improve warning.

2023-03-19  Eli Zaretskii  <eliz@gnu.org>

	Fix visiting XBM/XPM files when 'c-ts-mode' is active

	* lisp/progmodes/c-ts-mode.el (treesit-ready-p): Fix association
	for XBM/XPM files in 'auto-mode-alist'.  (Bug#62276)

2023-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/mpc.el (mpc-format): Fix oversight in commit 48b6cec61cf

2023-03-19  João Távora  <joaotavora@gmail.com>

	Bail early from eglot--apply-text-edits if nothing to do

	* lisp/progmodes/eglot.el (eglot--apply-text-edits): Early return.

2023-03-19  João Távora  <joaotavora@gmail.com>

	Improve ergonomics of Eglot's inlay hints

	Instead of deleting inlay hints instantly as soon as the affected
	changes, make hint overlays span one character (instead of being
	length 0).  Give the overlays an "evaporate" property.

	Given an inlay hints at position POS, its attached to [POS, POS+1] if
	it's kind=1 (usually type hints) and [POS-1, POS] otherwise.  For
	kind=1 hints, the 'cursor position of the first such overlay is also
	tweaked, so that's it's less akward to edit around it.

	* lisp/progmodes/eglot.el (eglot--before-change): Don't delete hints
	  here.
	  (eglot--update-hints-1): Rework.

2023-03-19  Eli Zaretskii  <eliz@gnu.org>

	Protect against too large size of 'recent-keys' vector

	* src/keyboard.c (MAX_NUM_RECENT_KEYS): New macro.
	(Flossage_size): Don't allow specifying too large lossage-size.
	Fix data types.  (Bug#62277)

2023-03-19  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-yn-prompt-regexp): Fix regexp.

2023-03-18  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-48-g92471e

2023-03-18  João Távora  <joaotavora@gmail.com>

	Merge confusing duplicate sections on commands in Eglot manual

	Also describe eglot-diagnostics-map.

	* doc/misc/eglot.texi (Eglot Features): Don't describe commands here.
	(Eglot Commands): Describe commands here.

2023-03-18  João Távora  <joaotavora@gmail.com>

	Don't take over mouse-1 binding on Eglot diagnostics (bug#62157)

	It's better to give the user a variable to allow the overlay keymap to
	be customized.

	* lisp/progmodes/eglot.el (eglot--mouse-call): Accept second arg.
	(eglot--mode-line-props): Adapt call to eglot--mouse-call
	(eglot-diagnostics-map): New variable.
	(eglot-code-actions-at-mouse): New command.

2023-03-18  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/progmodes/eglot.el (eglot--connect): Improve Tramp workaround.

2023-03-18  Gregory Heytings  <gregory@heytings.org>

	Avoid slowdowns in xmltok-scan-attributes

	* lisp/nxml/xmltok.el (xmltok-scan-attributes): Limit the search
	to 10000 characters, to avoid slowdowns due to the quadratic
	complexity of the regexp.  Suggested by Stefan Monnier.

2023-03-18  Alan Mackenzie  <acm@muc.de>

	CC Mode: Eliminate duplicate function c-list-of-strings

	Replace it with the existing c-string-list-p.  Also put an autoload cookie in
	front of c-string-list-p so that it will not be signalled as undefined by
	loaddefs.el.

	lisp/progmodes/cc-vars.el (c-string-list-p): Make this autoload.
	(c-list-of-strings): Remove.
	(c-font-lock-extra-types, c++-font-lock-extra-types)
	(objc-font-lock-extra-types, java-font-lock-extra-types)
	(idl-font-lock-extra-types, pike-font-lock-extra-types): In the autoload
	cookies, replace c-list-of-strings with c-string-list-p.

2023-03-18  Alan Mackenzie  <acm@muc.de>

	CC Mode: Allow lists of strings as safe values for *-font-lock-extra-types

	* lisp/progmodes/cc-vars.el (c-list-of-strings): New function.
	(c-font-lock-extra-types, c++-font-lock-extra-types)
	(objc-font-lock-extra-types, java-font-lock-extra-types)
	(idl-font-lock-extra-types, pike-font-lock-extra-types): Add a :safe entry
	into each of thes defcustoms for c-list-of-string.
	(Top level): Add an autoload entry for each of the above.

2023-03-18  Robert Pluim  <rpluim@gmail.com>

	Add tests for Bug#62207

	* test/src/keymap-tests.el (keymap-unset-test-remove-and-inheritance):
	New test.

2023-03-18  Manuel Giraud  <manuel@ledu-giraud.fr>

	Fix 'find-ls-option-default-ls' for BSD/MacOS (bug#62096)

	* lisp/find-dired.el (find-ls-option-default-ls): Adapt to
	a value that works with the default "find" on *BSD and
	Darwin/MacOS.  Tested on OpenBSD and MacOS.  Do not merge
	to master.

2023-03-17  João Távora  <joaotavora@gmail.com>

	Enhance section about troubleshooting in Eglot manual.

	* doc/misc/eglot.texi (Troubleshooting Eglot): Parially rewrite.

2023-03-17  João Távora  <joaotavora@gmail.com>

	Fix Eglot's snippet insertion to follow the manual

	The manual states that YASnippet must only be installed to be useful.
	Before this change, it would only work if the user happened to have
	manually activated it before with 'yas-global-mode' or somesuch.

	This makes Eglot's Yasnippet-activating behaviour similar to its
	Flymake-activating behaviour.

	* lisp/progmodes/eglot.el (eglot-client-capabilities): Consult
	eglot--stay-out-of.
	(eglot--snippet-expansion-fn): Turn on yas-minor-mod eon demand.
	(eglot-completion-at-point): Simplify.

2023-03-17  Filipp Gunbin  <fgunbin@fastmail.fm>

	Reset abbrevs-changed after saving abbrevs (bug#62208)

	* lisp/abbrev.el (abbrev--possibly-save): Reset abbrevs-changed after
	saving abbrevs.
	* test/lisp/abbrev-tests.el (abbrev--possibly-save-test): New test.

2023-03-17  Robert Pluim  <rpluim@gmail.com>

	Document `keymap-unset' in lispref

	* doc/lispref/keymaps.texi (Changing Key Bindings): Document
	keymap-unset.

2023-03-17  Robert Pluim  <rpluim@gmail.com>

	Don't add a key binding when REMOVE is non-nil

	* src/keymap.c (store_in_keymap): Don't add a nil keybinding if we've
	been asked to remove a non-existent binding.  (Bug#62207)

2023-03-17  Eli Zaretskii  <eliz@gnu.org>

	Fix the documentation of various aspects of adding Xref history

	* lisp/progmodes/xref.el (xref-marker-ring-length)
	(xref-set-marker-ring-length):
	* lisp/progmodes/etags.el (tags-location-ring-length)
	(find-tag-marker-ring): Add doc strings saying the variables are
	unused.

	* etc/NEWS: Enhance the description of the change which made Xref
	marker stack unlimited in its length.

	* doc/emacs/maintaining.texi (Looking Up Identifiers): Add back
	text lost when xref forward history was added in bug#38797.
	Explain the difference between 'C-M-,' and 'M-.'.  Improve
	wording (Bug#62229)

2023-03-16  kobarity  <kobarity@gmail.com>

	Fix python-fill-paragraph problems on filling strings (bug#62142)

	* lisp/progmodes/python.el (python-syntax--context-compiler-macro)
	(python-syntax-context): Add single-quoted-string and
	triple-quoted-string as TYPE argument.
	(python-info-triple-quoted-string-p): New helper function.
	(python-fill-paragraph)
	(python-fill-string): Use it.
	* test/lisp/progmodes/python-tests.el (python-syntax-context-1)
	(python-fill-paragraph-single-quoted-string-1)
	(python-fill-paragraph-single-quoted-string-2)
	(python-fill-paragraph-triple-quoted-string-1)
	(python-info-triple-quoted-string-p-1)
	(python-info-triple-quoted-string-p-2)
	(python-info-triple-quoted-string-p-3): New tests.

2023-03-16  João Távora  <joaotavora@gmail.com>

	Also exempt eglot-inlay-hints-mode from desktop.el's fumblings

	Reported in https://github.com/joaotavora/eglot/discussions/1183.

	* lisp/progmodes/eglot.el (desktop): Also exempt
	eglot-inlay-hints-mode from desktop.el fumblings.

2023-03-16  Stefan Kangas  <stefankangas@gmail.com>

	Refer to EWW instead of w3 and w3m

	* doc/misc/idlwave.texi (Help with HTML Documentation): Refer to EWW
	instead of w3 and w3m.

2023-03-16  João Távora  <joaotavora@gmail.com>

	Fix Eglot's command generation for code actions

	The user command generated by eglot--code-action should always call
	eglot-code-actions with a INTERACTIVE set to t.

	Reported in https://github.com/joaotavora/eglot/issues/1132.

	* lisp/progmodes/eglot.el (eglot--code-action): Pass INTERACTIVE=t to
	eglot-code-action call.

2023-03-16  João Távora  <joaotavora@gmail.com>

	Emphasize emacs-29-specificity in this version of lisp/progmodes/eglot.el

	Do not merge to master.

	Before working on bugfixes to Eglot in its non-ELPA form delivered
	with Emacs 29, it's important to distinguish between this emacs-29
	version and the one in master, which will also get the bugfixes (via
	routine gitmerge.el) but with a bumped version number.

	* lisp/progmodes/eglot.el (Version): Emphasize Emacs 29, but hint this
	is 1.12 + something.
	(Package-Requires): Remove.  Everything required is already in Emacs
	29.

2023-03-16  USAMI Kenta  <tadsan@zonu.me>

	Fix quoting of font-family in 'hfy-family'

	Running "M-x htmlfontify-buffer" in one buffer, the exported HTML contains
	lines like:

	  body, pre { text-decoration: none;  font-family: Migu 2M;  font-stretch:
	  normal;  font-weight: 500;  font-style: normal;  color: #ffffff;
	  background: #000000;  font-size: 15pt; }

	Standards-compliant web browsers should ignore this font-family.

	MDN Web Docs says:
	https://developer.mozilla.org/en-US/docs/Web/CSS/font-family

	  Valid family names
	  Font family names must either be given quoted as strings, or unquoted as
	  a sequence of one or more identifiers. This means that punctuation
	  characters and digits at the start of each token must be escaped in
	  unquoted font family names.

	  It is a good practice to quote font family names that contain white
	  space, digits, or punctuation characters other than hyphens.

	An unquoted font-family is valid as long as it doesn't start with a digit,
	but MDN Web Docs also says:

	  The following example is technically valid but is not recommended:
	  font-family: Gill Sans Extrabold, sans-serif;

	So it makes sense to quote all font-family.

	* lisp/htmlfontify.el (hfy-family): Quote 'font-family'.  (Bug#62054)

2023-03-15  Michael Eliachevitch  <m.eliachevitch@posteo.de>  (tiny change)

	Document how to construct JSONRPC arrays in Eglot manual

	Many language server configuration options are of the JSON array
	datatype, for example argument lists for executables, but there wasn't
	any example of that in the Eglot manual.

	* doc/misc/eglot.texi (User-specific configuration)
	(User-specific configuration): Tweaks.
	(JSONRPC objects in Elisp): Mention JSON arrays. Tweak example.

2023-03-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba: Use debian:bullseye.

2023-03-15  Andrea Corallo  <akrl@sdf.org>

	* configure.ac: Fix native comp compatibility check (bug#61960)

2023-03-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba: Install clangd.

2023-03-15  Philip Kaludercic  <philipk@posteo.net>

	Remove 'package-vc--query-spec'

	* lisp/emacs-lisp/package-vc.el (require): Do not load `inline' during
	compilation.
	(package-vc--query-spec): Remove function.
	(package-vc--clone): Do not call 'package-vc--query-spec'.

2023-03-15  Philip Kaludercic  <philipk@posteo.net>

	Do not store :lisp-dir in package descriptors

	* lisp/emacs-lisp/package-vc.el (package-vc--main-file)
	(package-vc--unpack-1): Query 'pkg-spec' instead of
	'package-desc-extras'.
	(package-vc--unpack): Do not update 'package-desc-extras'.

	This simplification is possible due to the change in 2718bbb3bc, since
	we now ensure that package specifications are not lost.  They are
	either provided by a package archive or stored in
	'package-vc-selected-packages'.

2023-03-15  Philip Kaludercic  <philipk@posteo.net>

	Use 'package-vc-selected-packages' to store package specs

	* doc/emacs/package.texi (Fetching Package Sources): Do not promote
	the usage of 'package-vc-selected-packages' to install packages.
	* lisp/emacs-lisp/package-vc.el (package-vc-selected-packages): Remove
	custom setter and change docstring according to these changes.
	(package-vc--desc->spec): Consult 'package-vc-selected-packages' for
	package specifications.
	(package-vc--unpack): Add unknown package specifications to
	'package-vc-selected-packages'

2023-03-13  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el: Bump the version.

2023-03-13  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el (xref--xref-buffer-mode): Split up 'setq-local'.

	xref.el needs to support 26.1, but an arbitrary number of variables
	in 'setq-local' was added in Emacs 27.1 (bug#62162).

2023-03-13  Filipp Gunbin  <fgunbin@fastmail.fm>

	Fix import of keys in buffer created by epa-search-keys

	* lisp/epa-ks.el (epa-ks--query-url): Add operation parameter.
	(epa-ks--fetch-key, epa-search-keys): Use it.

2023-03-13  Michael Albinus  <michael.albinus@gmx.de>

	Fix connection-local variables settings


	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables): Use NOW when calling
	`custom-set-variables'.

	* test/lisp/files-x-tests.el
	(files-x-test-connection-local-set-profile-variables)
	(files-x-test-connection-local-update-profile-variables)
	(files-x-test-connection-local-set-profiles)
	(files-x-test-hack-connection-local-variables-apply)
	(files-x-test-with-connection-local-variables)
	(files-x-test-setq-connection-local): Fix tests.

	* test/lisp/net/tramp-tests.el (tramp-test34-connection-local-variables)
	(tramp-test34-explicit-shell-file-name): Fix tests.

2023-03-13  João Távora  <joaotavora@gmail.com>

	Bump Eglot version to 1.12

	* etc/EGLOT-NEWS: New file.

	* etc/NEWS: Briefly mention etc/EGLOT-NEWS.

	* lisp/progmodes/eglot.el: Bump versions.

2023-03-13  João Távora  <joaotavora@gmail.com>

	Update Eglot's manual about eglot-workspace-configuration

	There is a possible use for a global setting
	eglot-workspace-configuration, which is to (ab)use it to set
	user-specific configuration when the server doesn't permit other
	methods.  Rearrange the "Advanced server configuration" section and
	describe that use in the manual.

	* doc/misc/eglot.texi (Project-specific configuration): Correct
	mistake about global usefulness of eglot-workspace-configuration.
	(Advanced server configuration): Swap order of sections.
	(User-specific configuration): Mention possibility of globally
	setting eglot-workspace-configuration.

2023-03-12  João Távora  <joaotavora@gmail.com>

	Amend last Eglot commit (bug#62065)

	The fix contained a spurious check for this-command that shouldn't
	have made it in..

	* lisp/progmodes/eglot.el (eglot-ensure): Don't check this-command.

2023-03-12  João Távora  <joaotavora@gmail.com>

	Make eglot-ensure's post-command-hook run a bit later (bug#62065)

	'eglot-ensure', typically used in the major-mode-hook, use
	'post-command-hook' to schedule an automated, non-interactive
	connection attempt to a server.  The goal is to connect when the
	buffer is ready, i.e. after the user command that found the file.

	However, if there are dir-local or buffer-local variables to confirm,
	finding the file will cause a minibuffer prompt to appear.

	In that case, 'eglot-ensure's addition to the global post-command-hook
	runs before it was intended too and a connection is started
	prematurely.

	In turn, this means that a call to 'hack-dir-local-variables' -- which
	is part of the connection process -- which also needs a minibuffer
	prompt, collides with the previous one.  This generates an error and
	confuses the user, who doesn't know if the directory-local variables
	have been applied or not.

	This commit fixes the clash by having 'eglot-ensure' set
	'post-command-hook' buffer-locally.  This causes the automated
	connection to take place, as intended, after the user's original
	file-finding command has ended.

	However, the problem reported in bug#62065 is not completely fixed.
	If the user answers "no" to the first "confirm local variables"
	"prompt, she will be prompted again in the second one.  A subsequent
	commit will address this separate problem.

	* lisp/progmodes/eglot.el (eglot-ensure): Use buffer-local post-command-hook.

2023-03-12  Eli Zaretskii  <eliz@gnu.org>

	Fix display of disabled-command help text

	* lisp/novice.el (disabled-command-function): Improve wording, and
	make sure the prompt doesn't exceed one screen line, so that the
	mini-window is not resized (which gets in the way of fitting the
	window to the size of the help text), and the help text is fully
	visible when Emacs prompts for input.  (Bug#62146)

2023-03-12  Mattias Engdegård  <mattiase@acm.org>

	Remove mention of old dotted-list reader quirk from manual

	* doc/lispref/objects.texi (Dotted Pair Notation):
	The (. X) reader peculiarity is no more (bug#62020).

2023-03-12  Eli Zaretskii  <eliz@gnu.org>

	Fix value history shown for 'gc-cons-percentage'

	When Emacs is built, temacs is run in batch mode, so if we enlarge
	'gc-cons-percentage' in that case, the enlarged value will be
	"remembered" by the dumped Emacs, and will show confusing
	information in "C-h v", claiming that the original value was 1.0.
	Keeping the value at 0.1 during dumping avoids that.

	* src/emacs.c (main): Increase 'gc-cons-percentage' in batch mode
	only if we are not initializing (a.k.a. "dumping") Emacs.

2023-03-12  Michael Albinus  <michael.albinus@gmx.de>

	TRework fix for bug#62106

	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables):
	Use `custom-set-variables'.  It serves the purpose to not keep
	unsaved user options, and it is less invasive than
	`customize-save-variable'.

2023-03-11  Randy Taylor  <dev@rjt.dev>

	Add missing indentation rule for rust-ts-mode (Bug#62109)

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--indent-rules): Add
	missing rule.

2023-03-11  Michael Albinus  <michael.albinus@gmx.de>

	Fix bug#62106

	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables):
	Use `customize-save-variable' instead of `customize-set-variable'.
	(Bug#62106)

2023-03-11  Randy Taylor  <dev@rjt.dev>

	Add missing rust-ts-mode highlight query for scoped_type_identifiers

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Add missing query.

2023-03-11  kobarity  <kobarity@gmail.com>

	Make "case" keyword a dedenter in Python

	* lisp/progmodes/python.el (python-rx): Add "case" to dedenter.
	(python-info-dedenter-opening-block-positions): Add "case" to pairs.
	* test/lisp/progmodes/python-tests.el (python-indent-dedenters-9):
	New test.

2023-03-11  Eli Zaretskii  <eliz@gnu.org>

	Fix decoding non-ASCII file names in zip archives on MS-Windows

	* lisp/arc-mode.el (archive-zip-summarize): On MS-Windows,
	override archive-file-name-coding-system for files compressed
	on MS-Windows, and use the local console encoding instead.

2023-03-11  Eli Zaretskii  <eliz@gnu.org>

	Fix copying binary files from zip archives

	* lisp/arc-mode.el (archive-copy-file): Prevent any coding
	conversions when writing output files.  (Bug#62091)

2023-03-10  Robert Pluim  <rpluim@gmail.com>

	Skip ruby-ts-syntax-propertize-symbol unless treesitter is available

	 *
	 test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-syntax-propertize-symbol):
	 Add check for treesitter.

2023-03-10  Randy Taylor  <dev@rjt.dev>

	Fix enums and unions appearing as structs in c-ts-base-mode's imenu

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Separate enums and unions out
	from structs.

2023-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fine-tune s-p-f on symbols (bug#62086)

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query):
	Don't match ':' in symbol node text.  Or '_', I suppose.
	(ruby-ts--syntax-propertize): Make sure to only put the '_' syntax
	on punctuation syntax characters, and not on the whole symbol (to
	e.g. have symbols like :foo? include text recognized as word).

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-syntax-propertize-symbol): New test.

2023-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	python-info-dedenter-opening-block-positions: Fix to support "bare" match

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions): Make the check
	stricter.  Require that block starts only at indentation.

	* test/lisp/progmodes/python-tests.el
	(python-indent-after-bare-match): Another test (bug#62031).

2023-03-09  João Távora  <joaotavora@gmail.com>

	Autoload Eglot helper funtion eglot--debbugs-or-github-bug-uri

	This isn't a typical autoload: the progn block is plced in the
	autoloads file, but the eglot.el file itself isn't loaded as a result
	when the function inside the progn block is called.

	* lisp/progmodes/eglot.el (eglot--debbugs-or-github-bug-uri):
	autoload, but in progn.

2023-03-09  João Távora  <joaotavora@gmail.com>

	Add chapter on advanced server configuration to Eglot manual

	* doc/misc/eglot.texi (Top): Add section "Advanced server configuration"
	(Setting Up LSP Servers): Rework.
	(Advanced server configuration): New chapter.

2023-03-09  Vincenzo Pupillo  <v.pupillo@gmail.com>  (tiny change)

	java-ts-mode: detect if text_block is supported.

	A recent commit in tree-sitter-java (issue #141) removed support for
	the text_block node type from the grammar. To support the old released
	version and the new one, a helper function was added on which the
	string syntax highlighting now depends. (bug#61913)

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--string-highlight-helper): New helper function that
	return the right query string
	(java-ts-mode--font-lock-settings): Use it

2023-03-09  kobarity  <kobarity@gmail.com>

	Revert workaround introduced in Bug#56271

	* lisp/progmodes/python.el (python-nav-end-of-statement)
	(python-nav-end-of-block): Revert workaround introduced in Bug#56271
	as the bug is fixedin Bug#58780.

2023-03-09  kobarity  <kobarity@gmail.com>

	Fix searching for end of string in python-nav-end-of-statement

	* lisp/progmodes/python.el (python-nav-end-of-statement): Add
	searching for corresponding string-quote.
	* test/lisp/progmodes/python-tests.el (python-nav-end-of-statement-3)
	(python-nav-end-of-statement-4, python-info-current-defun-4): New
	tests. (Bug#58780)

2023-03-08  Po Lu  <luangruo@yahoo.com>

	Fix libwebp check for some webp installations

	* configure.ac: Look for WebPGetInfo; if it is not there, look
	for libwebpdecoder as well.  (bug#61988)

2023-03-08  Dmitry Gutov  <dgutov@yandex.ru>

	Avoid potential infloop

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions):
	Avoid potential infloop (bug#62031).

2023-03-08  Dmitry Gutov  <dgutov@yandex.ru>
	    Lele Gaifax  <lele@metapensiero.it>

	Don't misindent 'else:' after 'if re.match:' in Python

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions): Check that the
	supposed block start is not a method call (bug#62031).

	* test/lisp/progmodes/python-tests.el (python-indent-after-re-match):
	New test.

2023-03-08  Andrea Corallo  <akrl@sdf.org>

	* Make sure `default-directory' exists before spawning processes (bug#62004)

	* lisp/emacs-lisp/comp.el (comp-final, comp-run-async-workers): Bind
	`default-directory' to `invocation-directory'.

2023-03-08  Ulrich Müller  <ulm@gentoo.org>

	Fix sed expression in install-etc make target

	* Makefile.in (install-etc): Fix sed expression for emacsclient
	desktop files.  (Bug#62045)

2023-03-08  Ulrich Müller  <ulm@gentoo.org>

	Avoid using bash in the emacsclient desktop file

	* etc/emacsclient-mail.desktop (Exec): Use sh and sed instead
	of bash, because the latter may not be available everywhere.

2023-03-08  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of the 'line-height' text property

	* doc/lispref/display.texi (Line Height): More accurate
	documentation of the value t of 'line-height' text property.
	(Bug#62048)

2023-03-08  Gregory Heytings  <gregory@heytings.org>

	Add 'declare' specs to with- and without-restriction

	* lisp/subr.el (with-restriction):
	(without-restriction): Add 'declare' specs.

2023-03-07  Yuan Fu  <casouri@gmail.com>

	Fix empty line indentation in c-ts-mode (bug#61997)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): Handle the empty line case.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el (treesit-simple-indent-presets): Support null as
	a value for NODE-TYPE in the 'match' matcher.

2023-03-07  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter indent preset prev-line (bug#61998)

	* lisp/treesit.el (treesit-simple-indent-presets): Fix return value.

2023-03-07  Manuel Giraud  <manuel@ledu-giraud.fr>

	Revert 'forward-sentence-default-function' to return point (bug#62027)

	* lisp/textmodes/paragraphs.el
	(forward-sentence-default-function): Revert to return the
	position of point.
	(count-sentences): Adapt to this change.

2023-03-07  Ulrich Müller  <ulm@gentoo.org>

	Fix Elisp code injection vulnerability in emacsclient-mail.desktop

	A crafted mailto URI could contain unescaped double-quote
	characters, allowing injection of Elisp code.  Therefore, any
	'\' and '"' characters are replaced by '\\' and '\"', using Bash
	pattern substitution (which is not available in the POSIX shell).

	We want to pass literal 'u=${1//\\/\\\\}; u=${u//\"/\\\"};' in the
	bash -c command, but in the desktop entry '"', '$', and '\' must
	be escaped as '\\"', '\\$', and '\\\\', respectively (backslashes
	are expanded twice, see the Desktop Entry Specification).

	Reported by Gabriel Corona <gabriel.corona@free.fr>.

	* etc/emacsclient-mail.desktop (Exec): Escape backslash and
	double-quote characters.

2023-03-07  Eli Zaretskii  <eliz@gnu.org>

	Fix problem with debuginfod queries in "M-x gdb"

	* lisp/progmodes/gdb-mi.el (gdb-debuginfod-enable-setting): New
	defcustom.
	(gdb-debuginfod-message): New function.
	(gdb-init-1): Initialize gdb-debuginfod-enable.  Ask the user
	about debuginfod queries and display any error messages.
	(Bug#61973)

	* etc/NEWS: Announce the change.

2023-03-06  João Távora  <joaotavora@gmail.com>

	Fix regression in Fido mode (bug#62015)

	To understand the regression consider this recipe where the 'fo'
	pattern is typed by the user in the last step.

	   emacs -Q
	   C-x b foo RET
	   C-x b afoo RET
	   C-x b *scratch* RET
	   M-x fido-mode RET
	   C-x b fo

	This used to offer both 'foo' and 'afoo' as candidates but now only
	offered 'foo'.  This is because the pattern 'fo' matches 'foo', but
	not 'afoo' with 'basic' completion style.

	Fido mode, however, prioritizes 'flex' completion style, and that is
	not happening here as it used to.

	This was introduced in this commit

	     commit bf81df86e52fdc995bec8d9646f84d114cb896d1
	     Author: João Távora <joaotavora@gmail.com>
	     Date:   Wed Dec 7 10:43:59 2022 +0000

	         Don't override completion-category-defaults in fido-mode

	I took away the nil setting of 'completion-category-defaults; in Fido
	mode's minibuffer. It seemed generally the correct thing to do, and
	was done mainly because Eglot added its style preferences to that
	variable instead of completion-category-overrides directly, which is a
	nono.  So, to be able use the Fido UI with Eglot successfully,
	'completion-category-defaults' should stay untouched.  Or so I
	thought.

	However, I failed to notice that, for most categories, the default
	value of 'completion-category-defaults' prioritizes the 'basic'
	completion style.

	For example, in the 'buffer' category, the default value has the
	styles list '(basic substring)'.  This means that if a pattern matches
	accoring to the 'basic' style, 'substring' will not be tried.  And
	neither will 'completion-styles' which in Fido mode's case happens to
	be 'flex'.

	The solution in this commit is to craft a value for completion
	category defaults that is just like the default one, but prioritizes
	'flex' completion for every category.

	* lisp/icomplete.el (icomplete--fido-ccd): New helper.
	(icomplete--fido-mode-setup): Use it.

2023-03-06  Andrea Corallo  <akrl@sdf.org>

	* Fix `emacs-lisp-native-compile-and-load' for (bug#61917)

	* lisp/progmodes/elisp-mode.el (emacs-lisp-native-compile-and-load):
	Don't load if no compialtion happened.

2023-03-06  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp-prettyformat-insn): Fix (bug#61917)

2023-03-06  Eli Zaretskii  <eliz@gnu.org>

	Revert "Fix configuration of webp libraries"

	This reverts commit de4277af009115ceba7fe920163c05c608ea9524.
	It breaks WebP support at least on my system.
	There's no reason to require libwebpdecoder library to be
	installed, since we don't use the functions from it, at least
	not in libwebp 1.2.1.

2023-03-06  Po Lu  <luangruo@yahoo.com>

	Fix configuration of webp libraries

	* configure.ac: Link with libwebpdecoder along with
	libwebpdemux.  (bug#61988)

2023-03-05  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Mentioned in bug#61893.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling): Handle
	"#elif" and "#else".
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts: Add an
	"#elif" to the test.

2023-03-05  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Mentioned in bug#61893, although not the subject of it.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): Fix the child index for preproc_else
	and preproc_elif case.
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts:
	New test.

2023-03-05  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Not the subject of it, but mentioned in bug#61893.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling): Skip
	the sibling if it doesn't start on it's own line.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-03-05  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-40-g3d817c

2023-03-05  Yuan Fu  <casouri@gmail.com>

	Add string-interpolation feature to bash-ts-mode

	* lisp/progmodes/sh-script.el:
	(bash-ts-mode): Add string-interpolation feature.
	(sh-mode--treesit-settings): Add rule for string-interpolation feature.

2023-03-05  Michael Albinus  <michael.albinus@gmx.de>

	Fix tramp-sh-handle-insert-directory

	* lisp/net/tramp-sh.el (tramp-sh-handle-insert-directory): Remove also
	//DIRED-OPTIONS// line when there is no //DIRED// line.

2023-03-05  Andrea Corallo  <akrl@sdf.org>

	* Warn when certain primitives are redefined (bug#61880)

		* lisp/emacs-lisp/comp.el (comp-warn-primitives): New constant.
		(comp-subr-trampoline-install): Warn when a sensitive primitive is
		being redefined.

2023-03-04  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode preproc directive indentation

	Mentioned in bug#61893, although not the subject of that report.  This
	change fixes indentation for nested directives.  For example, when the
	directive involves elif and the like, the elif is nested in the if
	directive, so simply using grand-parent and great-grand-parent for
	anchor is insufficient, because the nesting can grow arbitrarily.

	The test added also covers the last preproc fix.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--standalone-parent-skip-preproc): New function.
	(c-ts-mode--indent-styles): New rules.
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts: New test.

2023-03-04  João Távora  <joaotavora@gmail.com>

	More robustly unspoof HOME in Eglot tests (bug#61637)

	A fair number of LSP servers allow user-local installations instead of
	system wide installations.  Emacs's technique of spoofing the HOME env
	var to some non-existent or non-home directory during 'make check'
	breaks these tests.  That's because the executables are still found by
	executable-find, but their invocation will rarely be successful as
	HOME isn't what they expect it to be.

	Eglot tests already had a technique for dealing with this,
	"unspoffing" HOME just for the invocations of LSP server but it
	stopped working a while back.  So make it more robust.

	Eventually, we'll want to decide wether these local servers should be
	considered in 'make check' runs at all, or whether there is a way to
	use them with a spoofed HOME.

	* test/lisp/progmodes/eglot-tests.el (eglot--call-with-fixture):
	More robustly unspoof HOME.

2023-03-04  João Távora  <joaotavora@gmail.com>

	Turn on Eglot inlay hints by default

	This is like any other server-provided feature, and may be turned off
	client-side by setting eglot-ignored-server-capabilities like

	   (add-to-list 'eglot-ignored-server-capabilities :inlayHintProvider)

	* lisp/progmodes/eglot.el (eglot--maybe-activate-editing-mode):
	Activate eglot-inlay-hints-mode.
	(eglot-inlay-hints-mode): Instead of warning about missing
	:inlayHintProvider, turn off eglot-inlay-hints-mode.

2023-03-04  Dmitry Gutov  <dgutov@yandex.ru>

	Update ts modes missed in 4c16fd3a512 to use column-0

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	* lisp/progmodes/go-ts-mode.el (go-ts-mode--indent-rules):
	Change point-min anchor to column-0.

2023-03-04  João Távora  <joaotavora@gmail.com>

	Robustify Eglot for "transient" projects

	When Eglot needs to synthesize a "transient" project for
	default-directory sometimes the value of that variable is set to an
	unexpanded value, sometimes not.  This can cause simple invocations
	like.

	   Emacs -Q ~/path/to-some-python-file.py -f eglot

	to fail, because eglot--current-server will be looking for a project
	in the registry called

	    (transient . "~/path")

	where in reality it is stored there as

	    (transient . "/home/someuser/path")

	The fix is to always expand default-directory in eglot--current-project.

	* lisp/progmodes/eglot.el (eglot--current-project): Use
	expand-file-name.

2023-03-04  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'normal-mode' in buffers that don't visit files

	* lisp/files.el (normal-mode):
	* lisp/subr.el (run-mode-hooks):
	* doc/emacs/modes.texi (Choosing Modes): Mention the caveat with
	'normal-mode' in buffers not visiting files.  (Bug#61925)
	* lisp/files.el (hack-local-variables): Doc fix.

2023-03-04  Yuan Fu  <casouri@gmail.com>

	Change tree-sitter indent anchor 'point-min' to 'column-0'

	Point-min isn't necessarily at column 0, using line-beginning-position
	is better. column-0 is also more intuitive.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles):
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules):
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--indent-rules):
	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--indent-rules): Change point-min to column-0.
	* lisp/treesit.el (treesit-simple-indent-presets): Change point-min to
	column-0.

2023-03-04  Yuan Fu  <casouri@gmail.com>

	Fix go-ts-mode multi-line string indentation (bug#61923)

	* lisp/progmodes/go-ts-mode.el:
	(go-ts-mode--indent-rules): Add indent rule for multi-line sting.

2023-03-03  João Távora  <joaotavora@gmail.com>

	Remove Eglot activation check from find-file-hook

	Adding eglot--maybe-activate-editing-mode to find-file-hook isn't
	really necessary, since it is already in
	'after-change-major-mode-hook', and that also runs every time we find
	a file.

	This reduces the number of project.el logic that runs every time the
	user visits a file.

	* lisp/progmodes/eglot.el (find-file-hook): No need to add
	eglot--maybe-activate-editing-mode here.

2023-03-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/intervals.c (set_intervals_multibyte_1): Fix bug#61887

	When `total_length` is 0 there should be no subtree at all, but
	`delete_interval` only deletes one interval, so make sure we don't end
	up with some stale child of `i`.

2023-03-03  João Távora  <joaotavora@gmail.com>

	Revert inadvertent change to lisp/icomplete.el in previous commit

	The change

	   commit 3a651773d29afb48ac4229cd19e532bd57a4ee2d
	   Author: João Távora <joaotavora@gmail.com>
	   Date:   Fri Mar 3 13:13:35 2023 +0000

	       Eglot: pay better attention to hints' paddingLeft/Right (bug#61924)

	Inadvertently added a line to this file, which shouldn't (yet) bet
	added.

	* lisp/icomplete.el (icomplete--vertical-minibuffer-setup): Remove
	truncate-lines.

2023-03-03  Yuan Fu  <casouri@gmail.com>

	Revert previous change in go-ts-mode.el

	Reverts 59365f928565f1be551b1697b9246b00cb87a9b7 and
	56cd810b9d1a4d537bee5a2fd954d6e0d346631a.

	Reverting because the use of treesit-ready-p is very much intentional.

	* lisp/progmodes/go-ts-mode.el (treesit-ready-p): Revert change.

2023-03-03  F. Jason Park  <jp@neverwas.me>

	Release ERC 5.5

	* doc/misc/erc.texi: Update ERCVER to 5.5.
	* lisp/erc/erc.el: Increment main version header to 5.5.  Update
	Compat version in package-requires header to 29.1.3.4.  Update
	`customize-package-emacs-version-alist' entry by mapping ERC 5.5 to
	Emacs 29.1.
	(erc-version): Update value to 5.5.

2023-03-03  Jim Porter  <jporterbugs@gmail.com>

	Don't create GUI frames in batch sessions

	This resolves an issue with running test/lisp/server-tests.el when
	'DISPLAY' is set: the tests would start the Emacs server in a batch
	session, and then request a new GUI frame.  However, that caused the
	tests to terminate with SIGIO, since a batch Emacs doesn't set a SIGIO
	handler.

	Ref: <https://lists.gnu.org/archive/html/emacs-devel/2023-02/msg00879.html>

	* lisp/frame.el (make-frame): Always create a terminal frame in batch
	sessions.

2023-03-03  Eli Zaretskii  <eliz@gnu.org>

	Minor copyedits of documentation of OClosures

	* doc/lispref/functions.texi (OClosures): Improve wording,
	indexing, and markup; add details.

2023-03-03  João Távora  <joaotavora@gmail.com>

	Eglot: pay better attention to hints' paddingLeft/Right (bug#61924)

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Consider
	:json-false, which is a non-nil value.

2023-03-02  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation for statement after preproc (bug#61893)

	Originally our c-ts-mode--anchor-prev-sibling only specially handled
	labeled_statements, now we add special case for preproc in the similar
	fasion: instead of using the preproc directive as anchor, use the last
	statement in that preproc as the anchor. Thus effectively ignore the
	preproc.

	There should be an accompanying test, but there are some problem in
	the elif preproc directive indent so it would pass, we'll add the test
	when that is fixed.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): Add special case for preproc
	directives.

2023-03-02  Eli Zaretskii  <eliz@gnu.org>

	Fix c/c++-ts-mode's mode lighter

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-set-modeline): Remove
	trailing blank from comment-start when indicating the comment
	style on the mode line.

2023-03-02  João Távora  <joaotavora@gmail.com>

	Eglot: use shell-file-name in eglot--cmd (bug#61748)

	* lisp/progmodes/eglot.el (eglot--cmd): Use shell-file-name.

2023-03-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid signaling errors in url-basic-auth when password is nil

	* lisp/url/url-auth.el (url-basic-auth): Handle nil PASS.
	Suggested by Ellis Kenyo <me@elken.dev>.  (Bug#61411)

2023-03-02  Eli Zaretskii  <eliz@gnu.org>

	Fix wdired-tests on MS-Windows

	* test/lisp/wdired-tests.el (wdired-test-bug32173-01)
	(wdired-test-bug32173-02, wdired-test-unfinished-edit-01)
	(wdired-test-bug39280): Run test-dir through file-truename, to
	avoid failures due to MS-Windows "numeric tails" (mis)feature and
	similar issues, which make file names fail to compare 'equal'.
	(wdired-test-bug34915, wdired-test-bug61510): Skip if symlinks
	fail.

2023-03-02  Andrew De Angelis  <bobodeangelis@gmail.com>

	Improvements to xwidget on macOS (bug#60703)

	* src/nsxwidget.m ()
	([XwWebView initWithFrame:configuration:xwidget:])
	(nsxwidget_init):  Fixed memory leaks: when sending an alloc
	message to an object, send an autorelease message to any objects
	we won't explictly release.
	([XwWebView webView:didFinishNavigation:]): Second string to
	store in 'store_xwidget_event_string' is "load finished" rather
	than empty string.
	([XwWebView webView:didStartProvisionalNavigation:])
	([XwWebView webView:didReceiveServerRedirectForProvisionalNavigation:])
	([XwWebView webView:didCommitNavigation:]): New functions.
	(nsxwidget_webkit_estimated_load_progress): New function.
	(nsxwidget_webkit_stop_loading): New function.
	* src/xwidget.c (Fxwidget_webkit_estimated_load_progress): Call
	'nsxwidget_webkit_estimated_load_progress' if we're on MacOS.
	(Fxwidget_webkit_stop_loading): Call 'nsxwidget_webkit_stop_loading'
	if we're on MacOS.
	(syms_of_xwidget): Define symbol for function.
	'xwidget_webkit_estimated_load_progress' if we're on MacOS.
	* src/nsxwidget.h: Signature for functions
	'nsxwidget_webkit_estimated_load_progress' and
	'nsxwidget_webkit_stop_loading'.
	* lisp/xwidget.el (xwidget-webkit-current-url): Message URL rather
	than return value of 'kill-new' (which is always nil).

2023-03-01  Yuan Fu  <casouri@gmail.com>

	* lisp/progmodes/go-ts-mode.el: Use treesit-language-available-p.

	treesit-ready-p does more checks than language grammar availability.

2023-03-01  Yuan Fu  <casouri@gmail.com>

	Don’t signal warning when loading go-ts-mode.el without grammar

	* lisp/progmodes/go-ts-mode.el: Add a QUIET flag to the call of
	treesit-ready-p, so that it doesn't signal a warning if
	go-mod (tree-sitter grammar) is not available.

2023-03-01  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode empty line indentation (bug#61893)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Make the
	"rest sibling" matchers catch the case where NODE is nil, when
	indenting an empty line.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-03-01  Yuan Fu  <casouri@gmail.com>

	Improve tree-sitter's prev-sibling indent anchor

	Now it handles the case where NODE is nil when indenting an empty
	line: it tries to get the previous sibling nonetheless.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling):
	* lisp/treesit.el (treesit-simple-indent-presets): Add an or form to
	handle more cases.

2023-03-01  João Távora  <joaotavora@gmail.com>

	* lisp/icomplete.el (fido-mode): Enable in-buffer completion (bug#45763).

	Backport:
	(cherry picked from commit b5c13032538377b0037c745715613693a1580f81)

2023-03-01  Juri Linkov  <juri@linkov.net>

	* lisp/icomplete.el: Fix in-buffer completion.

	(icomplete-force-complete-and-exit, icomplete-force-complete): Use
	'icomplete--field-beg/end' when not in the minibuffer to not erase
	the current buffer.  Also disable 'completion-in-region-mode' instead
	of calling 'exit-minibuffer' (bug#45764, bug#51575, bug#61479).

	Backport:
	(cherry picked from commit a7a984c0ebebb891e2052d8416544f0bd7002007)

2023-03-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/profiler.c (malloc_probe): Make it safe for GC (bug#60237)

2023-03-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/debug-early.el (debug-early-backtrace): Fix bug#61847

	The `noerror` arg of `require` doesn't do what Stefan naively thought
	when he wrote this code, so use `condition-case` instead.
	Also check for `cl-defmethod` since `cl-prin1` can't be loaded before
	that anyway.

2023-03-01  Eli Zaretskii  <eliz@gnu.org>

	Revert "Don't disable eldoc when doing edebug"

	This reverts commit 6fd1fb8a6837acde8e1c9ab26618ec0f36121c72.
	It turns out ElDoc does show messages inside Edebug, if you
	are (un)lucky enough to have point where ElDoc has something
	to show.  Bug#56459 needs to be fixed in some more complex
	way.

2023-03-01  João Távora  <joaotavora@gmail.com>

	Eglot: work around Tramp instability bug#61350

	Unconditionally disable ControlMaster for the Eglot's Tramp
	connection.

	* lisp/progmodes/eglot.el (tramp-ssh-controlmaster-options)
	(use-tramp-ssh-controlmaster-options): Forward declare
	(eglot--connect): Set variables to unconditionally disable ControlMaster.

2023-03-01  Yuan Fu  <casouri@gmail.com>

	Fix treesit-indent-region

	Fix it for the case where there is no suitable rule for the line.
	Right now treesit-indent-region would indent the line to column 0.
	After the change the indentation is not altered.

	* lisp/treesit.el (treesit-indent-region): Handle the case where
	ANCHOR or OFFSET is nil specially.

2023-03-01  Po Lu  <luangruo@yahoo.com>

	Replace C++ comments with C style equivalents

	* src/alloc.c (Fmake_byte_code, purecopy):
	* src/bytecode.c (exec_byte_code):
	* src/xdisp.c (face_at_pos): Do not use C++-style comments!

2023-02-28  João Távora  <joaotavora@gmail.com>

	Eglot: fix M-x eglot-show-workspace-configuration (bug#61866)

	Now consult .dir-locals.el every time the workspace configuration is
	needed:

	- workspace/configuration server request
	- workspace/didChangeConfiguration signal
	- M-x eglot-show-workspace-configuration

	The major-mode/hack-dir-local-variables-non-file-buffer trick is used.
	When there is more than one, the server connection's "main" major mode
	is used to find the relevant .dir-locals.el section.

	* lisp/progmodes/eglot.el (eglot--lookup-mode): Fix docstring.
	(eglot--connect): Simplify.
	(eglot-show-workspace-configuration): Fix.
	(eglot--workspace-configuration): Remove.
	(eglot--workspace-configuration-plist): Rework.
	(eglot-handle-request): Simplify.

2023-02-28  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-mode: Fix method call indentation in rhs of multiple assignment

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules): Special-case
	assignment that follows a comma-separated list (bug#61871).

	* test/lisp/progmodes/ruby-mode-resources/ruby.rb: Add case.

2023-02-28  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-remote-path): Improve docstring.

2023-02-28  Felix  <felix.dick@web.de>  (tiny change)

	Minor change in 'dired--find-possibly-alternative-file'

	* lisp/dired.el (dired--find-possibly-alternative-file): Don't
	kill the buffer if the directory is shown in other windows.

2023-02-28  Felix  <felix.dick@web.de>  (tiny change)

	Implement prefix arg for 'c-ts-mode-toggle-comment-style'

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-toggle-comment-style):
	Actually implement the optional numeric arg mentioned in the
	docstring.

2023-02-28  Manuel Giraud  <manuel@ledu-giraud.fr>

	Defaults to zero for image-dired--number-of-thumbnails

	* lisp/image/image-dired.el (image-dired--number-of-thumbnails):
	Defaults zero to avoid wrong type argument error.  (Bug#61734)

2023-02-27  Dmitry Gutov  <dgutov@yandex.ru>

	Rename the newly added -ref- faces to -use-

	* lisp/font-lock.el (font-lock-variable-use-face)
	(font-lock-property-use-face): Rename from font-lock-variable-ref-face
	and font-lock-property-ref-face.  Update all references (bug#61655).

2023-02-27  João Távora  <joaotavora@gmail.com>

	Eglot: support multiple labels in same inlay hint

	Mainly the rust-analyzer LSP server uses this.  There are still more
	things we could support, like tooltips and stuff.

	* lisp/progmodes/eglot.el (lsp-interface-alist): Add
	InlayHintLabelPart.
	(eglot--update-hints-1): Support multiple labels for same hint.

2023-02-27  João Távora  <joaotavora@gmail.com>

	Eglot: don't paint hints outside requested region (bug#61812)

	* lisp/progmodes/eglot.el (eglot--lambda): Add cl-block.
	(eglot--update-hints-1): Return early if hint is outside the
	requested inlay hint range.

2023-02-27  João Távora  <joaotavora@gmail.com>

	Eglot: protect against unintended field text motion (bug#61726)

	Suggested-by: Augusto Stoffel <arstoffel@gmail.com>

	* lisp/progmodes/eglot.el (eglot--bol): New helper.
	(eglot-utf-8-linepos, eglot-utf-16-linepos)
	(eglot-utf-32-linepos, eglot-move-to-utf-8-linepos)
	(eglot-move-to-utf-16-linepos, eglot-move-to-utf-32-linepos)
	(eglot-handle-notification, eglot--xref-make-match)
	(eglot-completion-at-point): Use it.

2023-02-27  Eli Zaretskii  <eliz@gnu.org>

	Fix description of 'desktop-save-mode'

	* doc/emacs/misc.texi (Saving Emacs Sessions): Adjust to changes
	in 'desktop-path'.  Reported by Petteri Hintsanen <petterih@iki.fi>.

2023-02-27  Yuan Fu  <casouri@gmail.com>

	Adjust tree-sitter defun navigation (bug#61617)

	Before this change, when you use a tree-sitter navigation function to
	move to the next beginning of a thing, it jumps over the immediate
	next thing and lands you at the beginning of the next-next thing.

	Eg, when point is at the "|", and we evaluate
	(treesit--navigate-thing pos 1 'beg), we go from

	|  (thing) (thing)

	to

	   (thing) |(thing)

	But some might expect point to go to

	   |(thing) (thing)

	instead, which makes sense.  Also, that's how Emacs expect defun
	navigation functions to work.  The discrepancy in expectation causes
	bug#61617.

	In this change I made tree-sitter navigation functions to work as what
	Emacs expects.  And what I described for moving to the next beginning
	of thing is similarly applicable to moving to the end of previous end
	of thing.

	* lisp/treesit.el (treesit-beginning-of-defun)
	(treesit-end-of-defun): Handle the case where defun-skipper moves
	point back to where we started, by adding a retry.

	(treesit--navigate-thing): Add a single condition checking for
	progress to the condition form responsible for checking whether to
	skip the next defun.  Namely (eq pos (funcall advance next)))).

	* test/src/treesit-tests.el:
	(treesit--ert-defun-navigation-nested-master)
	(treesit--ert-defun-navigation-top-level-master): Change tests to
	reflect the new expectation.

2023-02-27  Yuan Fu  <casouri@gmail.com>

	Simplify c-ts-mode--top-level-label-matcher

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--top-level-label-matcher): Make more assumptions and remove
	the loop, so it's faster in large files.

2023-02-27  Yuan Fu  <casouri@gmail.com>

	New tree-sitter indent anchor standalone-parent used by c-ts-mode

	When writing c-ts-mode Theo used parent-bol which works well except
	one case:

	1 for (int i=0;
	2      i < 5;
	3      i++) {
	4   func(i);
	5 }

	In this case, when indenting "func(i)", parent-bol returns the start
	of "i++" on line 3, instead of the "correct" anchor, the start of
	"for" on line 1.  parent-bol would have worked if the "for (...) {"
	part is in one line.

	To support this case I tried numerous things and added a bunch of
	stuff, culminating in c-ts-common-statement-offset.  It's complicated,
	requires extra setup, and slow.

	Not anymore! I think the new anchor standalone-parent really captures
	the logic behind how people expect indentation to work. It's simple
	and fast, and requires no setup.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--standalone-grandparent): New anchor.
	(c-ts-mode--indent-styles): Replace c-ts-common-statement-offset with
	standalone-parent.
	(c-ts-base-mode): Add comment.

	* lisp/treesit.el:
	(treesit-simple-indent-presets): New anchor standalone-parent.

2023-02-26  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-smie-rules: Fix misindentation of a method call after assignment

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules): Fix indentation of a
	method call after assignment with ruby-after-operator-indent=nil
	(bug#61822).

	* test/lisp/progmodes/ruby-mode-resources/ruby-after-operator-indent.rb:
	Add corresponding example.

2023-02-26  Eli Zaretskii  <eliz@gnu.org>

	* lib-src/etags.c (process_file_name): Free malloc'ed vars (bug#61819).

2023-02-26  João Távora  <joaotavora@gmail.com>

	Eglot: rename and redocument encoding-related functions (bug#61726)

	* lisp/progmodes/eglot.el (eglot-current-column): Obsolete.
	(eglot-lsp-abiding-column): Obsolete.
	(eglot-current-column-function): Obsolete.
	(eglot-current-linepos-function): Rename from eglot-current-column-function.
	(eglot-utf-8-linepos): Rename from eglot-bytewise-column.
	(eglot-utf-16-linepos): Rename from eglot-lsp-abiding-column.
	(eglot-utf-32-linepos): Rename from eglot-current-column.
	(eglot-move-to-current-column): Obsolete.
	(eglot-move-to-lsp-abiding-column): Obsolete.
	(eglot-move-to-column-function): Obsolete.
	(eglot-move-to-linepos-function): Rename from eglot-move-to-column-function.
	(eglot-move-to-utf-8-linepos): Rename from eglot-move-to-bytewise-column.
	(eglot-move-to-utf-16-linepos): Rename from eglot-move-to-lsp-abiding-column.
	(eglot-move-to-utf-32-linepos): Rename from eglot-move-to-current-column.
	(eglot--managed-mode): Adjust.
	(eglot-client-capabilities): Trim whitespace.

	* test/lisp/progmodes/eglot-tests.el (eglot-test-lsp-abiding-column)
	(eglot-test-lsp-abiding-column-1): Use new function/variable names.

2023-02-26  Augusto Stoffel  <arstoffel@gmail.com>

	Eglot: support positionEncoding LSP capability (bug#61726)

	* lisp/progmodes/eglot.el(eglot-client-capabilities):  Announce the
	new capability.
	(eglot-bytewise-column, eglot-move-to-bytewise-column): New functions.
	(eglot--managed-mode): Set 'eglot-current-column-function' and
	'eglot-move-to-bytewise-column' appropriately.

2023-02-26  Eli Zaretskii  <eliz@gnu.org>
	    Augusto Stoffel  <arstoffel@gmail.com>

	Eglot: use faster strategy for moving to LSP positions (bug#61726)

	Turns out we don't need encode-coding-region after all.

	* lisp/progmodes/eglot.el (eglot-move-to-lsp-abiding-column): Rewrite.

2023-02-26  Eli Zaretskii  <eliz@gnu.org>

	Fix mule-tests in UTF-8 locales

	* test/lisp/international/mule-tests.el
	(sgml-html-meta-no-post-less-than-10lines): Fix test condition.

2023-02-26  Eli Zaretskii  <eliz@gnu.org>

	Fix 'vertical-motion' when display strings are around

	* src/indent.c (Fvertical_motion): Correct bidi-related condition
	for character position, when we didn't move vertically.  (Bug#61636)

2023-02-25  Dmitry Gutov  <dgutov@yandex.ru>

	python-ts-mode: Fix single-quote string fontification

	* lisp/progmodes/python.el (python--treesit-fontify-string):
	Look for ', not just ", as opening delimiter (bug#61796).

2023-02-25  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in bidi.c

	* src/bidi.c (bidi_set_paragraph_end): Reset the isolate_level to
	zero.  Whenever stack_idx is reset to zero, the isolate_level must
	also be reset, since there cannot be any isolate status outside of
	embeddings.  Failure to reset isolate_level will cause us infloop
	when we see a PDI.  Reported by Matt Beshara <m@mfa.pw>.

2023-02-25  Daniel Martín  <mardani29@yahoo.es>

	Check the anchor along with the offset in treesit-indent-region

	* lisp/treesit.el (treesit-indent-region): To compute a valid column,
	having a non-nil offset is not enough, we need a non-nil anchor as
	well.

2023-02-24  Yuan Fu  <casouri@gmail.com>

	Align to prev sibling for c-ts-mode indentation

	As requested by a discussion on emacs-devel.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): New function.
	(c-ts-mode--indent-styles): Indent first child as before, indent the
	rest to their previous sibling.  Remove bracketless statement rules
	that I forgot to remove previously.

2023-02-24  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-common-statement-offset and c-ts-common--node-is

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common--node-is): Guard against case where the node has no field
	name.
	(c-ts-common-statement-offset): Do indent a level if the "if" in the
	"else if" is on an independent line.

2023-02-24  Dmitry Gutov  <dgutov@yandex.ru>

	typescript-ts-mode: Highlight non-shorthand destructuring bindings

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Highlight non-shorthand
	variable bindings in object destructuring.

2023-02-24  Dmitry Gutov  <dgutov@yandex.ru>

	Add more/finer faces for tree-sitter

	* doc/lispref/modes.texi (Faces for Font Lock):
	Update the list of faces (bug#61655).

	* etc/NEWS: Update the list of new faces.

	* lisp/cus-theme.el (custom-theme--listed-faces): Update.

	* lisp/font-lock.el (font-lock-function-call-face)
	(font-lock-variable-ref-face, font-lock-property-ref-face):
	New faces.
	(font-lock-property-name-face):
	Rename from 'font-lock-property-face'.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Use new faces.  More 'enumerator' query to 'definition' feature.
	(c-ts-mode--fontify-declarator, c-ts-mode--fontify-variable):
	Use new faces.

	* lisp/progmodes/cmake-ts-mode.el
	(cmake-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/csharp-mode.el
	(csharp-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Use new faces.

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/js.el (js--treesit-fontify-assignment-lhs)
	(js--treesit-font-lock-settings): Use new faces.  Highlight
	variable definitions inside array and object destructuring
	patterns.

	* lisp/progmodes/python.el (python--treesit-variable-p):
	Exclude identifiers in parameters.
	(python--treesit-settings): Use new faces.  Highlight function
	parameters.  Move 'keyword' up to still highlight 'self' as
	keyword.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use new faces.

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Use new faces.

	* lisp/textmodes/css-mode.el (css--treesit-settings):
	Use font-lock-property-ref-face.

	* lisp/textmodes/toml-ts-mode.el
	(toml-ts-mode--font-lock-settings):
	Use font-lock-property-ref-face.

	* lisp/textmodes/yaml-ts-mode.el
	(yaml-ts-mode--font-lock-settings): Same.

2023-02-24  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in batch mode due to lack of frame face cache

	* src/xfaces.c (Finternal_merge_in_global_face): Handle frames
	with no face cache.

2023-02-24  Michael Albinus  <michael.albinus@gmx.de>

	Add Tramp version integrated in Emacs 28.3

	* lisp/net/trampver.el (customize-package-emacs-version-alist):
	Add Tramp version integrated in Emacs 28.3.

2023-02-24  Philip Kaludercic  <philipk@posteo.net>

	Avoid reusing :lisp-dir twice in 'package-vc--main-file'

	* lisp/emacs-lisp/package-vc.el (package-vc--main-file): Just use
	:lisp-dir from 'package-desc-extras', not 'pkg-spec'.

	This avoid appending the contents of :lisp-dir twice, in case it is
	specified both in pkg-spec and pkg-desc.

2023-02-24  Philip Kaludercic  <philipk@posteo.net>

	Ensure right package-desc-type before installing package

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Move copying
	code from 'package-vc-install'.
	(package-vc-install): Remove copying.  (Bug#61669)

2023-02-24  Stephen Berman  <stephen.berman@gmx.net>

	Restore invisibility of symlink target on exiting wdired-mode

	* lisp/wdired.el (wdired-change-to-dired-mode): Invoke
	dired-hide-details-update-invisibility-spec (bug#61510).

	* test/lisp/wdired-tests.el (wdired-test-bug61510): New test.

2023-02-24  João Távora  <joaotavora@gmail.com>

	Eglot: fix jit-lock inlay hint bugs

	One of the bugs was straightforward.  The timer function of
	eglot--update-hints must set the correct buffer.

	The other is much more odd.  When using Eglot on Emacs's own
	src/coding.c, the jit-lock code starts calling its jit-functions over
	and over again with the same sequence of arguments, like so:

	======================================================================
	1 -> (eglot--update-hints 63551 65051)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints 65051 66551)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints-1 63551 66551)
	1 <- eglot--update-hints-1: nil
	======================================================================
	1 -> (eglot--update-hints 63551 65051)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints 65051 66551)
	1 <- eglot--update-hints: [nil 25592 52026 5
	======================================================================
	1 -> (eglot--update-hints-1 63551 66551)
	1 <- eglot--update-hints-1: nil

	This continues forever at a very fast rate and saturates the LSP
	channel.

	At first I thought that it was because eglot--update-hints-1 is
	actually causing the buffer to be modified with overlays sometime in
	the future, but it is not so!  It seems that merely calling

	   (goto-char (eglot--lsp-position-to-point position))

	(from the LSP request handler in eglot--update-hints-1) will cause
	this bug.

	* lisp/progmodes/eglot.el (eglot--update-hints): Fix bugs.

2023-02-24  João Távora  <joaotavora@gmail.com>

	Eglot: fix inlay hint with label collection instead of string

	Reported by Chinmay Dalal <dalal.chinmay.0101@gmail.com>

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Fix bug when
	inlay hint contains collection of labels.

2023-02-24  Robert Pluim  <rpluim@gmail.com>

	Fix insertion of keyboard macro containing named keys

	* lisp/kmacro.el: Autoload `macro--string-to-vector'.
	(kmacro-ring-head): Convert `last-kbd-macro' to a vector if it's a
	string, since `kmacro' uses `key-parse' on it.
	(kmacro-lambda-form): Remove require for 'macros
	* test/lisp/kmacro-tests.el
	(kmacro-tests-name-last-macro-key-parse-syntax):
	Test that insertion of macros that contain strings that look
	like named keys works correctly.

	(Bug#61700)

2023-02-23  João Távora  <joaotavora@gmail.com>

	Eglot: simplify inlay hints implementation with jit-lock

	This implementation is much simpler than the one based on
	windows-scroll-functions.  It's also supposedly safer, as long as
	jit-lock guarantees refontification of affected regions.

	It's not _trivially_ simple though, as simply adding
	'eglot--update-hints-1' to jit-lock-functions, while possible, is
	going to request inlay hints from the LSP server for many small
	regions of the buffer, depending on what jit-lock thinks is best.  So
	we keep coalescing these into a larger region until the time is
	suitable for a more bandwidth-efficient request.

	To do this, we use a jit-lock implementation detail,
	jit-lock-context-unfontify-pos, which is a proxy for knowing that the
	jit-lock-context-timer has run.  Not sure how brittle it is, but it
	seems to work reasonably.

	We also get rid of the previous "get hints for entire buffer"
	implementation.

	* doc/misc/eglot.texi (Eglot Variables): Remove mention
	to deleted eglot-lazy-inlay-hints.

	* lisp/progmodes/eglot.el (eglot-lazy-inlay-hints)
	(eglot--inlay-hints-after-scroll)
	(eglot--inlay-hints-fully)
	(eglot--inlay-hints-lazily): Remove.
	(eglot--update-hints): Add function.
	(eglot-inlay-hints-mode): Simplify.

2023-02-23  João Távora  <joaotavora@gmail.com>

	Eglot: update inlay hints on window configuration changes

	* lisp/progmodes/eglot.el
	(eglot--inlay-hints-after-window-config-change): New helper.
	(eglot-inlay-hints-mode): Use it.

2023-02-23  João Távora  <joaotavora@gmail.com>

	Eglot: display completion label when safe

	Originally reported in
	https://github.com/joaotavora/eglot/discussions/1141 by "Mintsoup".

	Eglot doesn't always show the LSP :label property of a CompletionItem
	in the completion candidates.  That is because label is sometimes not
	what should be inserted in the buffer in the end, the :insertText
	property supercedes it.

	But the label is usually more suitable for display nevertheless and if
	the LSP CompletionItem contains either a snippet or a textEdit, it's
	safe to display the label, since :exit-function will guarantee that a
	suitable buffer insertion is performed.

	This change reflects that awareness that when a textEdit is available,
	it's acceptable to show the label.

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Adjust.

2023-02-23  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of VC commands, including in Dired

	* doc/emacs/dired.texi (Operating on Files):
	* doc/emacs/maintaining.texi (VC Change Log, VC Directory Mode)
	(Version Control, Basic VC Editing): Document VC command
	invocation from Dired buffers.  Improve documentation of vc-log
	commands.

	* lisp/dired-aux.el (dired-vc-next-action):
	* lisp/vc/vc.el (vc-print-log, vc-log-search, vc-log-mergebase)
	(vc-log-view-type, vc-print-root-log, vc-next-action): Doc fixes.

2023-02-23  Juri Linkov  <juri@linkov.net>

	* doc/emacs/maintaining.texi: More mentions of marked files in Dired.

	(Basic VC Editing, Old Revisions, VC Change Log): Add more mentions of
	ability to include the marked files to the VC fileset in Dired (bug#61712).

2023-02-22  João Távora  <joaotavora@gmail.com>

	Eglot: implement inlay hints (bug#61412, bug#61066)

	Inlay hints are small text annotations to specific parts of the whole
	buffer, not unlike diagnostics, but designed to help readability
	instead of indicating problems.  For example, a C++ LSP server can
	serve hints about positional parameter names in function calls and a
	variable's automatically deduced type.  Emacs can display these hints
	in many little 0-length overlays with an 'before-string property, thus
	helping the user remember those types and parameter names.

	Since inlay hints are potentially a large amount of data to request
	from the LSP server, the implementation strives to be as parsimonious
	as possible with these requests.

	So, by default, inlay hints are only requested for the visible
	portions of the buffer across windows showing this buffer.  This is
	done by leveraging the 'window-scroll-functions' variable, making for
	a reasonably complex implementation involving per-window timers.  When
	scrolling a window, it may take a short amount of time for inlay hints
	to "pop in".  The new user variable 'eglot-lazy-inlay-hints' can be
	used to exert some control over this.

	Specifically, if the variable's value is set to 'nil', then inlay
	hints are greedily fetched for the whole buffer every time a change
	occurs.  This is a much simpler mode of operation which may avoid
	problems, but is also likely much slower in large buffers.

	Also, because the inlay feature is probably visually suprising to
	some, it is turned OFF by default, which is not the usual practice of
	Eglot (at least not when the necessary infrastructure is present).
	This decision may be changed soon.  Here's a good one-liner for
	enabling it by default in every Eglot-managed buffer:

	   (add-hook 'eglot-managed-mode-hook #'eglot-inlay-hints-mode)

	I haven't tested inlay hints extensively across many LSP servers, so I
	would appreciate any testing, both for functional edge cases and
	regarding performance.  There are possibly more optimization
	oportunities in the "lazy" mode of operation, like more aggressively
	deleting buffer overlays that are not in visible parts of the buffer.

	Though I ended up writing this one from scratch, I want to thank
	Dimitry Bolopopsky <dimitri@belopopsky.com> and Chinmay Dala
	<dalal.chinmay.0101@gmail.com> for suggestions and early patches.

	* lisp/progmodes/eglot.el (eglot--lsp-interface-alist): Define
	InlayHint.
	(eglot-client-capabilities): Announce 'inlayHint' capability.
	(eglot-ignored-server-capabilities): Add :inlayHintProvider.
	(eglot--document-changed-hook): New helper hook.
	(eglot--after-change): Use it.
	(eglot-inlay-hint-face, eglot-type-hint-face)
	(eglot-parameter-hint-face): New faces.
	(eglot--update-hints-1, eglot--inlay-hints-after-scroll)
	(eglot--inlay-hints-fully, eglot--inlay-hints-lazily): New helpers.
	(eglot-lazy-inlay-hints): New user variable.
	(eglot-inlay-hints-mode): New minor mode.
	(eglot--maybe-activate-editing-mode): Try to activate
	eglot-inlay-hints-mode.
	(eglot--before-change): Remove overlays immediately in the
	area being changed.
	(eglot--managed-mode-off): Remove overlays.

	* doc/misc/eglot.texi (Eglot Features): Mention inlay hints.
	(Eglot Variables): Mention eglot-lazy-inlay-hints.

2023-02-22  João Távora  <joaotavora@gmail.com>

	Eglot: run eglot-managed-mode-hook after LSP didOpen

	This allows using the hook for interacting with the LSP server using
	the current buffer as the subject of that interaction ("document" in
	LSP parlance).

	* lisp/progmodes/eglot.el (eglot--maybe-activate-editing-mode):
	Run eglot-managed-mode-hook here.
	(eglot--managed-mode): Not here.

2023-02-22  João Távora  <joaotavora@gmail.com>

	Eglot: restore eldoc-documentation-functions on shutdown

	* lisp/progmodes/eglot.el (eglot--managed-mode): Restore
	eldoc-documentation-functions when shutting down eglot.

2023-02-22  João Távora  <joaotavora@gmail.com>

	Eglot: simplify capability-checking code

	* lisp/progmodes/eglot.el (eglot--server-capable-or-lose): New helper.
	(eglot--signal-textDocument/willSave)
	(eglot--signal-textDocument/didSave): Tweak docstring.
	(eglot--workspace-symbols, xref-backend-identifier-at-point)
	(eglot-format, eglot-completion-at-point, eglot-rename)
	(eglot-code-actions): Use new eglot--server-capable-or-lose.

2023-02-22  João Távora  <joaotavora@gmail.com>

	Eglot: go back to setting eldoc-documentation-strategy again

	This commits reverts part of

	   commit e83c78b8c7784254c2c6f043530ab325c2fa7f16
	   Author: João Távora <joaotavora@gmail.com>
	   Date:   Mon Feb 20 22:43:50 2023 +0000

	       Eglot: respect user's Eldoc configuration by default

	In that commit, I did what many longstanding issues and users were
	suggesting and removed Eglot's override of two Eldoc user
	configuration varibles.

	I verified that Eglot's behaviour would stay mostly unaltered but my
	tests were very incomplete.  In short there is no way that Eglot can
	work acceptably with the default setting of
	'eldoc-documentation-strategy', which is
	'eldoc-documentation-default'.  So it must be changed, either globally
	or locally in Eglot's minor mode.

	This is true for any situation where both synchronous and asynchronous
	documentation sources are present.  In Eglot's case there are two
	asynchronous sources which have more importance than the synchronous
	source.  So any other strategy except the
	'eldoc-documentation-default' makes sense.

	* lisp/progmodes/eglot.el (eglot--managed-mode): Set
	eldoc-documentation-strategy to eldoc-documentation-compose.

2023-02-22  F. Jason Park  <jp@neverwas.me>

	Yield to erc-move-to-prompt before unhiding prompt

	* lisp/erc/erc-backend.el (erc--hide-prompt): Change hook depth from 0
	to 91 to allow the `move-to-prompt' module to do its thing.  This
	feature was added by bug#54826 and first appeared in Emacs 29.
	* lisp/erc/erc-common.el (erc-server-user): Remove erroneous comment.
	The `buffers' field is a list of buffers.
	* test/lisp/erc/erc-tests.el (erc-hide-prompt): Use `erc--target'
	instead of `erc-default-recipients' because this is new code.

2023-02-22  Augusto Stoffel  <arstoffel@gmail.com>

	* lisp/progmodes/python.el (python--import-sources): Fix regexp (bug#61648)

2023-02-22  Manuel Giraud  <manuel@ledu-giraud.fr>

	Do not error out on non image file (bug#61639)

	* lisp/image/image-dired.el
	(image-dired-display-thumbs): Do not insert non image file and do not
	display image-dired buffer if it is empty.

2023-02-22  Eli Zaretskii  <eliz@gnu.org>

	Explain effect of variable-pitch fonts on fill-column

	* doc/emacs/text.texi (Fill Commands):
	* doc/emacs/display.texi (Displaying Boundaries):
	* lisp/display-fill-column-indicator.el
	(display-fill-column-indicator-mode): Document caveats of using
	variable-pitch fonts with 'fill-column' and its indicator.
	(Bug#61677)

2023-02-22  Eli Zaretskii  <eliz@gnu.org>

	Avoid division by zero in get_narrowed_* functions

	* src/xdisp.c (get_narrowed_width, get_narrowed_len): Return at
	least 1 as the value.  (Bug#61704)

2023-02-21  Martin Rudalics  <rudalics@gmx.at>

	* etc/NEWS: Mention new buffer display action alist entries

2023-02-21  Eli Zaretskii  <eliz@gnu.org>

	Fix build --without-xdbe

	* src/xterm.c (x_end_cr_clip, handle_one_xevent): Condition
	double-buffering code on HAVE_XDBE.  (Bug#61667)

2023-02-21  Robert Pluim  <rpluim@gmail.com>

	Improve dnd-direct-save-remote-files docstring

	* lisp/dnd.el (dnd-direct-save-remote-files): Reword.

2023-02-21  Robert Pluim  <rpluim@gmail.com>

	Add 'process-status' to process shortdoc

	* lisp/emacs-lisp/shortdoc.el (process): Add 'process-status'.

2023-02-21  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Improve 5d0b45cd67b

2023-02-21  Robert Pluim  <rpluim@gmail.com>

	Improve text about deleting windows

	* doc/emacs/windows.texi (Change Window): Improve grammar around
	'delete-window-choose-selected'.

2023-02-21  Robert Pluim  <rpluim@gmail.com>

	Make 'emacs-news-cycle-tag' work at all levels

	* lisp/textmodes/emacs-news-mode.el (emacs-news-cycle-tag): Search for
	a heading starting with 2 or more '*' rather than exactly 3.
	* test/lisp/textmodes/emacs-news-mode-resources/cycle-tag.erts
	(Point-Char): Add tests for 2 and 4 '*' levels.

2023-02-21  Mattias Engdegård  <mattiase@acm.org>

	Repair mistake in a previous edmacro-sanitize-string change

	* lisp/edmacro.el (edmacro-sanitize-for-string):
	This condition should not have been 'repaired' but removed altogether.
	Do so now, fixing bug#61647.

	Reported by Eduardo Ochs.

	(cherry picked from commit 4eefadad0670ad1c3da2505d734e528d54c76bef)

2023-02-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	regex-emacs.c: Reduce the use of backtracking a bit further

	bug#61514 exhibited some undesirable backtracking in a case where
	it's easy to avoid it by making `mutually_exclusive_p` just a bit
	more careful.

	* src/regex-emacs.c (mutually_exclusive_p): Handle `on_failure_jump`s.

	* test/src/regex-emacs-tests.el (regexp-tests-backtrack-optimization):
	Add a few tests.

2023-02-20  João Távora  <joaotavora@gmail.com>

	Eglot: respect user's Eldoc configuration by default

	This change addresses the problems reported in many Elglot reports
	dating back to early 2021 at least:

	  https://github.com/joaotavora/eglot/issues/648
	  https://github.com/joaotavora/eglot/issues/894
	  https://github.com/joaotavora/eglot/issues/920
	  https://github.com/joaotavora/eglot/issues/1031
	  https://github.com/joaotavora/eglot/issues/1171

	In one form or another, the reports point out that the multiple pieces
	of information about the "thing at point" made available by the LSP
	server are not all being considered by the ElDoc system.

	The reason for this is Eglot setting/trampling the variables
	'eldoc-documentation-strategy' and 'eldoc-documentation-functions' in
	its minor more entry function.

	The reason it did that is historical and is partially described in the
	issues above.  But, evidently, it never made much sense, because so
	many people want to override it, which requires setting
	'eldoc-documentation-strategy' to the non-default value
	'eldoc-documentation-compose'.

	The problem was made worse by the fact that setting it as usual in
	either the Customize menu or their init file didn't work, requiring a
	fairly complex Elisp snippet.  That is now solved as of this commit.

	If the user does not do any setting, then Eglot works basically the
	same as before (i.e. shows only one piece of information).

	It is arguable that the default value for
	'eldoc-documentation-strategy' should change globally to
	'eldoc-documentation-compose', but that has other subtle implications
	and is not part of this commit.

	* lisp/progmodes/eglot.el (eglot--managed-mode): Don't set Eldoc
	variables greedily.

2023-02-20  Andrea Corallo  <akrl@sdf.org>

	Make the native compiler always use `make-temp-file' for temporary files

	* src/comp.c (CALL4I): Define macro.
	(Fcomp__compile_ctxt_to_file): Use `make-temp-file' instead of
	`make-temp-file-internal'.
	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Likewise.

2023-02-20  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-216-gfe40342

2023-02-20  Daniel Martín  <mardani29@yahoo.es>

	Add declaration_list to c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Consider a
	"declaration_list" a block. (Bug#61635)
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts (Code): Add a
	test case.

2023-02-20  Theodor Thornhill  <theo@thornhill.no>

	Typescript-ts-mode: Add switch case handling

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): New rules.

2023-02-20  Theodor Thornhill  <theo@thornhill.no>

	Fix object initializer for csharp-mode (bug#61541)

	* lisp/progmodes/csharp-mode.el (csharp-guess-basic-syntax): Make sure
	we check the openers as well as closers.

2023-02-20  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-34-geea8da

2023-02-19  Yuan Fu  <casouri@gmail.com>

	Improve tree-sitter indent anchor prev-adaptive-prefix (bug#61314)

	Now prev-adaptive-prefix looks at the current line and checks if it
	begins with a prefix itself.  If it does, prev-adaptive-prefix tries
	to place the anchor before the prefix on the previous line, rather
	than after it.

	 - prev line
	 - this line -> This line starts with a "-", i.e., begins with a
	                prefix, so we place the anchor at the beginning of the
	                 "-" of the previous line, rather than after it

	 - prev line
	   this line -> This line doesn't start with a prefix, so the anchor
	                is placed after the previous line's "-".

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el:
	(treesit-simple-indent-presets): Add local variable
	this-line-has-prefix, base what anchor to return on the value of
	this-line-has-prefix and whether the prev line has a prefix.

2023-02-19  Theodor Thornhill  <theo@thornhill.no>

	Adjust jsx indentation

	We can use the fact that 'treesit-indent-1' uses 'treesit-node-on'
	when on a whitespace to set the actual current node as parent.  Now we
	can correctly indent the 'jsx_text' nodes.  We also add some more
	electric-indent-chars so that auto-indenting of jsx behaves a little
	more fluently.

	* lisp/progmodes/js.el (js--treesit-indent-rules): Add new rules.
	(js-ts-mode): Add more indent-chars.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): Add new rules.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-base-mode): Add more indent-chars and layout rules.

2023-02-19  Theodor Thornhill  <theo@thornhill.no>

	Cleanup preproc indent for c-ts-mode (bug#61558)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Make sure we
	indent to great-grand-parent if inside an #ifdef...#endif block.  If
	grand-parent is root node, then don't indent one step.
	(c-ts-mode--preproc-offset): New helper anchor function to calculate
	indent offset.

2023-02-19  Theodor Thornhill  <theo@thornhill.no>

	Add comment style toggle for c-ts-mode (bug#61550)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-toggle-comment-style): New
	command.
	(c-ts-base-mode-map): Add binding.
	(c-ts-mode-set-modeline): New function.
	(c-ts-mode): Set modeline.
	(c++-ts-mode): Set modeline.

2023-02-19  Juri Linkov  <juri@linkov.net>

	* lisp/simple.el (choose-completion): Check for completion-in-region-mode.

	Don't use base-affixes when completion-use-base-affixes is non-nil
	in completion-in-region-mode (bug#61535).

2023-02-19  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--font-lock-settings: Avoid the explicit 'default' face

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--fontify-scope)
	(rust-ts-mode--fontify-tail): New functions.
	(rust-ts-mode--font-lock-settings): Use them instead of a lot of
	more complex queries (bug#61302).  Thus avoid having to create
	block fontification by other features using the 'default' face.
	Replace the catch-all query for 'variable' with an enumeration of
	possible parent nodes.

2023-02-19  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/progmodes/xref.el: Bump the version.

2023-02-19  Dmitry Gutov  <dgutov@yandex.ru>

	xref--insert-xrefs: Use 'shadow' for the line number colon

	* lisp/progmodes/xref.el (xref--insert-xrefs): Use face 'shadow' for
	the line number colon instead of continuing it face (bug#61340).

	(cherry picked from commit d6d25a3c221e566de4df5319181e9ba9a8df285e)

2023-02-19  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el (xref--insert-xrefs): Remove extra space (bug#61340).

	(cherry picked from commit 643a11c6e5defc0a34da1a53b64aa1e097298923)

2023-02-19  Mattias Engdegård  <mattiase@acm.org>

	Backport: Fix xref-clear-marker-stack refactoring mistake

	* lisp/progmodes/xref.el (xref-clear-marker-stack):
	Clear the history correctly.  Changing a lexical variable has no effect.

	(cherry picked from commit dfdc0f5fb7b10e737c3c8e2bdb1eb873a1e91bd7)

2023-02-19  Stefan Kangas  <stefankangas@gmail.com>

	Merge from origin/emacs-28

	f5a99945b6f ; Update ChangeLog for Emacs 28.3
	f7bd5ac5521 Update HISTORY for Emacs 28.3

	# Conflicts:
	#	etc/NEWS

2023-02-19  Stefan Kangas  <stefankangas@gmail.com>

	Merge from origin/emacs-28

	4a77fcb1478 Update ChangeLog and AUTHORS for Emacs 28.3

2023-02-19  Manuel Giraud  <manuel@ledu-giraud.fr>

	More doc on image-dired-dired-* (bug#61624)

	* doc/emacs/dired.texi (Image-Dired): Some fixes and more
	documentation about image-dired-dired-* commands.

2023-02-19  Theodor Thornhill  <theo@thornhill.no>

	Eglot: improve treatment of completion items without :sortText (bug#61532)

	Previously, defaulting to the empty string put candidates without
	:sortText to the top of the list.  since string-lessp is safe with nil
	arguments, this makes them sort to the end instead.

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Simplify.

2023-02-19  Eli Zaretskii  <eliz@gnu.org>

	Fix invocation of File->Close from the menu bar

	* lisp/simple.el (kill-buffer--possibly-save): Don't request
	LONG-FORM from 'read-multiple-choice' if GUI dialog should be
	used.
	* lisp/emacs-lisp/rmc.el (read-multiple-choice): Doc fix.
	(read-multiple-choice--short-answers): Don't append "?" to
	CHOICES and don't display the prompt in the echo area if GUI
	dialog is used.  Use 'use-dialog-box-p'.  (Bug#61553)

2023-02-19  Manuel Giraud  <manuel@ledu-giraud.fr>

	Update thumbnail buffer's header more

	* lisp/image/image-dired.el (image-dired-display-thumbs): Call
	image-dired--update-header-line.  (Bug#61508)

2023-02-18  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-query-validate): Fix reusing the output buffer

	* lisp/treesit.el (treesit-query-validate): Fix the "Buffer is
	read-only" error when an output buffer already exists.

2023-02-18  Dmitry Gutov  <dgutov@yandex.ru>

	(rust-ts-mode--font-lock-settings): Highlight closure parameters

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--font-lock-settings): Highlight closure parameters.

2023-02-18  Andrea Corallo  <akrl@sdf.org>

	* Fix `native-comp-enable-subr-trampolines' semantic

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Interpret
	`native-comp-enable-subr-trampolines' relative to
	`invocation-directory'.

2023-02-18  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'just-one-space' and 'delete-horizontal-space'

	* lisp/simple.el (just-one-space, delete-horizontal-space):
	Mention the effect of prefix argument.  (Bug#61609)

2023-02-18  martin rudalics  <rudalics@gmx.at>

	Fix 'display-buffer-use-least-recent-window'

	* src/window.c (Fwindow_use_time): Doc fix.
	(Fwindow_bump_use_time): Bump use time of the seleceted window as
	well.  Doc fix.

	* lisp/window.el (display-buffer-avoid-small-windows): Remove.
	All users changed.
	(window--display-buffer): Bump window use time when requested.
	(display-buffer--lru-window): New function.
	(display-buffer-use-some-window): Use it.
	(display-buffer-use-least-recent-window): Rewrite and enhance doc
	string.

	* doc/lispref/windows.texi (Selecting Windows)
	(Buffer Display Action Functions, Buffer Display Action Alists)
	(The Zen of Buffer Display): Improve and update documentation of
	window selection and display facilities.

2023-02-18  kobarity  <kobarity@gmail.com>

	Fix point moving when calling python-shell-send-region

	* lisp/progmodes/python.el (python-shell-buffer-substring): Add
	`save-excursion' to prevent the point from moving.
	* test/lisp/progmodes/python-tests.el (python-tests-should-not-move):
	New helper function to assert that point does not move while calling a
	function.
	(python-shell-buffer-substring-*): Use
	`python-tests-should-not-move'. (Bug#61463)

2023-02-18  Omar Polo  <op@omarpolo.com>

	(project-try-vc): Remove unused defvar/require

	* lisp/progmodes/project.el (project-try-vc):
	Remove unused defvar/require (bug#61577).

2023-02-18  Stefan Kangas  <stefankangas@gmail.com>

	Delete redundant question from Gnus FAQ

	* doc/misc/gnus-faq.texi (FAQ 1-2): Delete redundant question.
	(FAQ 1-1, FAQ 1-3): Adjust accordingly.

2023-02-18  Stefan Kangas  <stefankangas@gmail.com>

	Slightly improve hashcash documentation

	* lisp/mail/hashcash.el: Improve Commentary.
	(hashcash-program):
	* lisp/gnus/message.el (message-generate-hashcash): Improve
	docstring.

2023-02-18  Eli Zaretskii  <eliz@gnu.org>

	Fix cursor motion when there's line-prefix and display string at BOL

	* src/xdisp.c (move_it_in_display_line_to): Handle 'line-prefix' and
	'wrap-prefix' when the screen line has a display string at its
	beginning.  (Bug#61580)

2023-02-18  Yuan Fu  <casouri@gmail.com>

	Fix comment in treesit_record_change (bug#61369)

	Turns out the previous commit message and comment is not entirely
	correct: the old behavior is in fact wrong, not just "correct but has
	problems".

	Here is why the old code is wrong:

	|visible range|     -> markup for visible range

	updated range       -> markup for updated range
	-------------

	First we have some text

	|aaaaaa|

	Now we insert something at the beginning, because we clip
	new_end_offset to visible_end, out of eight b's inserted, only the
	first six are known to tree-sitter.

	|bbbbbbbbaaaa|aa  start: 0, old_end: 0, new_end: 6
	 ------

	In treesit_sync_visible_region, we sync up visible region, but the two
	missing b's are not in the updated range.

	|bbbbbbbbaaaaaa|  start: 12, old_end: 12, new_end: 14
	             --

	The old behavior not only is wrong, but also doesn't make much sense.

	* src/treesit.c (treesit_record_change): Update comment.

2023-02-18  Stefan Kangas  <stefankangas@gmail.com>

	Spell out RPN abbreviation in Calc manual intro

	* doc/misc/calc.texi (What is Calc, Demonstration of Calc)
	(RPN Tutorial): Spell out "Reverse Polish notation" abbreviation.

2023-02-18  Eli Zaretskii  <eliz@gnu.org>

	Fix some uses of 'use-dialog-box'

	* lisp/frame.el (display-mouse-p): Fix return value on MS-Windows
	in batch invocations.
	* lisp/hi-lock.el (hi-lock-unface-buffer): Don't consider
	'last-nonmenu-event' being nil as a mouse event, for the purpose
	of using dialog boxes.

2023-02-18  Eli Zaretskii  <eliz@gnu.org>

	Fix hi-lock-tests when 'use-dialog-box' is non-nil

	* test/lisp/hi-lock-tests.el (hi-lock-case-fold)
	(hi-lock-unhighlight): Bind 'use-dialog-box' to nil.

2023-02-18  Eli Zaretskii  <eliz@gnu.org>

	Fix regression due to change in face sort order by 'face-list'

	* lisp/faces.el (x-create-frame-with-faces): Undo reversing of
	the face list, which is no longer necessary, since 'face-list's
	sorting order has been reversed recently.  (Bug#61521)

2023-02-17  Po Lu  <luangruo@yahoo.com>

	* lisp/files.el (file-equal-p): Work around Haiku stat bug.

2023-02-17  Dmitry Gutov  <dgutov@yandex.ru>

	(project-vc-backend-markers-alist): Add entry for vc-got

	* lisp/progmodes/project.el (project-vc-backend-markers-alist):
	Add entry for vc-got (bug#61577).  Bump the version.

2023-02-17  Dmitry Gutov  <dgutov@yandex.ru>

	project.el: Extract backend->marker association for a defvar

	* lisp/progmodes/project.el (project-vc-backend-markers-alist):
	Extract from 'project-try-vc'.
	(project-try-vc): Update accordingly (bug#61577).

2023-02-17  Yuan Fu  <casouri@gmail.com>

	Don't completely clip into visible range in treesit_record_change

	(Bug#61369)

	From
	    min (visible_end, max (visible_beg, new_end_byte)) - visible_beg
	to
	    max (visible_beg, new_end_byte) - visible_beg

	* src/treesit.c (treesit_record_change): We don't clip the new end
	into the visible range anymore.  If you think of it, when inserting in
	a narrowed region, the visible region is always extended to
	accommodate more text, rather than pushing text at the end to keep the
	size of the visible region.

2023-02-17  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/treesit.el (treesit-node-at): Update docstring (bug#61529).

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/calc/calc.el (calc-mode): Improve docstring.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.3

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.3.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for Emacs 28.3

	* ChangeLog.3:
	* etc/AUTHORS: Update for Emacs 28.3.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update HISTORY for Emacs 28.3

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update NEWS for Emacs 28.3

	* etc/NEWS: Update for Emacs 28.3.

2023-02-17  Andrea Corallo  <akrl@sdf.org>

	Merge 'emacs-29' into 'feature/inhibit-native-comp-cleanup'

2023-02-17  Eli Zaretskii  <eliz@gnu.org>  (tiny change)

	Fix order of faces in 'face-list'

	* lisp/faces.el (frame-face-alist, face-list): Sort faces in
	decreasing order of face IDs.  Patch by Brennan Vincent
	<brennan@umanwizard.com>.  (Bug#61521)

2023-02-17  Eli Zaretskii  <eliz@gnu.org>

	Allow 'icon-title-format' to have the value t

	* src/xdisp.c (gui_consider_frame_title, syms_of_xdisp): If the
	value of 'icon-title-format' is t, use 'frame-title-format'
	instead.  (Bug#61496)

	* etc/NEWS:
	* doc/lispref/frames.texi (Frame Titles): Document the new
	handling of the value t.
	(Basic Parameters): Fix the documentation of the 'title' and
	'name' frame parameters.

2023-02-16  Theodor Thornhill  <theo@thornhill.no>

	Add electric indent for preproc directives

	It looks like there are few if no other cases where we get this
	particular error in the AST than with insertion of '#'.

	Consider:

	```
	int
	main()
	{
	  |
	}
	```

	If we only add '#' the AST yields (ERROR (ERROR)), which we can
	exploit to hook onto electric indent.  The end result should be the
	hashtag anchored to column 0.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule.
	(c-ts-base-mode): Add # to electric-indent-chars.

2023-02-16  Robert Pluim  <rpluim@gmail.com>

	Rename 'emacs-news-toggle-tag' to 'emacs-news-cycle-tag'

	* lisp/textmodes/emacs-news-mode.el (emacs-news-cycle-tag): Renamed
	from 'emacs-news-toggle-tag'.
	(emacs-news-mode-map, emacs-news-mode-menu): Use new name.
	* test/lisp/textmodes/emacs-news-mode-resources/cycle-tag.erts:
	Renamed from "toggle-tag.erts".
	* test/lisp/textmodes/emacs-news-mode-tests.el (emacs-news-cycle-tag):
	Rename test from 'emacs-news-toggle-tag', and call
	'emacs-news-cycle-tag' with new resource file name.

2023-02-16  Robert Pluim  <rpluim@gmail.com>

	Add menu to news-mode

	* lisp/textmodes/emacs-news-mode.el (emacs-news-mode-map): Add binding
	for 'emacs-news-delete-temporary-markers'.
	(emacs-news-mode-menu): Add menu for common actions.

2023-02-16  Philip Kaludercic  <philipk@posteo.net>

	Attempt to recognise if a VC package has no Elisp files

	* lisp/emacs-lisp/package-vc.el (package-vc-non-code-file-names): Add
	new variable used to avoid false-positives.
	(package-vc--unpack): Recursively search for .el files excluding the
	ones listed in 'package-vc-non-code-file-names', offering to abort the
	installation if none are found.

2023-02-15  Eli Zaretskii  <eliz@gnu.org>

	Fix mule-tests under en_US.UTF-8 locale

	* test/lisp/international/mule-tests.el (sgml-html-meta-utf-8):
	Accept also utf-8-unix/dos/whatever.  (Bug#61534)

	* lisp/international/mule.el
	(sgml-html-meta-auto-coding-function): Fix comparison when
	buffer-file-coding-system is of type 'charset'.

2023-02-15  Theodor Thornhill  <theo@thornhill.no>

	Move block closer above declaration_list rule (bug#61531)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Move rule
	above the previous rule.

2023-02-15  Eli Zaretskii  <eliz@gnu.org>

	Minor improvements in c-ts-mode and docs

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode-map): Add a binding
	for comment-region.

	* doc/emacs/programs.texi (C Indent): Mention "C-u TAB".

2023-02-15  Theodor Thornhill  <theo@thornhill.no>

	Add super node as a keyword

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--font-lock-settings): Add new node.

2023-02-15  Stefan Kangas  <stefankangas@gmail.com>

	Delete perplexing paragraph from Gnus manual

	* doc/misc/gnus.texi (Exiting Gnus): Delete a confusing paragraph,
	that may or may not have been intended as a joke.  (Bug#61325)

2023-02-14  ~kby  <kby@tilde.team>  (tiny change)

	Eglot: check server capability before sending didSave (bug#61478)

	* lisp/progmodes/eglot.el (eglot--signal-textDocument/didSave): check
	server capability.

2023-02-14  Randy Taylor  <dev@rjt.dev>

	Fix rust-ts-mode type and module highlighting (Bug#61302)

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Specify import queries to avoid clashing with scoped identifiers in
	the code.  Highlight attributes with font-lock-preprocessor-face.

2023-02-14  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Highlight variable reassignments

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode):
	New treesit font-lock feature: 'assignment' (bug#61302).
	(rust-ts-mode--fontify-pattern): Remove the node lookup step.
	(rust-ts-mode--font-lock-settings): Update variable declaration
	queries to match the 'pattern' child node right away.  Add
	highlights for 'assignment.

2023-02-14  Gregory Heytings  <gregory@heytings.org>

	Improve backward compatibility of save-restriction

	* src/editfns.c (save_restriction_save_1): Renamed from
	'save_restrictions_save'.  Make it static.
	(save_restriction_restore_1): Renamed from
	'save_restriction_restore'.  Make it static.
	(save_restriction_restore): New function, combining
	'save_restriction_save_1' and 'narrowing_locks_save'.
	(save_restriction_save): New function, combining
	'save_restriction_restore_1' and 'narrowing_locks_restore'.
	(Fsave_restriction): Restore the previous code.
	(narrowing_locks_save, narrowing_locks_restore): Make them static.

	* src/lisp.h: Remove two functions that are not externally visible
	anymore.

	* src/comp.c (helper_save_restriction): Restore the previous code.

	* src/bytecode.c (exec_byte_code): Restore the previous code.

	* lisp/emacs-lisp/bytecomp.el (byte-compile-save-restriction):
	Decrement unbinding count.

2023-02-14  Theodor Thornhill  <theo@thornhill.no>

	Don't indent template_string contents (bug#61503)

	* lisp/progmodes/js.el (js--treesit-indent-rules): Add new rule.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): Add new rule.

2023-02-14  Jostein Kjønigsen  <jostein@kjonigsen.net>

	csharp-ts-mode: fontify compiler directives (bug#61512)

	lisp/progmodes/csharp-mode.el: Add tree-sitter-queries for known C#
	compiler-directives.

2023-02-14  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-209-gdab1dfa

2023-02-14  Andrea Corallo  <akrl@sdf.org>

	* Generate trampolines in a temporary directory if no other option is viable

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Use
	temporary file if no other option is viable.

2023-02-13  Eli Zaretskii  <eliz@gnu.org>

	Rename with/without-narrowing to with/without-restriction

	* doc/lispref/commands.texi:
	* doc/lispref/display.texi:
	* doc/lispref/positions.texi:
	* etc/NEWS:
	* lisp/subr.el:
	* src/buffer.c:
	* src/editfns.c:
	* src/keyboard.c:
	* src/xdisp.c:
	* test/src/buffer-tests.el: Rename with-narrowing and
	without-narrowing to with-restriction and without-restriction.
	Likewise with internal--with-narrowing and
	internal--without-narrowing.  All callers and documentation
	changed.

2023-02-13  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el: Rename internal function and variable (bug#60980)

	(repeat--transient-exitfun): Rename internal variable from
	'repeat-exit-function'.
	(repeat--clear-prev): Rename internal function from
	'repeat--exit'.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	* Fix previous change

	* lisp/emacs-lisp/generate-lisp-file.el (generate-lisp-file-trailer):
	Fix previous change b6e2799aa1c.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Rename native-comp-deferred-compilation-deny-list

		* lisp/emacs-lisp/comp.el (native-comp-jit-compilation-deny-list)
		(native-compile-async-skip-p): Rename
		native-comp-deferred-compilation-deny-list into
		native-comp-jit-compilation-deny-list.
		(native-comp-deferred-compilation-deny-list): Mark it obsolete.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Rename native-comp-deferred-compilation into native-comp-jit-compilation

		* src/comp.c (maybe_defer_native_compilation, syms_of_comp):
		Rename native-comp-deferred-compilation into
		native-comp-jit-compilation.

		* lisp/subr.el (native-comp-deferred-compilation): Mark
		native-comp-deferred-compilation as obsolete.

		* lisp/startup.el (native-comp-deferred-compilation)
		(normal-top-level): Rename native-comp-deferred-compilation into
		native-comp-jit-compilation.

		* lisp/progmodes/elisp-mode.el
		(emacs-lisp-native-compile-and-load): Likewise.

		* lisp/emacs-lisp/generate-lisp-file.el
		(generate-lisp-file-trailer): Likewise.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Rename comp-enable-subr-trampolines into native-comp-enable-subr-trampolines

		* src/data.c (Ffset): Rename comp-enable-subr-trampolines into
		native-comp-enable-subr-trampolines.

		* src/comp.c (syms_of_comp): Likewise.

		* lisp/subr.el (comp-enable-subr-trampolines): Make
		comp-enable-subr-trampolines obsolete.

		* lisp/startup.el (native-comp-enable-subr-trampolines)
		(normal-top-level): Rename comp-enable-subr-trampolines into
		native-comp-enable-subr-trampolines.

		* lisp/loadup.el (dump-mode): Likewise.

		* lisp/emacs-lisp/comp.el (comp-subr-trampoline-install)
		(comp--trampoline-abs-filename): Likewise.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (native-comp-never-optimize-functions): Improve doc

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Support `comp-enable-subr-trampolines' as string value

	* src/comp.c (syms_of_comp): Update `comp-enable-subr-trampolines'.

	* lisp/emacs-lisp/comp.el (native-comp-never-optimize-functions)
	(comp--trampoline-abs-filename): Support
	`comp-enable-subr-trampolines' string value.

	* src/data.c (Ffset): Use Vcomp_enable_subr_trampolines now.

2023-02-13  Gregory Heytings  <gregory@heytings.org>

	Merge branch 'scratch/fix-locked-narrowing'

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	* Some more `inhibit-native-compile' clean-up

	* lisp/emacs-lisp/generate-lisp-file.el (generate-lisp-file-trailer):
	Use `native-comp-deferred-compilation'.

2023-02-13  Gregory Heytings  <gregory@heytings.org>

	Minor improvements to labeled narrowing

	* lisp/subr.el (internal--with-narrowing):
	(internal--without-narrowing): Remove unnecessary 'progn'.

	* etc/NEWS: Mention 'with-narrowing' in the entry about long
	lines.

	* doc/lispref/positions.texi (Narrowing): Fix typo.

	* doc/lispref/display.texi (Auto Faces): Use @pxref.

	* doc/lispref/commands.texi (Command Overview): Use @pxref.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Revert "Add new variable 'inhibit-native-compilation'"

	This reverts commit 5fec9182dbeffa88cef6651d8c798ef9665d6681.

2023-02-13  Andrea Corallo  <akrl@sdf.org>

	Revert "Rename to inhibit-automatic-native-compilation"

	This reverts commit f97993ee667f9be7589825f3a4fbc095d6944ec6.

2023-02-13  Ulrich Müller  <ulm@gentoo.org>

	Fix spurious display of eclipses in Calendar

	* lisp/calendar/lunar.el (eclipse-check): Don't show an eclipse
	unless the phase is new moon or full moon. (bug#61460)
	* test/lisp/calendar/lunar-tests.el (lunar-test-eclipse-check)
	(lunar-test-phase-list): Update tests.

2023-02-12  Yuan Fu  <casouri@gmail.com>

	Fix indentation for closing bracket in c-ts-mode (bug#61398)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): Move the rule earlier.
	(c-ts-base-mode): Add move block type.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New tests.

2023-02-12  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-31-gaf1bb1

2023-02-12  Alan Mackenzie  <acm@muc.de>

	* src/.gdbinit (nextcons): Amend $.u.cdr to $.u.s.u.cdr (bug#61453).

	(cherry picked from commit dde023b63ab82c38d33815409de5552f5bf349d1)

2023-02-12  Theodor Thornhill  <theo@thornhill.no>

	Add lambda_expression to c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/java-ts-mode.el (java-ts-mode): Tweak regexp.

2023-02-12  Philip Kaludercic  <philipk@posteo.net>

	Tolerate missing elpa-packages.eld files

	* lisp/emacs-lisp/package-vc.el
	(package-vc--download-and-read-archives): Replace
	'condition-case-unless-debug' with a regular 'condition-case'.

	It appears a few people using third-party archives that don't serve
	package specifications have been having issues with package-vc, when
	toggle-on-error is enabled.  In their case, package-vc would raise an
	error in its first invocation, but it would go on working normally
	afterwards.  As this behaviour is confusing and the user can't do much
	about a missing elpa-packages.eld to begin with, we satisfy ourselves
	with printing out a message and continuing on.

2023-02-12  Eli Zaretskii  <eliz@gnu.org>

	Avoid warning about 'load-path' in non-interactive sessions

	* lisp/startup.el (command-line): Emit the warning about
	'user-emacs-directory' in 'load-path' only in interactive
	sessions.  (Bug#61014)

2023-02-12  Ulrich Müller  <ulm@gentoo.org>

	Support webkit2gtk-4.1

	* configure.ac: Check for webkit2gtk API version 4.1 first, then
	fall back to 4.0.

2023-02-10  Gregory Heytings  <gregory@heytings.org>

	Save and restore the absence of narrowing locks

	* src/editfns.c (narrowing_locks_save): Return the buffer with a
	empty locks list when the current buffer has no narrowing locks.
	(narrowing_locks_restore): Remove the narrowing locks if the
	buffer had no narrowing locks.

2023-02-10  Tassilo Horn  <tsdh@gnu.org>

	bug-reference: prevent match-data clobbering (bug#61395)

	* lisp/progmodes/bug-reference.el (bug-reference-fontify): Wrap call
	to syntax-ppss in save-match-data since it can clobber our
	match-data (bug#61395).

2023-02-10  Yuan Fu  <casouri@gmail.com>

	Rename LIMIT to DEPTH in tree-sitter functions (bug#61231)

	I only changed the Lisp functions, internal functions are left
	unchanged.

	* doc/lispref/parsing.texi (Retrieving Nodes): Update manual.
	* src/treesit.c (Ftreesit_search_subtree)
	(Ftreesit_induce_sparse_tree): Change LIMIT to DEPTH.

2023-02-09  Yuan Fu  <casouri@gmail.com>

	Add 'live' property to treesit-node-check (bug#61235)

	* doc/lispref/parsing.texi (Accessing Node Information): Document.
	* src/treesit.c (treesit_parser_live_p): New function.
	(Ftreesit_node_check): Add 'live' property.
	* test/src/treesit-tests.el (treesit-node-api): Add tests.

2023-02-09  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-205-gb8ad0da

2023-02-09  Eli Zaretskii  <eliz@gnu.org>

	Fix 'rmail-summary-output'

	* lisp/mail/rmailsum.el (rmail-summary-output): Fix deletion of
	messages when 'rmail-output-reset-deleted-flag' is non-nil.
	(Bug#61380)

2023-02-09  Nicolas Martyanoff  <nicolas@n16f.net>

	lisp-mode: add docstring recognition for more common lisp symbols

	* lisp/emacs-lisp/lisp-mode.el (define-compiler-macro)
	(define-setf-expander, deftype): Add the 'doc-string-elt'
	property for proper docstring highlighting in Common Lisp.

2023-02-09  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-204-gecff8c2

2023-02-09  Eli Zaretskii  <eliz@gnu.org>

	Fix Scala entry in Eglot's DB of LSP servers

	* lisp/progmodes/eglot.el (eglot-server-programs): Support Scala
	LSP named "metals", in addition to "metals-emacs".  (Bug#61312)

2023-02-08  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Also don't reindent 'identifier' when inside ERROR

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Also don't reindent 'identifier' when inside ERROR.

2023-02-08  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix indentation inside empty if/unless/case/def

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Add new rule.

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-indent-empty-if-else): New test.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Add an extensive test for labeled (locked) narrowing

	* test/src/buffer-tests.el (test-labeled-narrowing): New test.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Update the documentation about labeled (locked) narrowing

	* src/xdisp.c (syms_of_xdisp) <fontification-functions>: Update
	docstring.

	* src/keyboard.c (syms_of_keyboard) <pre-command-hook>:
	(syms_of_keyboard) <post-command-hook>: Update docstring.

	* src/editfns.c:
	(narrowing_locks): Explain why an alist is used instead of a
	buffer-local variable.
	(reset_outermost_narrowings): Point to recipes that demonstrate
	why it is necessary to restore the user narrowing bounds when
	redisplay starts.
	(Fwiden): Update docstring.
	(Fnarrow_to_region): Update docstring.
	(Finternal__lock_narrowing): Update docstring.
	(Finternal__unlock_narrowing): Update docstring.
	(Fsave_restriction): Update docstring.

	* src/buffer.c (syms_of_buffer)
	<long-line-optimizations-region-size>: Update docstring.
	(syms_of_buffer) <long-line-optimizations-bol-search-limit>:
	Update docstring.

	* lisp/subr.el (with-narrowing): Update docstring.
	(without-narrowing): Update docstring.

	* etc/NEWS: Mention the 'long-line-optimizations-region-size' and
	'long-line-optimizations-bol-search-limit' options.
	Announce the 'with-narrowing' and 'without-narrowing' forms.

	* doc/lispref/positions.texi (Narrowing): Update the documentation
	of 'narrow-to-region', 'widen' and 'save-restriction'.  Document
	the 'with-narrowing' and 'without-narrowing' special forms.

	* doc/lispref/display.texi (Auto Faces): Update the documentation.

	* doc/lispref/commands.texi (Command Overview): Document the fact
	that the buffer is narrowed around 'pre-command-hook' and
	'post-command-hook' when the buffer text includes very long lines.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Rename two long line optimizations variables

	* src/buffer.c (syms_of_buffer): Rename two variables.

	* src/xdisp.c (get_locked_narrowing_begv):
	(get_locked_narrowing_zv):
	(handle_fontified_prop): Use the new names.

	* src/keyboard.c (safe_run_hooks_maybe_narrowed): Use the new
	names.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Add specific symbols for narrowings

	* src/xdisp.c (syms_of_xdisp): Define symbol.
	(handle_fontified_prop): Use it.

	* src/keyboard.c (syms_of_keyboard): Define symbol.
	(safe_run_hooks_maybe_narrowed): Use it.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Add 'without-narrowing' macro

	* lisp/subr.el (without-narrowing): New macro, companion (and
	almost identical) to 'with-narrowing'.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Make 'narrowing-lock' and 'narrowing-unlock' internal

	* src/editfns.c (Finternal__lock_narrowing): Renamed from
	'narrowing-lock'.
	(Finternal__unlock_narrowing): Renamed from 'narrowing-unlock'.
	(unwind_narrow_to_region_locked):
	(narrow_to_region_locked):
	(syms_of_editfns): Use the new names.

	* lisp/subr.el (internal--with-narrowing): Use the new name.

2023-02-08  Gregory Heytings  <gregory@heytings.org>

	Fix 'save-restriction' for narrowing locks

	* src/editfns.c (narrowing_locks_save):
	(narrowing_locks_restore): Make them non-static.

	* src/lisp.h: Make them externally visible.

	* src/bytecode.c (exec_byte_code): Save and restore narrowing
	locks.

	* lisp/emacs-lisp/bytecomp.el (byte-compile-save-restriction):
	Increment unbinding count.

	* src/comp.c (helper_save_restriction): Save and restore narrowing
	locks.

2023-02-08  LensPlaysGames  <lensplaysgames@gmail.com>  (tiny change)

	* lisp/iimage.el (iimage-mode-buffer): Handle multiple regexps.

	Go to the beginning of the buffer before searching every regexp in
	iimage-mode-image-regex-alist.

2023-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/edmacro.el (edit-kbd-macro): Fix thinko (bug#61333)

	Backported from commit 2273cdb40e1939f7c29a669f6a64e6a27738c1a5.

2023-02-07  Eli Zaretskii  <eliz@gnu.org>

	Fix crashes inside 'xfree' called from treesit.c

	* src/treesit.c (treesit_load_language): Always xstrdup 'c_name',
	to avoid crashes inside xfree.  (Bug#61351)

2023-02-06  Yuan Fu  <casouri@gmail.com>

	Make java-ts-mode use the c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/java-ts-mode.el:
	(java-ts-mode): Setup c-ts-common-indent-type-regexp-alist.

2023-02-06  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Sign, ok, there's another edge case: else if statements.  Because
	"else if" is usually implemented as just another if statement nested
	in the else branch, this creates additional levels that indentation
	needs to ignore.

	I converted c-ts-common-indent-block-type-regexp +
	c-ts-common-indent-bracketless-type-regexp into a new, more flexible
	variable, c-ts-common-indent-type-regexp-alist, to avoid adding yet
	more variables in order to recognize else and if statements.

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common-indent-type-regexp-alist): New variable.
	(c-ts-common-indent-block-type-regexp)
	(c-ts-common-indent-bracketless-type-regexp): Remove variables.
	(c-ts-common--node-is): New function.
	(c-ts-common-statement-offset): Use the new variable, and add the
	"else if" special case.  Also merge the code of
	c-ts-mode--fix-bracketless-indent, because now the code is much more
	succinct.
	(c-ts-mode--fix-bracketless-indent): Merge into
	c-ts-common-statement-offset.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-base-mode): Setup c-ts-common-indent-type-regexp-alist.

	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-02-06  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Turns out I shouldn't have removed the explicit rules.  Anyway, now it
	indents properly.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Add rules.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Add tests

2023-02-06  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation (bug#61291)

	Fix indentation for the semicolon in

	while (str_a[i++] == str_b[j++])
	  ;

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-02-06  Dmitry Gutov  <dgutov@yandex.ru>

	(eglot-completion-at-point): Return correct values in :company-kind

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Return the
	correct values in :company-kind for "EnumMember" and "TypeParameter".
	The convention is to use kebab case rather than plain downcasing.
	Reported in https://github.com/company-mode/company-mode/issues/1370.

2023-02-06  Mattias Engdegård  <mattiase@acm.org>

	Tighten and simplify typescript compilation-mode regexps (bug#61104)

	* lisp/progmodes/compile.el (compilation-error-regexp-alist-alist):
	Tighten regexps and simplify.  Translate to rx.
	* etc/compilation.txt: Add examples.

	In collaboration with Jostein Kjønigsen.

2023-02-06  Tassilo Horn  <tsdh@gnu.org>

	Clarify bug-reference-auto-setup-functions docstring.

	* lisp/progmodes/bug-reference.el (bug-reference-auto-setup-functions):
	Add clarification to docstring that this variable is for packages, not
	for users.

2023-02-06  Aleksandr Vityazev  <avityazev@posteo.org>

	* lisp/treesit.el (treesit): Fix shortdoc example form (bug#61318).

2023-02-06  Theodor Thornhill  <theo@thornhill.no>

	Use c-ts-common-statement-offset in java-ts-mode (bug#61142)

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Add new
	matchers to enable c-ts-common machinery.
	(java-ts-mode): Add regexps.
	* lisp/progmodes/c-ts-common.el (c-ts-common-statement-offset): Fix
	typo in documentation and use the new if statement helpers.
	(c-ts-common-if-statement-regexp): New defvar.
	(c-ts-common-nestable-if-statement-p): New defvar.
	(c-ts-common--fix-nestable-if-statement): New helper.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Add test for
	complicated bracket matching indentation.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Add indent
	rules for bracketless statements.

2023-02-06  Theodor Thornhill  <theo@thornhill.no>

	Add array_initializer to java-ts-mode

	Indent strings inside arrray_initializer one step:

	public class Java {
	    void foo() {
	        return new String[]{
	            "foo", // These
	            "bar"
	        }
	    }
	}

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): New
	matcher.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	go-ts-mode: Highlight variable declarations

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Highlight variable declarations in 'definition' feature.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	go-ts-mode: Fix highlighting of function name in call_expression

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Remove :override from the 'property' rules and move them above
	'variable' (bug#61302).  Just like in rust-ts-mode.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	c-ts-mode: Highlight "property functions" as functions

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Highlight "property functions" as functions (bug#61302).

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Fix highlighting of function name in call_expression

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Remove :override from the 'property' rules and move them above
	'variable' (bug#61302).

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--font-lock-settings: Improve consistency

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Remove the rule that highlighted scope identifier in a function call
	as type.  The existing rules will handle it when it does look like a
	type (capitalized).

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	Make sure 'M-x show-paren-local-mode' turns on right away

	* lisp/paren.el (show-paren--enabled-p): Extract from
	'show-paren-function'.
	(show-paren-local-mode): Use it in the :variable getter (bug#61098).

2023-02-05  Tassilo Horn  <tsdh@gnu.org>

	Add to bug-reference-auto-setup-functions after its declaring defvar

	If it's the init-value of the defvar, add-hook from a third-party
	package will suppress the default functions if it takes place before
	bug-reference is loaded.

	* lisp/progmodes/bug-reference.el (bug-reference-auto-setup-functions):
	Add to bug-reference-auto-setup-functions after its declaring defvar.

2023-02-05  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc.el (vc-find-revision-no-save): Fix parens (bug#61256).

	Move '(setq failed nil)' from UNWINDFORMS of 'unwind-protect' to BODYFORM.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	Fix inability to turn show-paren-local-mode on manually (bug#61098)

	* lisp/paren.el (show-paren-local-mode): Don't kill the local
	value when both local and global are t.  Because the
	show-paren-predicate check in show-paren-function also checks
	whether a local (non-nil) value of this variable exists.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Highlight variable declarations

	(rust-ts-mode--font-lock-settings): Change scoped_type_identifier
	highlight to match similar cases.  Highlight variable declarations
	inside all kinds of destructuring patterns, not just function
	definitions.
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--fontify-pattern):
	Rename from 'rust-ts-mode--fontify-parameter'.  Check the id node's
	parent to avoid touching type identifiers.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--indent-rules: Indent to 0 at top level

2023-02-05  Alan Mackenzie  <acm@muc.de>

	Ensure upper bound of font-lock region is less than point-max

	This fixes bug #61298.  The new long-lines code may have narrowed a buffer
	before font-lock-default-fontify-region gets called.

	* lisp/font-lock.el (font-lock-default-fontify-region): Set `end' to point-max
	if it is greater that it.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	Highlight more complex function parameters

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--fontify-parameter): New function.
	(rust-ts-mode--font-lock-settings): Use it.

2023-02-05  Jonas Bernoulli  <jonas@bernoul.li>

	No longer use transient in isearch-emoji-by-name

	* lisp/isearch.el (isearch-emoji-by-name): Use 'emoji--read-emoji'
	and if that returns derivations, 'completing-read' to select one
	of them.  This fixes bug#60740.
	* lisp/international/emoji.el (emoji--init): Autoload.
	(emoji--read-emoji): New function, which doesn't use transient
	and returns a list of the glyph and all derivations, if any.
	(emoji--choose-emoji): Use 'emoji--read-emoji'.

2023-02-05  Dmitry Gutov  <dgutov@yandex.ru>

	Make highlighting more regular across TS modes (bug#61205)

	* doc/emacs/display.texi (Parser-based Font Lock):
	Update description of treesit-font-lock-level, moving 'property' to
	level 4.

	* lisp/treesit.el (treesit-font-lock-level): Likewise, in docstring.

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Do that here.

	* lisp/progmodes/cmake-ts-mode.el (cmake-ts-mode): Add a comment.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode): Add 'definition' to
	level 1.  Move 'function', 'property' and 'variable' to level 4.
	(go-ts-mode--font-lock-settings): Move a bunch of existing rules
	to 'definition'.  Add highlighting of function parameters.

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode)
	(rust-ts-mode--font-lock-settings): Same.  And also change "scoped
	identifiers" highlights to only match capitalized names.

2023-02-05  Eli Zaretskii  <eliz@gnu.org>

	Document 'plistp'

	* doc/lispref/lists.texi (Property Lists): Document 'plistp'.
	(Bug#61293)

2023-02-05  Eli Zaretskii  <eliz@gnu.org>

	Fix display of raised/lowered composed text

	* src/xdisp.c (fill_gstring_glyph_string): Adjust the base line of
	the glyph string due to subscript/superscript.  (Bug#61290)

2023-02-05  Eli Zaretskii  <eliz@gnu.org>

	Fix installation of tree-sitter grammar on MS-Windows

	* lisp/treesit.el (treesit--install-language-grammar-1): Fix a
	failure on MS-Windows when the old DLL is still being used.
	(Bug#61289)

2023-02-05  Eli Zaretskii  <eliz@gnu.org>

	Update the Emacs FAQ for Emacs 29

	* doc/misc/efaq.texi (New in Emacs 29, History of Emacs): Add new
	section about Emacs 29.

2023-02-05  Eli Zaretskii  <eliz@gnu.org>

	Fix byte-compilation of *-ts-mode.el files

	* lisp/treesit.el (treesit-font-lock-settings): Move to before
	use, to prevent failure in byte-compiling modes which require this
	file.  (Bug#61282)

2023-02-04  Yuan Fu  <casouri@gmail.com>

	Make c-ts-mode-set-style's effect local (bug#61245)

	Now c-ts-mode-set-style's effect is local, and there is a new function
	c-ts-mode-set-global-style that changes the global setting.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-style-setter): Use c-ts-mode-set-style.
	(c-ts-mode-indent-style)
	(c-ts-mode--prompt-for-style): Minor change in docstring.
	(c-ts-mode-set-global-style): New function (from c-ts-mode-set-style).
	(c-ts-mode-set-local-style): Remove function (became c-ts-mode-set-style).
	(c-ts-mode-set-style): Renamed from c-ts-mode-set-local-style.
	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts:
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Use
	c-ts-mode-set-style.

2023-02-04  Dmitry Gutov  <dgutov@yandex.ru>

	c-ts-mode: Highlight name in parameter declarations

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Uncomment parameter declaration highlighting (bug#61275).
	(c-ts-mode--fontify-declarator): Check that identifier was found.
	Some declarations can miss identifier name.

2023-02-04  Davide Masserut  <dm@mssdvd.com>

	Fix switch statement indentation for go-ts-mode (bug#61238)

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--indent-rules): Add
	indentation for type switch and select case blocks
	* test/lisp/progmodes/go-ts-mode-resources/indent.erts: New .erts file
	to test indentation of Go constructs and prevent regression of bug
	fixes.
	* test/lisp/progmodes/go-ts-mode-tests.el: New file with go-ts-mode
	tests.

2023-02-04  Eli Zaretskii  <eliz@gnu.org>

	Fix bidi reordering of sequence of whitespace characters before a TAB

	* src/bidi.c (bidi_level_of_next_char): Test the current level
	only for characters whose original type is BN.  (Bug#61269)

2023-02-04  Theodor Thornhill  <theo@thornhill.no>

	Add tests for compilation support for TypeScript (bug#61104)

	* test/lisp/progmodes/compile-tests.el
	(compile-tests--test-regexps-data): Add new test-cases.
	(compile-test-error-regexps): Increase expected errors

2023-02-04  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Add support for TypeScript compilation to compile.el (bug#61104)

	* lisp/progmodes/compile.el (compilation-error-regexp-alist-alist):
	Add regexps.

2023-02-04  Eli Zaretskii  <eliz@gnu.org>

	Don't clobber match data in 'y-or-n-p'

	* lisp/subr.el (y-or-n-p): Avoid clobbering caller's match data.
	(Bug#61091)

2023-02-03  Dmitry Gutov  <dgutov@yandex.ru>

	Refine the previous change

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query): Fix a typo.
	(ruby-ts--syntax-propertize): Use pcase-exhaustive to avoid typos.
	Put the last s-t property after heredoc's end (apparently
	parse-partial-sexp likes that more).  Move first s-t property on
	percent literals to the very beginning (to be refined later).
	Differentiate the %r{} literals from /.../ ones -- tree-sitter
	parses them exactly the same.

2023-02-03  Dmitry Gutov  <dgutov@yandex.ru>

	Add syntax-propertize-function to ruby-ts-mode

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query):
	New variable.
	(ruby-ts--syntax-propertize): New function.
	(ruby-ts--parser-after-change): New function.
	(ruby-ts-mode): Use both of them.

2023-02-03  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'header-line-indent-mode'

	* doc/lispref/modes.texi (Header Lines): Rewrite the documentation
	of 'header-line-indent-mode' and its two variables.  Fix the
	example.
	* doc/lispref/display.texi (Pixel Specification): More accurate
	description of what happens with :align-to in header-lines.
	Improve indexing.  (Bug#61239)

	* src/buffer.c (syms_of_buffer) <header-line-format>:
	* lisp/display-line-numbers.el (header-line-indent)
	(header-line-indent-width, header-line-indent-mode): Doc fixes.

	* etc/NEWS: Enhance the announcement of 'header-line-indent-mode'.

2023-02-03  F. Jason Park  <jp@neverwas.me>

	Don't casemap erc-sasl-user when set to :nick

	* lisp/erc/erc-sasl.el (erc-sasl-user): Fix doc string.
	(erc-sasl--get-user): Don't apply casemapping when the option
	`erc-sasl-user' is set to `:nick'.  While many servers and
	auth-services providers perform case-folding when comparing SASL
	usernames, only some recognize RFC1459 mappings, which ERC previously
	applied blindly.  Instead, ERC now behaves like other clients in
	leaving such preparation in the hands of the server.  This bug was
	introduced with changes new to ERC 5.5 and Emacs 29 (bug#29108).

2023-02-03  Robert Pluim  <rpluim@gmail.com>

	Improve keymap-global-set and keymap-local-set interactive use fix

	* lisp/keymap.el (keymap-global-set, keymap-local-set): Add optional
	`interactive' arg and use it to decide when to convert the key
	specification to a string.  Add `advertised-calling-convention'
	declarations.  (Bug#61149)

2023-02-02  Yuan Fu  <casouri@gmail.com>

	Make c-ts-mode indent tests side-effect-free

	Running indent tests changes the global value of
	c-ts-mode-indent-style.  That's not good.  This change fixes that.

	I also refactored the indent style functions a bit.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--prompt-for-style): New function.
	(c-ts-mode-set-local-style): New function.
	(c-ts-mode-set-style): Use c-ts-mode--prompt-for-style.  Use
	derived-mode-p when testing for major mode.  Remove check of current
	buffer's major mode since it doesn't matter.

	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts:
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Use
	c-ts-mode-set-local-style to set the indent style locally.

2023-02-02  Yuan Fu  <casouri@gmail.com>

	Call treesit_record_change in insert_from_gap_1

	Before this change, insert_from_gap calls treesit_record_change but
	insert_from_gap_1 doesn't.  However, insert_from_gap_1 is a public
	function and is called in many other places outside of insdel.c.  This
	could lead to tree-sitter's parse tree becoming out-of-sync with the
	buffer content.

	This change might fix bug#60650.

	* src/insdel.c (insert_from_gap_1): Call treesit_record_change.
	(insert_from_gap): Remove call to treesit_record_change.

	* admin/notes/tree-sitter/treesit_record_change: New file.

2023-02-02  Yuan Fu  <casouri@gmail.com>

	Use c-ts-common-statement-offset for closing brackets too

	Merge c-ts-mode--close-bracket-offset into
	c-ts-common-statement-offset.

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common-statement-offset): Handle closing brackets too.
	(c-ts-mode--close-bracket-offset): Remove function.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Use
	c-ts-common-statement-offset for closing brackets.

2023-02-02  Eli Zaretskii  <eliz@gnu.org>

	Minor improvements in sqlite.c

	* src/sqlite.c (Fsqlite_next): Doc fix.  Return nil if SQLITE_DONE
	was once seen for this statement.  (Bug#61151)
	(row_to_value): Cons the value in reverse, to avoid the Fnreverse
	call.  Patch by Helmut Eller <eller.helmut@gmail.com>.
	(Bug#61165)

2023-02-02  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit_predicate_match): Match node text against regexp without consing

	* src/treesit.c (treesit_predicate_match): Match node text against
	regexp without creating a new string object (bug#60953).

	* src/search.c (search_buffer): Make not static.
	Delete declaration near the beginning of the file.

	* src/lisp.h: Declare it here.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--builtin-method-p):
	Remove function.
	(ruby-ts--font-lock-settings): Use the regexp with :match directly.

2023-02-02  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of gdb-mi's dedicated windows

	* doc/emacs/building.texi (Other GDB Buffers): Describe the I/O
	buffer and commands to show individual specialized windows.
	Improve indexing.

2023-02-02  Kévin Le Gouguec  <kevin.legouguec@gmail.com>

	Avoid spurious pause in kill-ring-save (Bug#60841)

	'indicate-copied-region' checks whether the region is "highlighted"
	and if not, briefly moves point to mark to give a visual cue of the
	extent of text that was saved to the kill ring.

	The region is considered "highlighted" if (a) it is active and (b) its
	face specifies a :background.  That latter condition does not account
	for the multiple ways in which the face can make the region "visually
	distinct" from the default face, so switch to the more extensive
	predicate face-differs-from-default-p.

	The patch also fixes a couple of issues with the predicate's
	implementation, and introduces a new user option in case anyone
	happened to enjoy unconditional blinking.

	* lisp/faces.el (face-differs-from-default-p): Filter out :extend; add
	rationale for the attributes we ignore.
	* lisp/simple.el (copy-region-blink-predicate): Add option to let
	users explicitly opt into or out of blinking point and mark.
	(region-indistinguishable-p): New function to detect
	"if there is currently no active region highlighting", leveraging
	face-differs-from-default-p.
	(indicate-copied-region): Use it.
	* src/xfaces.c (merge_face_ref): Allow :stipple to be nil, since it is
	a documented valid value for that attribute.
	* etc/NEWS: Announce user option.

2023-02-02  Eli Zaretskii  <eliz@gnu.org>

	Change the default of 'treesit-defun-tactic' for 'c-ts-mode'

	* lisp/progmodes/c-ts-mode.el (c-ts-mode): Set
	'treesit-defun-tactic' as appropriate for C.  (Bug#61208)

2023-02-02  Eli Zaretskii  <eliz@gnu.org>  (tiny change)

	Fix docstring fontification of CL's 'defstruct'

	* lisp/emacs-lisp/lisp-mode.el (defstruct): Set 'doc-string'
	property.  Patch by Nicolas Martyanoff <nicolas@n16f.net>.

2023-02-02  Eli Zaretskii  <eliz@gnu.org>

	Teach 'hs-minor-mode' about tree-sitter based modes

	* lisp/progmodes/hideshow.el (hs-special-modes-alist): Teach
	'hs-minor-mode' about tree-sitter based modes.  (Bug#61232)

2023-02-02  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'repeat-mode' and related variables

	* lisp/bindings.el (next-error-repeat-map)
	(page-navigation-repeat-map, undo-repeat-map):
	* lisp/tab-bar.el (tab-bar-switch-repeat-map)
	(tab-bar-move-repeat-map):
	* lisp/window.el (other-window-repeat-map)
	(resize-window-repeat-map): Mention repeatable commands in the doc
	strings.
	* lisp/repeat.el (repeat-exit-timeout, repeat-check-key)
	(repeat-echo-function, repeat-mode, repeat-check-key)
	(repeat-check-map, repeat-echo-message-string)
	(repeat-echo-message, repeat-echo-mode-line)
	(describe-repeat-maps): Improve wording of doc strings.
	(describe-repeat-maps): Improve wording of the heading line.
	(Bug#61183)

	* doc/emacs/basic.texi (Repeating): Clarify and improve wording of
	'repeat-mode' documentation.

2023-02-01  Nicolas Martyanoff  <nicolas@n16f.net>

	(eshell--complete-commands-list): Fix regression in fix to bug#48995

	Copyright-Paperwork-Exempt: Yes

	* lisp/eshell/em-cmpl.el (eshell--complete-commands-list):
	Fix misuse of `completion-table-dynamic` when completing a file name.

2023-02-01  Juri Linkov  <juri@linkov.net>

	* doc/emacs/basic.texi (Repeating): Mention describe-repeat-maps (bug#61183).

	* lisp/repeat.el (describe-repeat-maps): Add more explanation to
	the docstring.  Suggested by Robert Pluim <rpluim@gmail.com>.

2023-02-01  Eli Zaretskii  <eliz@gnu.org>

	Unbreak the MS-Windows build

	* src/treesit.c (ts_query_pattern_count) [WINDOWSNT]: Load from
	the library and define as macro.

2023-01-31  Dmitry Gutov  <dgutov@yandex.ru>

	(Ftreesit_query_capture): Cache list of predicates for given pattern index

	* src/treesit.c (Ftreesit_query_capture):
	Cache list of predicates for given pattern index (bug#60953).

2023-01-31  Robert Pluim  <rpluim@gmail.com>

	* lisp/keymap.el (keymap-global-unset): Correct prompt

2023-01-31  Eli Zaretskii  <eliz@gnu.org>

	Fix cursor-in-echo-area on TTY frames

	* src/dispnew.c (update_frame_1): Fix off-by-one error when
	positioning the cursor in the echo-area.  (Bug#61184)

2023-01-30  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-196-gb91f509

2023-01-30  Alan Mackenzie  <acm@muc.de>

	CC Mode: Fix a coding bug in c-make-keywords-re.  This should fix bug #61135

	* lisp/progmodes/cc-defs.el (c-make-keywords-re): Generate "\>" components in
	result regexp when argument ADORN is `appendable'.  This fully fixes a bug
	which was half-fixed on 2019-01-22.

2023-01-30  Juri Linkov  <juri@linkov.net>

	* lisp/isearch.el (isearch-emoji-by-name): Disable derived emoji (bug#60740).

	Let-bind emoji--derived to nil to avoid the subsequent selection
	of derived emoji that fails in transient.el.

2023-01-30  Eli Zaretskii  <eliz@gnu.org>

	Fix keymap inheritance in descendants of 'c-ts-base-mode'

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode-map): Rename from
	'c-ts-mode-map'.
	(c-ts-base-mode): Adjust accordingly.  (Bug#60983)

2023-01-30  Robert Pluim  <rpluim@gmail.com>

	Fix interactive use of `keymap-local-set' and `keymap-global-set'

	* lisp/keymap.el (keymap-global-set, keymap-local-set): Convert the
	read key sequence to a string when called interactively.  Based on a
	patch from Stephen Berman <stephen.berman@gmx.net>.  (Bug#61149)

2023-01-30  Michael Albinus  <michael.albinus@gmx.de>

	Fix password prompt in Tramp (do not merge)

	* lisp/net/tramp.el (tramp-password-prompt-regexp):
	Allow alternative trailing colons.  (Bug#61168)

2023-01-29  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-23-gc45a05

2023-01-29  Eli Zaretskii  <eliz@gnu.org>

	Document tree-sitter features in the user manual

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-map): Bind "C-c .", for
	consistency with CC mode.
	* lisp/treesit.el (treesit-font-lock-level): Doc fix.

	* doc/emacs/programs.texi (C Indent, Custom C Indent): Document
	the indentation features of 'c-ts-mode'.
	(Moving by Defuns): Document 'treesit-defun-tactic'.
	* doc/emacs/files.texi (Visiting): Document
	'treesit-max-buffer-size'.
	* doc/emacs/display.texi (Traditional Font Lock)
	(Parser-based Font Lock): New subsections.
	* doc/emacs/emacs.texi (Top): Update top-level menu.

2023-01-29  Randy Taylor  <dev@rjt.dev>

	Fix dockerfile-ts-mode line continuation indentation (bug#61131)

	Without this rule, line continuations are only indented after entering
	the contents for the line and hitting TAB or RET.

	For example:
	```
	EXPOSE 1 \
	```

	After hitting RET to go to the next line, point would end up at BOL
	instead of lining up with the previous entry, like so:
	```
	EXPOSE 1 \
	2
	```

	The new rule will indent it as so:
	```
	EXPOSE 1 \
	       2
	```

	* lisp/progmodes/dockerfile-ts-mode.el:
	(dockerfile-ts-mode--indent-rules): New rule.
	(dockerfile-ts-mode--line-continuation-p)
	(dockerfile-ts-mode--line-continuation-anchor): New functions.

2023-01-29  Yuan Fu  <casouri@gmail.com>

	Use treesit-subtree-stat to determine treesit--font-lock-fast-mode

	* lisp/treesit.el:
	(treesit--children-covering-range-recurse): Return nil if LIMIT is
	exceeded.
	(treesit--font-lock-fast-mode): Change to a ternary value.
	(treesit-font-lock-fontify-region): Enable fast mode based on the
	result of treesit-subtree-stat.

2023-01-29  Yuan Fu  <casouri@gmail.com>

	Add treesit-subtree-stat

	* src/treesit.c (Ftreesit_subtree_stat): New function.
	* lisp/treesit.el (treesit): Add to shortdoc.

2023-01-29  Yuan Fu  <casouri@gmail.com>

	Move c-ts-mode--statement-offset to c-ts-common.el

	Now it can be used by other C-like languages.

	* lisp/progmodes/c-ts-common.el (c-ts-common-indent-offset):
	(c-ts-common-indent-block-type-regexp):
	(c-ts-common-indent-bracketless-type-regexp): New variables.
	(c-ts-common-statement-offset):
	(c-ts-mode--fix-bracketless-indent):
	(c-ts-mode--close-bracket-offset): New functions.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Change
	c-ts-mode--statement-offset to c-ts-common-statement-offset.
	The (parent-is "if_statement") rules are now handled by (node-is
	"compound_statement").

	(c-ts-mode--statement-offset-post-processr):
	(c-ts-mode--statement-offset):
	(c-ts-mode--fix-bracketless-indent): Move to c-ts-common.el.

	(c-ts-base-mode): Setup c-ts-common stuff.

	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Make the test
	more challenging.

2023-01-29  Yuan Fu  <casouri@gmail.com>

	Fix <> syntax in rust-ts-mode

	Similar to bug#60351, the angle brackets in rust-ts-mode are not
	recognized as pairs when they should be.  This change copies the
	function used by c++-ts-mode and adapts it to rust-ts-mode.

	* lisp/progmodes/rust-ts-mode.el:
	(rust-ts-mode--syntax-propertize): New function.
	(rust-ts-mode): Set up syntax-propertize-function.

2023-01-29  Eli Zaretskii  <eliz@gnu.org>

	Fix spurious errors on Windows when deleting temporary *.eln files

	* lisp/emacs-lisp/comp.el (comp--native-compile): On MS-Windows,
	ignore errors when deleting a temporary .eln file.  (Bug#60996)

2023-01-28  Theodor Thornhill  <theo@thornhill.no>

	Fix java class member without access modifier (bug#61115)

	This

	```
	public class T {
	    @Autowired
	        String a;
	}
	```

	Should be indented as:

	```
	public class T {
	    @Autowired
	    String a;
	}
	````

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Add new
	rule to match edge case of field_declaration indentation.

2023-01-28  Theodor Thornhill  <theo@thornhill.no>

	Make treesit-font-lock-level a defcustom

	* lisp/treesit.el (treesit--font-lock-level-setter): Setter for the
	new defcustom.
	(treesit-font-lock-level): Turn it into a defcustom.

2023-01-28  Theodor Thornhill  <theo@thornhill.no>

	Add c-ts-mode-set-style and :set for c-ts-mode-indent-style

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-style-setter): New
	setter for the indent style defcustom.
	(c-ts-mode-indent-style): Don't quote the values and refer to the
	setter.
	(c-ts-mode-set-style): New command to interactively set the indent
	style.
	(c-ts-mode--get-indent-style): New function renamed from
	'c-ts-mode--set-indent-style'.

2023-01-28  Juri Linkov  <juri@linkov.net>

	Minor documentation improvements for outline-minor-mode (bug#61062)

	* doc/emacs/text.texi (Outline Minor Mode, Outline Minor Mode):
	Add pxrefs to "Icons" and "Outline Visibility".

	* etc/NEWS: Mention outline-minor-mode for two modes.

2023-01-28  Brian Leung  <leungbk@posteo.net>

	python.el: Use correct regexp when enabling python-ts-mode

	* lisp/progmodes/python.el: Use "python[0-9.]*" regexp for
	'interpreter-mode-alist', and not 'auto-mode-alist'.  (Bug#61090)

2023-01-27  Dmitry Gutov  <dgutov@yandex.ru>

	Make project-current not error out inside non-existent dirs

	* lisp/progmodes/project.el (project-try-vc):
	Use condition-case to catch 'file-missing' (bug#61107).

	* test/lisp/progmodes/project-tests.el
	(project-vc-nonexistent-directory-no-error): New test.

2023-01-27  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'shell-command-dont-erase-buffer'

	* doc/emacs/misc.texi (Single Shell):
	* lisp/simple.el (shell-command, shell-command-on-region):
	Document that non-nil value of 'shell-command-dont-erase-buffer'
	affects what is displayed in the echo area after the command.
	(Bug#61100)

2023-01-27  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix errors in fontification of JavaScript import-statements (bug#61083)

	Currently js-ts-mode handles imports with aliases incorrectly. To be
	consistent with how we otherwise do things, we should only highlight
	the variable which is new and/or introduced, in this case "someAlias".

	Attached is a patch which fontifies import-declarations somewhat more
	correctly.

	The following cases have been tested and all fontify properly:

	import gnu from "fsf";              // highlights gnu
	import { gnu2 } from "fsf2";        // highlights gnu2
	import { gnu as gnu3 } from "fsf3"; // highlights gnu3
	import * as gnu4 from "fsf4";       // highlights gnu4

	* lisp/progmodes/js.el (js--treesit-font-lock-settings): Add new
	import_clause rules that adhere to the comment above.

2023-01-27  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix fontification TypeScript of import-statements (bug#61081)

	Currently typescript-ts-mode and tsx-ts-mode handles imports with
	aliases incorrectly.

	Consider the following case:

